<?
/* AgataConnection
 *
 */
class AgataConnection
{
    var $db;         // the connection identifier
    var $traceback;  // a list of transaction errors
    var $level;      // a counter for the transaction level
    
    /***********************************************************/
    /* Opens a new connection
    /***********************************************************/
    function Open($agataConfig)
    {
        $this->agataConfig = $agataConfig;
        echo "\nabrindo em agata";
        $DbUser  = $agataConfig['DbUser'];
        $DbPass  = $agataConfig['DbPass'];
        $DbName  = $agataConfig['DbName'];
        $DbHost  = $agataConfig['DbHost'];
        $DbType  = $agataConfig['DbType'];
        require_once 'classes/DB.php';
        
        $tmp = explode('-', $DbType);
        if (count($tmp) == 2)
        {
            $DriverType = $tmp[0];
            $DbType = $tmp[1];
            
            if ($DriverType == 'odbc')
            $DbType = $DriverType;
        }
        
        $dsn="$DbType://$DbUser:$DbPass@$DbHost/$DbName";
        $this->db = DB::connect($dsn);
        
        if (DB::isError($this->db))
        {
            new Dialog(Cut($this->db->userinfo, 'ERROR:'));
            $this->db = null;
            return false;
        }
        
        return $this->db;
    }

    /***********************************************************/
    /* Execute multiple inserts
    /***********************************************************/
    function InsertAll($pre, $allData)
    {
        $dbh = $this->db;
        $sth = $dbh->prepare($pre);
        $x = $dbh->executeMultiple($sth,$allData);
        if (DB::isError($x))
        {
            new Dialog(Cut($x->userinfo, 'ERROR:'));
            return false;
        }
        return true;
    }

    /***********************************************************/
    /* Executes a short query
    /***********************************************************/
    function ShortQuery()
    {
        $DbType = $this->GetDbType();
        
        if ($DbType=='oci8')
        {
            return 'where rownum=1';
        }
        else
        {
            return 'limit 1';
        }
    }

    /***********************************************************/
    /* Closes the connection
    /***********************************************************/
    function Close()
    {
        if ( $this->db )
        {
            $this->db = null;
        }
    }

    /***********************************************************/
    /* Creates a new query
    /***********************************************************/
    function CreateQuery($sql="")
    {
        $q = &new AgataQuery($this->agataConfig);
        
        $q->conn   = $this->db;
        $q->sql    = $sql;
        $q->result = 0;
        $q->row    = -1;
        $q->DbType = $this->GetDbType();
        $q->Gateway= $this->GetGateway();
        
        if ( $sql != "" )
        {
            $q->Open($this->db);
        }
        
        return $q;
    }

    /***********************************************************/
    /* Load field names from a table
    /***********************************************************/
    function LoadFields($table)
    {
        $DbType = $this->GetDbType();
        $Gateway = $this->GetGateway();
        
        $sql['pgsql']   = "SELECT * FROM $table limit 1";
        $sql['mysql']   = "SELECT * FROM $table limit 1";
        $sql['access']  = "SELECT * FROM $table limit 1";
        $sql['oci8']    = "select column_name from user_tab_columns where table_name='$table'";
        $sql['sybase']  = "SELECT * FROM $table limit 1";
        //$sql['mssql']  = "SELECT COLUMN_NAME AS name FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = '$table' ORDER BY COLUMN_NAME";
        $sql['mssql']   = "SELECT c.name FROM sysobjects o INNER JOIN syscolumns c ON o.id=c.id WHERE o.name = '$table' ORDER BY c.name";
        $sql['fbsql']   = "SELECT * FROM $table limit 1";
        $sql['ibase']   = "select RDB\$FIELD_NAME as name from RDB\$RELATION_FIELDS " .
                          "where RDB\$RELATION_NAME = '$table' order by RDB\$FIELD_NAME ";
        $sql['ifx']     = "select c.colname from systables t, syscolumns c " .
                          "where t.tabid = c.tabid and t.tabname = '$table' order by colname ";
        $sql['db2']     = "select name from sysibm.syscolumns where tbname='$table'";
        
        $sql = $sql[$DbType];
        $Results = $this->db->query($sql);
        if (DB::isError($Results) || (!$Results))
        {
            //$this->ShowError($Results->userinfo, $this->isGui);
            return false;
        }
        
        if (($DbType == "ibase") || ($DbType == "mssql") || ($DbType == "ifx") || ($DbType == "oci8"))
        {
            while ($Row = $Results->fetchRow())
            {
                $strings[] = trim($Row[0]);
            }
        }
        else
        {
            //cdigo teste esse if (para access)
            if ($Gateway == "odbc")
            {
                for ($n=1; $n<=odbc_num_fields($Results->result); $n++)
                {
                    $strings[] = odbc_field_name($Results->result, $n);
                }
                echo "odbc\n";
                var_dump($strings);
            }
            else
            {
                foreach ($Results->TableInfo() as $Result)
                {
                    $strings[] = $Result['name'];
                }
            }
        }
        
        return $strings;
    }

    /***********************************************************/
    /* Load Tables from a database
    /***********************************************************/
    function LoadTables()
    {
        $DbType = $this->GetDbType();
        
        if ($DbType == 'pgsql')
        {
            $fields = $this->LoadFields('pg_tables');
            if (in_array('schemaname',$fields))
            {
                $TableNamesQuery['pgsql']  = "select tablename from pg_tables where " .
                "tablename not like 'pg%' and schemaname<>'information_schema' union " .
                "select viewname from pg_views where viewname not like 'pg%' and ".
                "schemaname<>'information_schema' order by 1";
            }
            else
            {
                $TableNamesQuery['pgsql']  = "select tablename from pg_tables where " .
                "tablename not like 'pg%' union " .
                "select viewname from pg_views where viewname not like 'pg%'".
                "order by 1";
            }
        }
        
        $TableNamesQuery['mysql']  = "SHOW TABLES";
        $TableNamesQuery['oci8']   = "SELECT table_name FROM user_tables";
        $TableNamesQuery['sybase'] = "select name from sysobjects where type = 'U' order by name";
        $TableNamesQuery['mssql']  = "select name from sysobjects where (type = 'U' or type='V') order by name";
        $TableNamesQuery['fbsql']  = "select \"table_name\" from information_schema.tables";
        $TableNamesQuery['ibase']  = "select RDB\$RELATION_NAME from RDB\$RELATIONS where RDB\$SYSTEM_FLAG=0 and RDB\$VIEW_BLR is null order by RDB\$RELATION_NAME";
        $TableNamesQuery['ifx']    = "select tabname from systables where tabid > 99 order by tabname";
        $TableNamesQuery['db2']   = "select name from sysibm.systables where name not like 'SYS%' and type='T'";
        $TableNamesQuery['sqlite'] = "SELECT name FROM sqlite_master WHERE (type = 'table')";
        $TableNamesQuery['access'] = "SELECT Name FROM MSysObjects WHERE Type = 1";
        
        $sql = $TableNamesQuery[$DbType];
        if ($sql)
        {
            $Result = $this->db->query($sql);
            while ($Row = $Result->fetchRow())
            {
                $strings[] = trim($Row[0]);
            }
            return $strings;
        }
        else
        {
            return null;
        }
    }
    
    /***********************************************************/
    /* Get database type
    /***********************************************************/
    function GetDbType()
    {
        // native-pgsql
        // native-mssql
        // odbc-oci8
        // odbc-mssql
        
        $agataConfig = $this->agataConfig;
        $DbType = $agataConfig['DbType'];
        
        $tmp = explode('-', $DbType);
        if (count($tmp) == 2)
        {
            $DbType = $tmp[1];
        }
        
        return $DbType;
    }

    /***********************************************************/
    /* Get Gateway
    /***********************************************************/
    function GetGateway()
    {
        // native-pgsql
        // native-mssql
        // odbc-oci8
        // odbc-mssql
        
        $agataConfig = $this->agataConfig;
        $DbType = $agataConfig['DbType'];
        
        $tmp = explode('-', $DbType);
        if (count($tmp) == 2)
        {
            $Gateway = $tmp[0];
        }
        
        return $Gateway;
        
    }
}
?>