<?
/***********************************************************/
/* Classe que cria Forms de Entrada de Dados               */
/* Linguagem PHP-GTK                                       */
/* Autor: Pablo Dall'Oglio                                 */
/* ltima aterao em 08 Janeiro 2001 por Pablo            */
/***********************************************************/

/***********************************************************/
/* Classe de Dilogo
/***********************************************************/
class FormEntry
{
  var $Form;
  var $InputEntries;
  var $CheckVars;

  /***********************************************************/
  /* Mtodo construtor da classe dilogo
  /***********************************************************/
  function FormEntry($mensagem, $CheckVars, $Closeapp = false, $Status)
  {
    $this->Form = new GtkWindow;
    $this->Form->set_title($mensagem);
    $this->Form->set_border_width(0);
    $this->Form->set_position(GTK_WIN_POS_CENTER);
    $this->Form->set_default_size(460,400);
    $this->Form->connect('key_press_event', array(&$this, 'KeyTest'));
    //$this->Form->set_policy(false, false, false);
    $lenght = 40;

    $this->Form->connect_simple('delete_event', array(&$this, 'Close'), $Closeapp);

    $this->CheckVars = $CheckVars;

    $Sbox = &new GtkHBox(false, 10);
    $Vbox1 = &new GtkVBox(false, 4);
	$Vbox2 = &new GtkVBox(false, 4);

    $this->Form->add($Sbox);
    $Sbox->pack_start($Vbox);
	$scroll = new GtkScrolledWindow;
	$scroll->set_policy(GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	$Sbox->pack_start($scroll);
	$viewport = new GtkViewPort;
	$scroll->add($viewport);
	$hbox_dupla = new GtkHBox;
	$viewport->add($hbox_dupla);
	$hbox_dupla->pack_start($Vbox1);
	$hbox_dupla->pack_start($Vbox2);

    $c = 0;
	$count = count($CheckVars);
    foreach ($CheckVars as $CheckVar)
    {
      $Content = $CheckVar[0];
      $Description = $CheckVar[1];
      $IsPassword = $CheckVar[2];
      $Combo = $CheckVar[3];
	  $i = $Description;
      $box = &new GtkHBox(false, 3);
      $box->show();

	  if ($c>=($count/2))
		  $Vbox2->pack_start($box, false, false);
	  else
		  $Vbox1->pack_start($box, false, false);

	  $this->OldContents[$i] = $Content;
      if ($Combo)
      {
        $this->InputEntries[$i] = &new GtkCombo();
	    $box->pack_start(new Box($this->InputEntries[$i], $Description), false, false, 10);
        $this->InputEntries[$i]->set_popdown_strings($Combo);
        $entry =$this->InputEntries[$i]->entry;
        $entry->set_text($Content);
        $this->InputEntries[$i]->show();
      }
      else
      {
        $this->InputEntries[$i] = &new GtkEntry();
	    $box->pack_start(new EntryBox($this->InputEntries[$i], $lenght, $Description, $Content), false, false, 10);
        if ($IsPassword)
          $this->InputEntries[$i]->set_visibility(false);
        $this->InputEntries[$i]->show();
      }
      $c ++;
    }
	$Vbox1->pack_start(new GtkVBox);
	
	$this->button1 = &new Icone( images . 'ico_ok.xpm',  '  ' . Trans::Translate('Update') . '  ', Trans::Translate('Update'), true);
	$this->button2 = &new Icone( images . 'menu_del.xpm', '  ' . Trans::Translate('Delete') . '  ', Trans::Translate('Delete'), true);
    $this->button1->set_border_width(4);
    $this->button2->set_border_width(4);

	$box = &new GtkHBox(false, 3);
	$box->pack_start($this->button1, false, false, 10);
	$box->pack_start($this->button2, false, false, 10);
	$Vbox2->pack_start($box, false,false);
	$Vbox2->pack_start(new GtkVBox);

    $this->Form->realize();
    $this->Form->show_all();
  }

  function KeyTest($p1)
  {
    if ($p1->keyval == K_ESC)
    {
        //$this->button->clicked();
        $this->Form->hide();
    }
  }

  /*******************************************************************************/
  /* Cria Caixa com botes para consulta
  /*******************************************************************************/
  function Show()
  {
    $this->Form->Show();
  }

  /***********************************************************/
  /* Funo que fecha dilogo
  /***********************************************************/
  function Close($widget, $Closeapp=false)
  {
    if ($Closeapp)
    {
      Gtk::main_quit();
      return true;
    }
    else
    {
      $this->Form->hide();
      return true;
    }
  }
}
?>