<?
/***********************************************************/
/* MenuItem class, a wrapper for GtkMenuItem
/* by Pablo Dall'Oglio 2001-2006
/***********************************************************/

class MyNormalMenuItem extends GtkMenuItem
{   
    
    /***********************************************************/
    /* Constructor Method
    /***********************************************************/
	
    function MyNormalMenuItem($img, $label, $function, $param = null)
	{
		parent::__construct($label);
        $child = $this->child;

        parent::remove($child);
        
        if($img)
                {
                   
                   $pixmap= GtkImage::new_from_file($img);
                }  
        $hbox = new GtkHBox;
        $hbox->pack_start($pixmap, false, false, 5);
        $hbox->pack_start($child, true, true);
        parent::add($hbox);
        
        if ($function)
        {
            parent::connect_simple('activate', $function, $param);
        }
		//parent::lock_accelerators();
	}
}

/***********************************************************/
/* MenuItem class for Control Key actions
/* by Pablo Dall'Oglio 2001-2006
/***********************************************************/
class MyControlMenuItem extends GtkMenuItem
{
    /***********************************************************/
    /* Constructor Method
    /* $img = endereo da imagem
    /***********************************************************/
	function __construct($img, $label, $underscore, $accelgroup, $function, $param = null)
	{
		
        parent::__construct($label);
        $child = $this->child;

        parent::remove($child);
        if($img)
        {
            $pixmap = GtkImage::new_from_file($img);
        }
        $hbox = new GtkHBox;
        $hbox->pack_start($pixmap, false, false, 5);
        $hbox->pack_start($child, true, true);
        parent::add($hbox);
        if (!empty($underscore))
        {
            if (strlen($label)!=(strlen($underscore)-1))
                $parse = new GtkLabel;
            else
                $parse = $child;

            $Subitem_key = $parse->parse_uline($underscore);

		parent::add_accelerator("activate", $accelgroup, $Subitem_key, GDK_CONTROL_MASK, ($underscore)? 1:0);
        }
        if ($function)
        {
            if ($param)
            {
                parent::connect_simple('activate', $function, $param);
            }
            else
            {
                parent::connect_simple('activate', $function);
            }
        }
		//parent::lock_accelerators();
	}
}

/***********************************************************/
/* MenuItem class for CheckItems
/* by Pablo Dall'Oglio 2001-2006
/***********************************************************/
class MyCheckMenuItem extends GtkCheckMenuItem
{
    /***********************************************************/
    /* Constructor Method
    /***********************************************************/
    //MyCheckMenuItem($Pixmaps['menu_view'],  _a('View files'),'_I',  $accelgroup, array(&$this, 'FireTog1'));
	function __construct($img, $label, $underscore, $accelgroup, $function)
	{
		parent::__construct($label);
        $child = $this->child;
        parent::remove($child);
        
        if($img)
                {
                    $pixmap = GtkImage::new_from_file($img);
                }
        //$pixmap = new GtkPixmap($img[0], $img[1]);

        $hbox = new GtkHBox;
        $hbox->pack_start($pixmap, false, false, 5);
        $hbox->pack_start($child, true, true);
        parent::add($hbox);

		if (strlen($label)!=(strlen($underscore)-1))
			$parse = new GtkLabel;
		else
			$parse = $child;

		$Subitem_key = $parse->parse_uline($underscore);


		parent::add_accelerator("activate", $accelgroup, $Subitem_key, GDK_MOD1_MASK, ($underscore)? 1:0);
		parent::connect_simple('activate', $function);
		//parent::lock_accelerators();
	}
}

/***********************************************************/
/* MenuItem class for ALT Key actions
/* by Pablo Dall'Oglio 2001-2006
/***********************************************************/
class MyAltMenuItem extends GtkMenuItem
{
    /***********************************************************/
    /* Constructor Method
    /***********************************************************/
	function __construct($label, $underscore, $accelgroup)
	{
		parent::__construct($label);

		if (strlen($label)!=(strlen($underscore)-1))
			$label = new GtkLabel;
		else
			$label = $this->child;

		$Subitem_key = $label->parse_uline($underscore);
		parent::add_accelerator("activate_item", $accelgroup, $Subitem_key, GDK_MOD1_MASK, 0);
	}
}

/***********************************************************/
/* MenuItem class for Simple function actions
/* by Pablo Dall'Oglio 2001-2006
/***********************************************************/
class MyFunctionMenuItem extends GtkMenuItem
{
    /***********************************************************/
    /* Constructor Method
    /***********************************************************/
	function __construct($img, $label, $key, $accelgroup, $function, $param = null)
	{
		parent::__construct($label);
        $child = $this->child;
        parent::remove($child);
        if($img)
                {
                    $pixmap = GtkImage::new_from_file($img);
                }

        $hbox = new GtkHBox;
        $hbox->pack_start($pixmap, false, false, 5);
        $hbox->pack_start($child, true, true);
        if (is_integer($key))
        {
            parent::add_accelerator("activate", $accelgroup, $key, 0, 1);
        }
        else
        {
            $hbox->pack_start(new GtkLabel($key), false, false);
        }
        GtkMenuItem::add($hbox);
        if ($function)
        {
            if ($param)
            {
                parent::connect_simple('activate', $function, $param);
            }
            else
            {
                parent::connect_simple('activate', $function);
            }
        }
	}
}
?>