<?
// +----------------------------------------------------------------------+
// | Licensed under GPL: www.fsf.org for further details                  |
// |                                                                      |
// +----------------------------------------------------------------------+
// | Abstract: Tulip Editor                                               |
// |                                                                      |
// | Created by Pablo Dall'Oglio (pablo@php.net)                          |
// | Rename: PhpGtkEditor.class                                           |
// | Converted Php-Gtk2b in abril,20,2008                                 |
// | Author: Helder Mauricio Gomes Ferreira (helder.mauricio@hotmail.com  |
// +----------------------------------------------------------------------+



/**
 * Class defining the main tulip window (interface)
 */
class PhpGtkEditor
{
	/**
	 * Class constructor. This constructor instanciates and displays the
	 * main window when called. Then the window remains open and answers
	 * all events until close() (onClose()) event.
	 *
	 * It still contains some hardcoded elements as the size of the
	 * window or the window title (which is bad).
	 * Also, if a php-gtk function could maximize the window, that
	 * could enhance the display.
	 *
	 * Inside this method are also the file explorer and the edition screen
	 * definitions.
	 */
	 
	function PhpGtkEditor($Theme, $Language, $Profile, $argv)
	{
        global $Pixmaps;

		//$width = gdk::screen_width();
		//$height= gdk::screen_height();
		if (strtoupper(substr(PHP_OS, 0, 3)) != 'WIN')
		{
			//$height -= 80;
			//$width -= 8;
		}
		$this->janela =& new GtkWindow(GTK_WINDOW_TOPLEVEL);
		$this->janela->connect('delete-event', array(&$this, 'onClose'));
		$this->janela->set_title('PhpGtkEditor');
		//$this->janela->fullscreen();//set_default_size($width, $height);
		$this->janela->set_uposition(0,0);
        $pixbuf = GdkPixbuf::new_from_file('icon.xpm');
        $this->janela->set_icon($pixbuf);
		$this->janela->realize();
		$vbox = new GtkVBox;
		$this->janela->add($vbox);
        
        $this->Theme = $Theme;
        $this->Language = $Language;
        $this->Profile = ($Profile ? $Profile : 'default');

		/*******************************************
			EXPLORER SECTION
		*******************************************/
        $dir=images;
        $Pixmaps['menu_close']    =  "$dir".'menu_close.xpm';
        $Pixmaps['menu_logout']   =  "$dir".'menu_logout.xpm';
        $Pixmaps['menu_copy']     =  "$dir".'menu_copy.xpm';
        $Pixmaps['menu_cut']      =  "$dir".'menu_cut.xpm';
        $Pixmaps['menu_caret']    =  "$dir".'menu_caret.xpm';
        $Pixmaps['menu_wrap']     =  "$dir".'menu_wrap.xpm';

        $Pixmaps['menu_selall']   =  "$dir".'menu_selall.xpm';
        $Pixmaps['menu_selmode']  =  "$dir".'menu_selmode.xpm';
        $Pixmaps['menu_eol']      =  "$dir".'menu_eol.xpm';
        $Pixmaps['menu_config']   =  "$dir".'menu_config.xpm';
        $Pixmaps['menu_del']      =  "$dir".'menu_del.xpm';
        $Pixmaps['menu_indent']   =  "$dir".'menu_indent.xpm';
        $Pixmaps['menu_unindent'] =  "$dir".'menu_unindent.xpm';
        $Pixmaps['menu_goline']   =  "$dir".'menu_goline.xpm';
        $Pixmaps['menu_login']    =  "$dir".'menu_login.xpm';
        $Pixmaps['menu_new']      =  "$dir".'menu_new.xpm';
        $Pixmaps['menu_open']     =  "$dir".'menu_open.xpm';
        $Pixmaps['menu_recent']   =  "$dir".'menu_recent.xpm';
        $Pixmaps['menu_paste']    =  "$dir".'menu_paste.xpm';
        $Pixmaps['menu_tab1']     =  "$dir".'menu_tab1.xpm';
        $Pixmaps['menu_tab2']     =  "$dir".'menu_tab2.xpm';
        $Pixmaps['menu_quit']     =  "$dir".'menu_quit.xpm';
        $Pixmaps['menu_redo']     =  "$dir".'menu_redo.xpm';
        $Pixmaps['menu_saveas']   =  "$dir".'menu_saveas.xpm';
        $Pixmaps['menu_save']     =  "$dir".'menu_save.xpm';
        $Pixmaps['menu_search']   =  "$dir".'menu_search.xpm';
        $Pixmaps['menu_search+']  =  "$dir".'menu_search+.xpm';
        $Pixmaps['menu_replace']  =  "$dir".'menu_replace.xpm';
        $Pixmaps['menu_undo']     =  "$dir".'menu_undo.xpm';
        $Pixmaps['menu_up']       =  "$dir".'menu_up.xpm';
        $Pixmaps['menu_help']     =  "$dir".'menu_help.xpm';
        $Pixmaps['menu_view']     =  "$dir".'menu_view.xpm';
        $Pixmaps['menu_desktop']  =  "$dir".'menu_desktop.xpm';
        $Pixmaps['menu_reload']   =  "$dir".'ico_reload.xpm';
        $Pixmaps['menu_docs']     =  "$dir".'menu_docs.xpm';
        $Pixmaps['menu_expand']   =  "$dir".'menu_expand.xpm';
        $Pixmaps['menu_collapse'] =  "$dir".'menu_collapse.xpm';
        $Pixmaps['menu_schemas']  =  "$dir".'ico_schemas.xpm';
        $Pixmaps['menu_lock']     =  "$dir".'menu_lock.xpm';
        $Pixmaps['menu_unlock']   =  "$dir".'menu_unlock.xpm';
    

		$Pixmaps['csv'] =  "$dir".'ico_csv.xpm';
        $Pixmaps['sxw'] =  "$dir".'ico_sxw.xpm';
		$Pixmaps['php'] =  "$dir".'ico_php.xpm';
        $Pixmaps['class']= "$dir".'ico_class.xpm';
		$Pixmaps['txt'] =  "$dir".'ico_txt.xpm';
        $Pixmaps['met'] =  "$dir".'ico_met.xpm';
        $Pixmaps['pro'] =  "$dir".'ico_pro.xpm';
		$Pixmaps['doc'] =  "$dir".'ico_doc.xpm';
		$Pixmaps['dia'] =  "$dir".'ico_dia.xpm';
		$Pixmaps['png'] =  "$dir".'ico_png.xpm';
		$Pixmaps['jpg'] =  "$dir".'ico_jpg.xpm';
		$Pixmaps['gif'] =  "$dir".'ico_gif.xpm';
		$Pixmaps['cdr'] =  "$dir".'ico_cdr.xpm';
		$Pixmaps['xpm'] =  "$dir".'ico_xpm.xpm';
		$Pixmaps['pdf'] =  "$dir".'ico_pdf.xpm';
		$Pixmaps['sql'] =  "$dir".'ico_sql.xpm';
		$Pixmaps['xml'] =  "$dir".'ico_xml.xpm';
		$Pixmaps['zip'] =  "$dir".'ico_zip.xpm';
		$Pixmaps['html'] = "$dir".'ico_html.xpm';
		$Pixmaps['home'] = "$dir".'ico_home.xpm';
		$Pixmaps['ps'] =   "$dir".'ico_ps.xpm';
		$Pixmaps['db'] =   "$dir".'ico_db.xpm';
        $Pixmaps['cvs'] =  "$dir".'ico_cvs.xpm';
		$Pixmaps['table']= "$dir".'ico_table.xpm';
		$Pixmaps['field']= "$dir".'ico_field.xpm';
		$Pixmaps['folder1']="$dir".'ico_folder1.xpm';
		$Pixmaps['folder2']="$dir".'ico_folder2.xpm';
		$Pixmaps['generic']="$dir".'ico_generic.xpm';
        $Pixmaps['projects']="$dir".'projects.xpm';
        $Pixmaps['docs']    ="$dir".'docs.xpm';
        $Pixmaps['cor']     ="$dir".'cor.xpm';
        $Pixmaps['font']    ="$dir".'font.xpm';
        $Pixmaps['file']    ="$dir".'filesel.xpm';
        $Pixmaps['icon']    ="$dir".'icon.xpm';
        $Pixmaps['checkout']="$dir".'ico_checkout.xpm';
        $Pixmaps['login'] =  "$dir".'ico_login.xpm';
        $Pixmaps['logout'] = "$dir".'ico_logout.xpm';
        $Pixmaps['remote'] = "$dir".'ico_remote.xpm';

        $Pixmaps['file_open']="$dir".'fileopen.xpm';
        $Pixmaps['file_del'] ="$dir".'filedelete.xpm';
        $Pixmaps['folder_new']="$dir".'foldernew.xpm';


        $gdkwindow = $this->janela->window;
        $pixbuf = GdkPixbuf::new_from_file("$dir".'icon.xpm');
       //$gdkwindow->set_icon($Pixmaps['icon'][0]);
       //$gdkwindow->set_icon($pixbuf);//no funcionou
       
		$hbox1 = new GtkHBox;
		$linecmd = new GtkHBox;
		$hbox2 = new GtkHBox;
		$hbox3 = new GtkHBox;
		$hbox2->set_border_width(4);
		$hbox3->set_border_width(4);
		$linecmd->set_border_width(4);
		$hbox1->pack_start($this->Menu());

		$buttons = new GtkHandleBox;
		$hboxbuttons = new GtkHBox;
		$buttons->add($hboxbuttons);
        //linha abrir procurar
		$stub = new GtkHBox;
		
		$cmdentry = new GtkEntry;
		$cmdentry->connect_simple('key_press_event', array(&$this, 'kOpen'), $cmdentry);
		$cmdbutton = new GtkButton(_a('Open'));
		$cmdbutton->connect_simple('clicked', array(&$this, 'AtalhoAbrir'), $cmdentry);
		$cmdfind = new GtkEntry;
		$cmdfind->connect_simple('key_press_event', array(&$this, 'kFind'), $cmdfind);
		$cmdbutton2 = new GtkButton(_a('Find'));
		$cmdbutton2->connect_simple('clicked', array(&$this, 'Encontra'), $cmdfind);

		$linecmd->pack_start($cmdentry, false, false);
		$linecmd->pack_start($cmdbutton, false, false);
		$linecmd->pack_start($cmdfind, false, false);
		$linecmd->pack_start($cmdbutton2, false, false);
		$linecmd->pack_start($stub, true, true);
        //criando os botoes novo abrir salvar salvar como 
        //function Icone($imagem, $texto, $dica ,$action)
       //__construct('xpm/filenew.xpm', ' Novo ', 'Novo Arquivo', Array)
                         //   Icone($oWindow, $imagem, $texto, $dica, $ishorizontal = false
		$novo   = new Icone( '.'.bar.images . 'filenew.xpm',       ' '._a('New').' ',     _a('New File'));
		$abrir  = new Icone( images . 'fileopen2.png',      ' '._a('Open').' ',    _a('Open File'));
		$salvar = new Icone( images . 'filesave.xpm',      ' '._a('Save').' ',    _a('Save File'));
		$salvarc= new Icone( images . 'filesaveas.xpm',    ' '._a('Save as').' ', _a('Save File as'));

        $upload  = new Icone( images . 'ico_up.xpm',      ' '._a('Upload').' ',    'FTP::' . _a('Upload'));
        $download= new Icone( images . 'ico_down.xpm',    ' '._a('Download').' ',  'FTP::' . _a('Download'));

		$projs  = new Icone( images . 'ico_proj.xpm',      ' '._a('Projects').' ',_a('Setup Projects'));
		$high   = new Icone( images . 'highlight.xpm',     ' '._a('Highlight').' ',_a('Create Documentation'));
        $test   = new Icone( images . 'filetest.xpm',      ' '._a('Debug').' ',   _a('Debug'));
        $report = new Icone( images . 'report.xpm',        ' '._a('Report').' ',  _a('Report'));
        $this->view =$view = new ToggleIcone( images . 'ico_view.xpm',' '._a('View files').' ',_a('View File Tree'));
        //$this->view = $view;//utilizado para setar o menu ligar ou no os arquivos
		$novo->connect_simple('clicked', array(&$this, 'AppendPage'));
		$abrir->connect_simple('clicked', array(&$this, 'PreAbrir'));
		$salvar->connect_simple('clicked', array(&$this, 'Save'));
		$salvarc->connect_simple('clicked', array(&$this, 'DialogSaveAs'));

        $upload->connect_simple('clicked', array(&$this, 'FTPUpload'));
        $download->connect_simple('clicked', array(&$this, 'FTPDownload'));
		$projs->connect_simple('clicked', array(&$this, 'Projects'));
		$view->connect_simple('toggled', array(&$this, 'FireTog2'));
		$high->connect_simple('clicked', array(&$this, 'Highlight'));
        $test->connect_simple('clicked', array(&$this, 'TestFile'));
        $report->connect_simple('clicked', array(&$this, 'Report'));
		
        $array_buttons = array($novo, $abrir, $salvar, $salvarc, $upload, $download, $projs, $view, $high, $test, $report);

		foreach ($array_buttons as $button)
		{
			$button->set_relief(Gtk::RELIEF_NONE);
			$button->set_border_width(2);
		}

		$hboxbuttons->pack_start($novo,   false, false);
		$hboxbuttons->pack_start($abrir,  false, false);
		$hboxbuttons->pack_start($salvar, false, false);
		$hboxbuttons->pack_start($salvarc, false, false);
		$hboxbuttons->pack_start(new GtkVSeparator, false, false);
        $hboxbuttons->pack_start($upload,   false, false);
        $hboxbuttons->pack_start($download,   false, false);
		$hboxbuttons->pack_start(new GtkVSeparator, false, false);

		$hboxbuttons->pack_start(new GtkVSeparator, false, false);
		$hboxbuttons->pack_start($projs,   false, false);
		$hboxbuttons->pack_start($high,   false, false);
		$hboxbuttons->pack_start($view,   false, false);
        $hboxbuttons->pack_start($test,   false, false);
        $hboxbuttons->pack_start($report,   false, false);

		$this->status = new GtkStatusBar;
		$hbox3->pack_start($this->status);

		$vbox->pack_start($hbox1, false, false);   //linha menu
		$vbox->pack_start($buttons, false, false); //linha botoes menu
		$vbox->pack_start($linecmd, false, false); //linha abrir procurar
		$vbox->pack_start($hbox2);//onde fica a lista de arquivos e o editor
		$vbox->pack_start($hbox3, false, false);//linha de status inferior a janela onde aparece o numero da coluna
		
        echo "\nLoading File Explorer...\n";
        
        $this->arquivos = &new FileTree;
        $this->remote = &new RemoteTree;
        $this->doc = &new FileTree;
        $this->cvs = &new CVSTree;//http://www.google.com/talk/intl/pt-BR/otherclients.html 
        $this->db  = &new DBTree;
        
        //$this->doc->abreDiretorio('doc', null, 'php-doc', null);
        $caminho="/home/helder/PhpGtkEditor/doc/gtk-doc";
        $caminho2="/home/helder/PhpGtkEditor/doc/php-doc";
        $this->doc->AddHome($caminho,'GTK-DOC');
        $this->doc->AddHome($caminho2,'PHP-DOC');
        $this->doc->setCallBack(array(&$this,'Abrir'));
       
		$handlerdoc = &new TreeHandler($this->doc, array(0 => 'Open'));
		$ItemOpenDoc = $handlerdoc->OpenAction;
		$ItemOpenDoc->connect_simple('clicked', array(&$this, 'OpenTree'));
        
        $handlercvs = &new TreeHandler($this->cvs, array(0 => 'Open'));
        $handlerdb  = &new TreeHandler($this->db,  array(0 => 'Open'));

       
    //$caminho="/home/helder/PhpGtkEditor";//define o diretorio inicial da arvore de arquivos
    //$caminho2="/home/helder/B2Stok";
	//$this->arquivos->AddHome($caminho,'PhpGtkEditor');//abreDiretorio($caminho);
    //$this->arquivos->AddHome($caminho2,'B2Stok');//abreDiretorio($caminho2);
    $this->arquivos->setCallBack(array(&$this,'Abrir'));//funcao a ser chamada ao clicar sobre um arquivo
        
        //$this->arquivos->set_column_width(0,400);
  /*  $handler = &new TreeHandler($this->arquivos, array(0 => 'Open'));
		$ItemOpen = $handler->OpenAction;
		$ItemOpen->connect_object('clicked', array(&$this, 'OpenTree'));    
    */    
	$handler = &new TreeHandler($this->arquivos, array(0 => 'Open'),false);
	$ItemOpen = $handler->OpenAction;
	$ItemOpen->connect_simple('clicked', array(&$this, 'OpenTree'));
       
        
        
        //$this->remote->set_column_width(0,400);
        $scrollremote = new GtkScrolledWindow;
        $scrollremote->add($this->remote);

        $this->ReadProfiles();
        $this->ReloadTree();
        
        $botao = $this->arquivos->BotaoOk;
		$botao->connect_simple('clicked', array(&$this,'OpenTree'));

		$botao = $this->remote->BotaoOk;
		$botao->connect_simple('clicked', array(&$this,'OpenRemote'));
        $this->remote->setCallBack(array(&$this,'OpenRemote'));

		$botao = $this->doc->BotaoOk;
		$botao->connect_simple('clicked', array(&$this,'OpenTree'), true);

        $botaoCVS = $this->cvs->Botao;
        $botaoCVS->connect_simple('clicked', array(&$this, 'CVSVerify'));

		$botao2 = $this->db->Botao;
		$botao2->connect_simple('clicked', array(&$this,'AbrirTable'));

		
		$this->paned = new GtkHPaned;
		$hbox2->pack_start($this->paned, true, true);//coloca um painel com um separador movel 
        /*************************************************
			EDITOR SECTION + BUTTONS AROUND FILE EXPLORER
		**************************************************/
		$this->notebook = new GtkNotebook();//cria o notebook do editor
		$this->notebook->set_scrollable(true);
        
        if (!$this->OpenWorkspace())
        { 
            $this->AppendPage();
        }
		$this->AltKeys();
        foreach ($argv as $key => $file)
        {
            if ($key > 0)
            {
                $this->LoadFile($file);
            }
        }
        //__construct( $imagem, $texto, $dica ,$action)
        //$this->janela->window,
		$botao = new Icone( images . 'ico_reload.xpm', _a('Reload'), _a('Reload'), true);
		$botao->connect_simple('clicked', array(&$this, 'ReloadTree'));
        $botao->set_relief(GTK_RELIEF_NONE);

		$boxbotao = new GtkHBox;
		$boxbotao->pack_start(new GtkHBox);
		$boxbotao->pack_start($botao);
		$boxbotao->pack_start(new GtkHBox);

        $notefiles = &new GtkNotebook();
        //conteudo da pagina de arquivos
        $treebotao=$handler->CreateToolBar();//cria os botoes de novo abrir delete abaixo dos arquivos
		$vbox = new GtkVBox;//cria um boxvertical
		$vbox->pack_start($boxbotao, false, false);//inclui um botao no vboxvertical
        
        $vbox->pack_start($handler, true, true);//coloca a lista de arquivos abaixo do botao
        $vbox->pack_start($treebotao, false, false);        
//criar aqui a linha de botoes para abrir deletar e novo 
        $vbox1 = new GtkVBox;//cria um boxvertical
		$vbox1->pack_start($boxbotao, false, false);//inclui um botao no vboxvertical
        $vbox1->pack_start($this->doc, true, true);
        
        $label1 = new GtkHBox;
        $label1->pack_start(GtkImage::new_from_file($Pixmaps['projects']));
        $label1->show_all();

        $label2 = new GtkHBox;
        $label2->pack_start(GtkImage::new_from_file($Pixmaps['remote']));
        $label2->show_all();

        $label3 = new GtkHBox;
        $label3->pack_start(GtkImage::new_from_file($Pixmaps['docs']));
        $label3->show_all();
        
        $label4 = new GtkHBox;
        $label4->pack_start(GtkImage::new_from_file($Pixmaps['cvs']));
        $label4->show_all();

        $label5 = new GtkHBox;
        $label5->pack_start(GtkImage::new_from_file($Pixmaps['db']));
        $label5->show_all();

        $notefiles->append_page($vbox,         $label1);
        $notefiles->append_page($scrollremote, $label2);
        $notefiles->append_page($handlerdoc,   $label3);
        $notefiles->append_page($handlercvs,   $label4);
        $notefiles->append_page($handlerdb,    $label5);

		$this->paned->add1($notefiles);//coloca o notebook de files no lado esquerdo
		$this->paned->add2($this->notebook);//coloca o editor no lado direito do paned
        
		
        
		$ico_box = new GtkVBox;
		$del = new IconeImg($this->janela->window, images . 'ico_del.xpm', _a('Close file'));
		$del->connect_simple('clicked', array(&$this, 'Fechar'));
		$del->set_relief(Gtk::RELIEF_NONE);
		$ico_box->pack_start($del, false, false);
		$hbox2->pack_start($ico_box, false, false);
      
        $this->OpenRecent();
        $this->SetMenuRecent();
		$this->Toggled = false;
		$this->SubitemC->set_active(true);
        $this->SubitemD->set_active(true);
        $this->SubitemE->set_active(false);

		$this->janela->show_all();
        $notefiles->set_current_page(0);
	}

	/**
	 * Method adding accelerators (shortcuts?)?
	 */
	function AltKeys()
	{
		$accelgroup = $this->accel;
		$label = new GtkLabel;
		for ($n=1; $n<=9; $n ++)
		{
			$Subitem_key = $label->parse_uline("_$n");
			$button = new GtkButton;
			//$button->add_accelerator("clicked", $accelgroup, $Subitem_key, GDK_MOD1_MASK, 0);
			//$button->connect_simple('clicked', array(&$this, 'OnAlt'), $n);
			//$button->lock_accelerators();
		}

        // CTRL+PG_UP and CTRL+PGDOWN shortcuts
        $button = new GtkButton;
       // $button->add_accelerator("clicked", $accelgroup, 65365, GDK_CONTROL_MASK, 0);
      // $button->connect_simple('clicked', array(&$this, 'onCtrlUp'));
      //  $button->lock_accelerators();
        
        $button = new GtkButton;
      // $button->add_accelerator("clicked", $accelgroup, 65366, GDK_CONTROL_MASK, 0);
      // $button->connect_simple('clicked', array(&$this, 'onCtrlDown'));
      // $button->lock_accelerators();
	}

	/**
	 * Method that changes the page to up
	 */
    function onCtrlUp()
    {
        $current = $this->notebook->get_current_page();
        $this->notebook->set_page($current -1);
        $this->onAlt($current);
    }

	/**
	 * Method that changes the page to down
	 */
    function onCtrlDown()
    {
        $current = $this->notebook->get_current_page();
        $next = $this->notebook->get_nth_page($current +1);
        if ($next)
        {
            $this->notebook->set_page($current +1);
            $this->onAlt($current +2);
        }
        else
        {
            $this->notebook->set_page(0);
            $this->onAlt(1);
        }
    }

	/**
	 * Method answering alt+number events and getting to the page in the
	 * edition screen corresponding to the parameter (number)
	 *
	 * @param	int	The page number we want to go to
	 *
	 */
	function OnAlt($n)
	{
		$this->notebook->set_current_page($n-1);
		$scintilla = $this->GetScintilla();
        if ($scintilla)
        {
            $scintilla->grab_focus();
            $this->Refresh($scintilla);
            $file = $this->GetFileName();
            if ($file)
            {
                $this->janela->set_title('PhpGtkEditor - ' . $file);
            }
            else
            {
                $this->janela->set_title('PhpGtkEditor');
            }
        }
	}

    /**
	 * Method generating the scrolling-down menu bar.
	 *
	 * Accelerators might need to be redefined based on the language used.
	 *
	 * @return object Menu bar pointer.
	 */
	function Menu()
	{
        global $Pixmaps;

		$this->accel = $accelgroup = &new GtkAccelGroup();
		$this->janela->add_accel_group($accelgroup);

		$MenuBar = &new GtkMenuBar;
                                //($label, $underscore, $accelgroup)
		$Menu = new MyAltMenuItem(_a('File'), '_' . _a('File'), $accelgroup);
                                        //($img, $label, $underscore, $accelgroup, $function, $param = null)
		$Subitem1 = new MyControlMenuItem($Pixmaps['menu_new'],    _a('New'),    '_' .  _a('New'),   $accelgroup, array(&$this, 'AppendPage'));
		$Subitem2 = new MyControlMenuItem($Pixmaps['menu_open'],   _a('Open'),   '_O',  $accelgroup, array(&$this, 'PreAbrir'));
        $Subitem2_= new MyControlMenuItem($Pixmaps['menu_recent'], _a('Open Recent'), '', $accelgroup, null);
		$Subitem3 = new MyControlMenuItem($Pixmaps['menu_save'],   _a('Save'),   '_S' .  _a('Save'), $accelgroup, array(&$this, 'Save'));
		$Subitem4 = new MyControlMenuItem($Pixmaps['menu_saveas'], _a('Save as'), '', $accelgroup, array(&$this, 'DialogSaveAs'));
        $Subitem5 = new MyControlMenuItem($Pixmaps['menu_desktop'],_a('Save Workspace'), '',$accelgroup, array(&$this, 'SaveWork'));
        $Subitem50= new MyControlMenuItem($Pixmaps['menu_config'], _a('Preferences'), '_P',$accelgroup, array(&$this, 'Preferences'));
        $Subitem51= new MyControlMenuItem($Pixmaps['menu_reload'], _a('Reload'), '_E',$accelgroup, array(&$this, 'ReloadTree'));
        $Subitem6 = &new GtkMenuItem;
		$Subitem7 = new MyControlMenuItem($Pixmaps['menu_close'], _a('Close'),  '_W',       $accelgroup, array(&$this, 'Fechar'));
		$Subitem8 = new MyControlMenuItem($Pixmaps['menu_quit'], _a('Quit'),   '_Q',      $accelgroup, array(&$this, 'onClose'));

        $this->MenuRecent = $Subitem2_;

		$SubMenu = &new GtkMenu;
		$SubMenu->append($Subitem1);
		$SubMenu->append($Subitem2);
        $SubMenu->append($Subitem2_);
		$SubMenu->append($Subitem3);
		$SubMenu->append($Subitem4);
		$SubMenu->append($Subitem5);
        $SubMenu->append($Subitem50);
        $SubMenu->append($Subitem51);
        $SubMenu->append($Subitem6);
        $SubMenu->append($Subitem7);
        $SubMenu->append($Subitem8);

		$Menu->set_submenu($SubMenu);

		$MenuBar->append($Menu);
		
		$Menu = new MyAltMenuItem(_a('Edit'), '_' . _a('Edit'), $accelgroup);

		$Subitem1 = new MyControlMenuItem($Pixmaps['menu_undo'],    _a('Undo'), '_Z',   $accelgroup, array(&$this, 'Undo'));
		$Subitem2 = new MyControlMenuItem($Pixmaps['menu_redo'],    _a('Redo'),  '_R',   $accelgroup, array(&$this, 'Redo'));
		$Subitem3 = new MyControlMenuItem($Pixmaps['menu_cut'],     _a('Cut'), '_X',   $accelgroup, array(&$this, 'Cut'));
		$Subitem4 = new MyControlMenuItem($Pixmaps['menu_copy'],    _a('Copy'),   '_C',   $accelgroup, array(&$this, 'Copy'));
		$Subitem5 = new MyControlMenuItem($Pixmaps['menu_paste'],   _a('Paste'),    '_V',   $accelgroup, array(&$this, 'Paste'));
        $Subitem50= new MyControlMenuItem($Pixmaps['menu_del'],     _a('Line Delete'),    '_L',   $accelgroup, array(&$this, 'LineDelete'));

        $Subitem51 =&new GtkMenuItem;
        $Subitem51a=new MyControlMenuItem($Pixmaps['menu_selall'],  _a('Select all'),   '_A',   $accelgroup, array(&$this, 'SelectAll'));
        $Subitem51b=new MyFunctionMenuItem($Pixmaps['menu_selmode'], _a('Rectangular selection'),   'Ctl+Sel',   $accelgroup, null);
        $Subitem52= new MyFunctionMenuItem($Pixmaps['menu_indent'],  _a('Indent'),   'Tab',       $accelgroup, array(&$this, 'Indent'));
        $Subitem53= new MyFunctionMenuItem($Pixmaps['menu_unindent'],_a('Unindent'), 'Shift+Tab',     $accelgroup, array(&$this, 'UnIndent'));
        $Subitem54= new MyFunctionMenuItem($Pixmaps['menu_tab1'],    _a('Left Tab'), 'Ctl+PgUp',      $accelgroup, array(&$this, 'onCtrlUp'));
        $Subitem55= new MyFunctionMenuItem($Pixmaps['menu_tab2'],    _a('Right Tab'),'Ctl+PgDown',    $accelgroup, array(&$this, 'onCtrlDown'));
        $Subitem56= new MyFunctionMenuItem($Pixmaps['menu_expand'],  _a('Expand all'),'',    $accelgroup, array(&$this, 'onExpand'));
        $Subitem57= new MyFunctionMenuItem($Pixmaps['menu_collapse'],_a('Collapse all'),'',    $accelgroup, array(&$this, 'onCollapse'));
		$Subitem6 = &new GtkMenuItem;
		$Subitem7 = new MyControlMenuItem($Pixmaps['menu_search'],  _a('Find'),  '_F',  $accelgroup, array(&$this, 'Find'));
		$Subitem8 = new MyFunctionMenuItem($Pixmaps['menu_search+'],_a('Find Next'),   65472,$accelgroup, array(&$this, 'Next'));
		$Subitem9 = new MyControlMenuItem($Pixmaps['menu_replace'], _a('Replace'),'_H',  $accelgroup, array(&$this, 'Replace'));
		$SubitemA = new MyControlMenuItem($Pixmaps['menu_goline'], _a('Go to line'),'_G',  $accelgroup, array(&$this, 'GoToLine'));
		$SubitemB = &new GtkMenuItem;
		$SubitemC = $this->SubitemC = &new MyCheckMenuItem($Pixmaps['menu_view'],  _a('View files'),'_I',  $accelgroup, array(&$this, 'FireTog1'));
        $SubitemD = $this->SubitemD = &new MyCheckMenuItem($Pixmaps['menu_caret'], _a('Caret Lines'),'_C',  $accelgroup, array(&$this, 'ToggleCaretLines'));
        $SubitemE = $this->SubitemE = &new MyCheckMenuItem($Pixmaps['menu_eol'],   _a('Show EOL'),'_O',  $accelgroup, array(&$this, 'ToggleEolMode'));
        $SubitemF = $this->SubitemF = &new MyCheckMenuItem($Pixmaps['menu_wrap'],  _a('Word Wrap'),'_W',  $accelgroup, array(&$this, 'ToggleWordWrap'));
        $this->caret   = false;
        $this->eolmode = false;
        $this->wordwrap= false;


		$SubMenu = &new GtkMenu;
		$SubMenu->append($Subitem1);
		$SubMenu->append($Subitem2);
		$SubMenu->append($Subitem3);
		$SubMenu->append($Subitem4);
		$SubMenu->append($Subitem5);
        $SubMenu->append($Subitem50);
        $SubMenu->append($Subitem51);
        $SubMenu->append($Subitem51a);
        $SubMenu->append($Subitem51b);
        $SubMenu->append($Subitem52);
        $SubMenu->append($Subitem53);
        $SubMenu->append($Subitem54);
        $SubMenu->append($Subitem55);
        $SubMenu->append($Subitem56);
        $SubMenu->append($Subitem57);
		$SubMenu->append($Subitem6);
		$SubMenu->append($Subitem7);
		$SubMenu->append($Subitem8);
		$SubMenu->append($Subitem9);
		$SubMenu->append($SubitemA);
		$SubMenu->append($SubitemB);
		$SubMenu->append($SubitemC);
        $SubMenu->append($SubitemD);
        $SubMenu->append($SubitemE);
        $SubMenu->append($SubitemF);

		$Menu->set_submenu($SubMenu);

		$MenuBar->append($Menu);
        $Menu = new MyAltMenuItem('CVS', '_CVS', $accelgroup);

        //$Subitem1= &new MyControlMenuItem($Pixmaps['menu_login'], _a('Login'),    '',  $accelgroup, array(&$this, 'CVSLogin'));
        $Subitem2= &new MyControlMenuItem($Pixmaps['menu_new'], _a('New'),     '',   $accelgroup, array(&$this, 'CVSNovo'));
        $Subitem3= &new MyControlMenuItem($Pixmaps['menu_up'], _a('Commit'), '_A',$accelgroup, array(&$this, 'CVSAtual'));
        $Subitem4= &new MyControlMenuItem($Pixmaps['menu_del'], _a('Delete'),   '',  $accelgroup, array(&$this, 'CVSDelete'));
        $Subitem5= &new MyControlMenuItem($Pixmaps['menu_lock'],   _a('Lock'),   '',  $accelgroup, array(&$this, 'CVSLock'));
        $Subitem6= &new MyControlMenuItem($Pixmaps['menu_unlock'], _a('Unlock'),   '',  $accelgroup, array(&$this, 'CVSUnlock'));
        //$Subitem5= &new MyControlMenuItem($Pixmaps['menu_logout'], _a('Logout'),   '',  $accelgroup, array(&$this, 'CVSLogout'));

        $SubMenu = &new GtkMenu;
        //$SubMenu->append($Subitem1);
        $SubMenu->append($Subitem2);
        $SubMenu->append($Subitem3);
        $SubMenu->append($Subitem4);
        $SubMenu->append($Subitem5);
        $SubMenu->append($Subitem6);
        //$SubMenu->append($Subitem5);

        $Menu->set_submenu($SubMenu);

        $MenuBar->append($Menu);

        $Menu = new GtkMenuItem('?');

		$Subitem1= &new MyControlMenuItem($Pixmaps['menu_help'], _a('About'), '',  $accelgroup, array(&$this, 'About'));
        $Subitem2= &new MyControlMenuItem($Pixmaps['menu_docs'], _a('View Docs'),'_I',  $accelgroup, array(&$this, 'Documentation'));
        //&new GtkMenuItem(_a('About'));
		//$Subitem1->connect_object('activate', array(&$this, 'Sobre'));

		$SubMenu = &new GtkMenu;
		$SubMenu->append($Subitem1);
        $SubMenu->append($Subitem2);

		$Menu->set_submenu($SubMenu);

		$MenuBar->append($Menu);

		return $MenuBar;
	}
	/**
	 * Method getting the properties of a project and setting them as the
	 * 'active' properties (when a new project is selected for example).
	 *
	 * @param	array	Array of properties
	 * @return	array	Array of properties
	 */
	function GetProperties($Arquivo)
	{
                //echo"PhpGtkEditor.class 641 GetProprieties $Arquivo \n" ;
                //print_r($Arquivo);//esta recebendo um string precisa ser um projeto ou array
                $properties['DbUser'] = $Arquivo['db_user'];
                $properties['DbPass'] = base64_decode($Arquivo['db_pass']);
                $dbname = $properties['DbName'] = $Arquivo['db_name'];
                $properties['DbHost'] = $Arquivo['db_ip'];
                $properties['DbType'] = $Arquivo['db_type'];
                $properties['Table'] = $Arquivo['Table'];// ?????

		return $properties;
	}

	/**
	 * Set the Page Name by its Label
	 */
    function SetPageByLabel($FileName)
    {
        for ($n=0; $n<=$this->count -1; $n++)
        {
            if ($FileName == $this->GetFileName($n))
            {
                $this->notebook->set_current_page($n);
            }
        }
		$scintilla = $this->GetScintilla();
        if ($scintilla)
        {
            $scintilla->grab_focus();
        }
    }

	/**
	 * Select All
	 */
    function SelectAll()
    {
		$scintilla = $this->GetScintilla();
        if ($scintilla)
        {
            $scintilla->select_all();
        }
    }


	/**
	 * Set the Page Name by its Label
	 */
    function ToggleCaretLines()
    {
        $this->caret = !$this->caret;

        for ($n=0; $n<=$this->count -1; $n++)
        {
            $scintilla = $this->GetScintilla($n);
            if ($scintilla)
            {
                $scintilla->set_caret_line_visible($this->caret);
            }
        }
    }
    
    function ApplyColors($profile)
    {
        for ($n=0; $n<=$this->count -1; $n++)
        {
            $scintilla = $this->GetScintilla($n);
            if ($scintilla)
            {
                $scintilla->DefinePHP($profile);
            }
        }
    }

	/**
	 * Set the Page Name by its Label
	 */
    function ToggleWordWrap()
    {
        $this->wordwrap= !$this->wordwrap;

        for ($n=0; $n<=$this->count -1; $n++)
        {
            $scintilla = $this->GetScintilla($n);
            if ($scintilla)
            {
                $scintilla->set_wrap_mode($this->wordwrap);
            }
        }
    }


	/**
	 * Set the Page Name by its Label
	 */
    function ToggleEolMode()
    {
        $this->eolmode = !$this->eolmode;

        for ($n=0; $n<=$this->count -1; $n++)
        {
            $scintilla = $this->GetScintilla($n);
            if ($scintilla)
            {
                $scintilla->set_view_eol($this->eolmode);
            }
        }
    }

    function GetMagicPath()
    {
        $guidepath = trim(substr(GetPath($this->GetFileName()),0,-1));
        if (substr($guidepath,0,1) == '*')
        {
            $guidepath = trim(substr($guidepath, 1));
        }

        $selecao = $this->arquivos->selection[0];
        if ($selecao)
        {
            $Arquivo = $this->arquivos->node_get_row_data($selecao);
            $dir = GetPath($Arquivo);
            if (is_dir($dir))
            {
                return $dir;
            }
            else
            {
                return $guidepath;
            }
        }
        else
        {
            return $guidepath;
        }
    }

	/**
	 * Method opening a file tree in the file explorer part
	 */
	function OpenTree($isdoc = false)
	{
        $tree = ($isdoc) ? $this->doc : $this->arquivos;
        $selecao = $tree->selection[0];
        $Arquivo = $tree->node_get_row_data($selecao);

        if ($this->Locks[$Arquivo])
        {
            new Dialog(_a('File already opened'));
            $this->SetPageByLabel($Arquivo);
            return;
        }

		$lock = $this->IsLocked($Arquivo);
		if (!$lock)
		{
            $this->LoadFile($Arquivo, $isdoc);
            $scintilla->connect('modified', array(&$this, 'Added'));
		}
		else
		{
			$lock = trim($lock);
			new Dialog(_a("User ^1 is working on this file", $lock));
		}
	}
    
    function LoadFile($Arquivo, $ReadOnly = false)
    {
        $info1 = $Arquivo;
        $info2 = split('://', $Arquivo, 2);

        if (count($info2) == 2)
        {
            $Server  = $info2[0];
            $Arquivo = $info2[1];
            # Define um array de parmetros
            $param = array('File'=>$Arquivo);
            # Cria objeto cliente SOAP
            $client = new soap_client("http://$Server/phpgtkeditor-server.php");
            $text= $client->call('open_file',$param);
            echo "\n lendo arquivo remoto $Server ://$Arquivo";
            if (!$text)
            {
                new Dialog(_a('Permission denied'));
            }
            else
            {
                $results = $this->AppendPage(GetFileName($Arquivo));
                $label = $results[0];
                $scintilla = $results[1];
                $scintilla->Load($text);
                $this->Lock($info1);
                $label->set_text("$Server://$Arquivo");
            }
        }
        else
        {
            $results = $this->AppendPage(GetFileName($Arquivo));
            $label = $results[0];
            $scintilla = $results[1];
            $scintilla->Open($Arquivo);
            $this->Lock($Arquivo);
            $label->set_text($Arquivo);
        }
        if ($ReadOnly)
        {
            $scintilla->set_read_only(1);
        }
    }

	/**
	 * Open remote files via Web Services
	 */
	function OpenRemote($Server,$caminho)
	{   echo "\n abrindo arquivo remoto $Server:// $caminho";
        $tree    = $this->remote;
        $selecao = $tree->selection[0];
        //$info1   = $tree->node_get_row_data($selecao);
        $info1 ="$Server://$caminho";//cuidado com espassos depois do Server e antes de $caminho
        $info2   = split('://', $info1, 2);

        if ($this->Locks[$info1])
        {
            $this->SetPageByLabel($info1);
            return;
        }

		$lock = $this->IsLocked($info1);
		if (!$lock)
		{
            $this->LoadFile($info1);
            //$scintilla->connect('modified', array(&$this, 'Added'));
		}
		else
		{
			$lock = trim($lock);
			new Dialog(_a("User ^1 is working on this file", $lock));
		}
	}


	/**
	 * Method using a backup workspace file to initiate the workspace when
	 * opening Tulip. PhpGtkEditor
	 */
	function OpenWorkspace()
	{
        $loaded = false;
        if (file_exists('workspace.txt'))
        {
            $fp = fopen('workspace.txt', 'r');
            if ($fp)
            {
                while ($Arquivo = fgets($fp, 500))
                {
                    $Arquivo = ereg_replace("\n", '', $Arquivo);
                    $lock = $this->IsLocked($Arquivo);
                    if (!$lock)
                    {
                        $this->LoadFile($Arquivo);
                        $loaded = true;
                    }
                    else
                    {
                        //$lock = trim($lock);
                        //new Dialog(_a("User ^1 is working on this file", $lock));
                    }
                }
                fclose($fp);
            }
        }
        return $loaded;
	}

	/**
	 * Method opening a table (from the database?)
	 */
	function AbrirTable()
	{
		$selecao = $this->db->selection[0];
        //echo "PhpGtkEditor.class 918 selecao=";
        //print_r($selecao);
        //busca os dados do projeto com o nome da tabela 
		$Arquivo = $this->db->node_get_row_data($selecao);//deve retornar uma string com os dados do projeto
        //echo "\nPhpGtkEditor.class 917 Arquivo ou tabela=$Arquivo..\n";
       // print_r($Arquivo);
		$results = $this->AppendTablePage($Arquivo);
		$label = $results[0];
		$grid = $results[1];
       // echo "\nPhpGtkEditor.class 921 label=$label e grid =$grid..";
		//$grid->Open($table);
		//$label->set_text($table);
	}
	
	/**
	 * Method reading the projects list in the projects directory and setting
	 * an array in the tulipIF (PhpGtkEditorIf) object to hold the different projects infos.
	 */
	function ReadProjects()
	{
		$this->Projects = array();
		$dir = @opendir('projects');
        echo "\n diretorio = $dir";
        
		if ($dir)
		{
			while ($entry = readdir($dir))
			{
				if (($entry != '.') && ($entry != '..') && (substr($entry, -1) != '~')  && (trim($entry) != 'CVS'))
				{
					include "projects/$entry";
                    
					$project = GetFileName("projects/$entry");echo "\n\nprojeto nome = $project";
                    
					$this->Projects[$project]['directory'] = $directory;echo "\ndiretorio = $directory;";
                    $this->Projects[$project]['remote'] = $remote;echo "\nremote = $remote;";
					$this->Projects[$project]['ftp_ip'] = $ftp_ip;
					$this->Projects[$project]['ftp_user'] = $ftp_user;
					$this->Projects[$project]['ftp_pass'] = $ftp_pass;
                    $this->Projects[$project]['ftp_dir'] = $ftp_dir;
					$this->Projects[$project]['server'] = $server;echo "\nserver = $server;";
					$this->Projects[$project]['cvs_user'] = $cvs_user;
					$this->Projects[$project]['db_ip'] = $db_ip;echo "\ndb_ip =$db_ip..";
					$this->Projects[$project]['db_user'] = $db_user;echo "\ndb_user =$db_user..";
					$this->Projects[$project]['db_pass'] = $db_pass;echo "\ndb_pass =$db_pass..";
					$this->Projects[$project]['db_name'] = $db_name;echo "\ndb_name =$db_name..";
					$this->Projects[$project]['db_type'] = $db_type;echo "\ndb_name =$db_name..";
                    $this->Projects[$project]['icon']    = $icon;echo "\nicon = $icon..";
                    $this->Entries[$directory] = $project;
                    unset($directory, $remote, $ftp_ip, $ftp_user, $ftp_pass,
                          $ftp_dir, $server, $cvs_user, $db_ip, $db_user,
                          $db_pass, $db_name, $db_type, $project, $icon);
                          
				}
			}
		}
	}


	/**
	 * Method reading the profile list in the profiles directory and setting
	 * an array in the tulipIF (PhpGtkEditorIF) object to hold the different profiles infos.
	 */
	function ReadProfiles()
	{
		$this->Profiles = array();
		$dir = @opendir('profiles');
		if ($dir)
		{
			while ($entry = readdir($dir))
			{
				if (($entry != '.') && ($entry != '..') && (substr($entry, -1) != '~')  && (trim($entry) != 'CVS'))
				{
					include "profiles/$entry";
					$profile = GetFileName("profiles/$entry");
					$this->Profiles[$profile]['colors'] = $colors;
                    $this->Profiles[$profile]['font'] = $font;
				}
			}
            if ($this->Profiles)
            {
                ksort($this->Profiles);
            }
		}
	}

	
	/**
	 * Method adding a page in the editor section.
	 * criando uma pagina adicional no notebook editor section.
	 * @param	string	Name of the new page (default = '')
	 * @return	array	Array containing the label of the page and
	 *					the reference to the page object
	 */
	function AppendPage($string='')
	{
        global $Pixmaps;
		$vbox = new GtkVBox;
		$path = new GtkLabel;
		$style = &new GtkStyle();
        $desc = new PangoFontDescription('Arial Bold 14');
		$style->font=$desc;//font = gdk::font_load ("-*-helvetica-bold-r-*-*-*-100-*-*-*-*-*-*");
		$path->set_style($style);
		$scintilla = &new ScintillaPHP($this->Profiles[$this->Profile]);
        $scintilla->set_caret_line_visible($this->caret);
        $scintilla->set_wrap_mode($this->wordwrap);
        $scintilla->set_view_eol($this->eolmode);
		// comentado no original $scintilla->set_flags(GTK_CAN_);
        //echo "\n 978 patch $path";
		$vbox->pack_start($path, false, false);//linha com o endereo do arquivo
		$vbox->pack_start($scintilla);//criando o editor
		$vbox->show_all();
        $scintilla->connect('char_added', array(&$this, 'Added'));//indica com asteristico no salvo
        $scintilla->connect('update_ui', array(&$this, 'Refresh'));
        // da erro $scintilla->register('modified', array(&$this, 'Added'));

		$ext = explode('.', $string);
		$ext = trim($ext[1]);

		if (!$ext || !$Pixmaps[$ext])
			$GdkPixmap = $Pixmaps['generic'];
		else
			$GdkPixmap = $Pixmaps[$ext];
		$imagem = $Pixmaps['generic'];
        
		$label = new GtkLabel(" $string ");//label da aba nome do arquivo
		
		$hbox = new GtkHBox;
		$hbox->pack_start(GtkImage::new_from_file($imagem));
		$hbox->pack_start($label);//nome do arquivo ao lado do label
		$hbox->show_all();

		$this->notebook->append_page($vbox, $hbox);
        $this->count ++;
		$page = $this->notebook->page_num($vbox);
		$this->notebook->set_current_page($page);
		$scintilla->grab_focus();
        if ($string)
        {
            $this->janela->set_title("PhpGtkEditor - {$string}");
        }
        else
        {
            $this->janela->set_title('PhpGtkEditor');
        }
		return array($path, $scintilla);
	}

	/**
	 * Method connecting to the database and executing a query. 
	 * The results are shown in a new page
	 * @see PhpGtkEditorIF#GetScroll()
	 */
	function ExecuteSql()
	{
        global $Pixmaps;
		$text = $this->GetSql();//$sql = new GtkEntry; mudei 1181
		$scroll= $this->GetScroll();
		$label= $this->GetLabel();
		$grid = $scroll->child;
		$properties = $grid->properties;
        echo "\n 1080proprieties=$properties..";print_r($properties);
		$txt = $text->get_text();
        echo "\n 1082 txt=$txt";
		$conn   = new AgataConnection;
		$Pass   = $conn->Open($properties);
		if (!$Pass)
		{
			$conn->Close();
			return false;
		}

		$query = $conn->CreateQuery($txt);
		$pos = strpos(strtoupper($txt), strtoupper('from'));
		$table = substr($txt,$pos+5);
		$pos2 = strpos(strtoupper($table), strtoupper(' '));
		$pos3 = strpos(strtoupper($table), strtoupper(','));
		if ($pos2)
			$table = substr($table,0,$pos2);
		else
			if ($pos3)
				$table = substr($table,$pos3);
			else
				$table = substr($table,0);

		$result = $query->result;
		if ($query->result and strtoupper(substr($txt,0,6))=='SELECT')
		{
			
            while($row=$result->fetchRow())
			{
				$lines[] = $row;
			}
            $Fields = $query->GetColumnNames();
            $grid->clear();//deveria ser excluido o modelo 
            $properties['Table']=$label->set_text($table);//coloca o nome da nova tabela se mudou
            $grid->monta_model($Fields);//criando o modelo de dados
            $grid->add_coluna_treeview($Fields,$grid,$grid->model);//inserindo os nomes 
            $grid->properties = $properties;
           // echo "\nPhpGtkEditor 1175 lines=$lines";print_r($lines);echo"..";
            $grid->AppendLineItems($lines,$grid->model);
            $grid->new_model();
            $pagelabel = $this->GetPage();
			$pagelabel->set_text($table);
            
		}
		$conn->Close();
	}

	/**
	 * Method adding a table page to the editor section. Generally used to 
	 * display a query result.
	 * @param	array	Array containing the properties of the current project?
	 *					Used to get info on the table queried.
	 */
	function AppendTablePage($Arquivo)
	{
        global $Pixmaps;
		$properties = $this->GetProperties($Arquivo);
        //echo "\n PhpGtkEditor.class 1128\n";
        //print_r($properties);
		$vbox = new GtkVBox;
		$path = new GtkLabel($Arquivo['Table']);
		$style = &new GtkStyle();
		//$style->font = gdk::font_load ("-*-helvetica-bold-r-*-*-*-100-*-*-*-*-*-*");
		$path->set_style($style);
		$table = $Arquivo['Table'];
        //echo"\n PhpGtkEditor.class 1142 nome da tabela=$table..";
		$conn   = new AgataConnection;
		$Pass   = $conn->Open($properties);
		if (!$Pass)
		{
			$conn->Close();
			return false;
		}

		$Fields = $conn->LoadFields($table);
		$txt = "select * from $table order by 1 limit 100";
		$query = $conn->CreateQuery($txt);
		$result = $query->result;
		if ($query->result)
		{
			while($row=$result->fetchRow())
			{
				$lines[] = $row;
			}
           
		}
		$conn->Close();


		$this->scroll = new GtkScrolledWindow;
        
		$grid = &new Grid('abc', $Fields, $Pixmaps['field']);
        //$grid->clear();//retiro o modelo
        $grid->monta_model($Fields);//criando o modelo de dados
        $grid->add_coluna_treeview($Fields,$grid,$grid->model);//inserindo os nomes 
		$grid->properties = $properties;
       // echo "\nPhpGtkEditor 1175 lines=$lines";print_r($lines);echo"..";
		$grid->AppendLineItems($lines,$grid->model);
        $grid->new_model();
		$this->scroll->add($grid);
/*
		$sql = new GtkText;
		$sql->set_usize(-1, 48);
		$sql->set_editable(true);
		$sql->insert_text($txt,0);
*/
        $sql = new GtkEntry;
		$sql->set_size_request(-1, 48);
		$sql->set_editable(true);
		$sql->set_text($txt);
        
		$boxsql = new GtkHbox;
		$img = GtkImage::new_from_file(images . 'sql.xpm');
		$boxsql->pack_start($img, false, false);
		$boxsql->pack_start($sql, true, true);
		$boxsql->set_border_width(4);
        $imgen = GtkImage::new_from_file(images . 'ico_ok.xpm');
                      
		$botao = new Icone($imagen, '  Ok  ', '  Ok  ', true);
		$botao->set_border_width(4);
		$botao->connect_simple('clicked', array(&$this, 'ExecuteSql'));
		$caixa = new GtkHBox;
		$caixa->pack_start(new GtkHBox, true, true);
		$caixa->pack_start($botao, false, false);

		$vbox->pack_start($path,   false, false);
		$vbox->pack_start($boxsql, false, false);
		$vbox->pack_start($caixa,  false, false);
		$vbox->pack_start($this->scroll, true,  true);

		$vbox->show_all();

		$label = new GtkLabel($table);
		
		$hbox = new GtkHBox;
		$hbox->pack_start(GtkImage::new_from_file($Pixmaps['table']));
		$hbox->pack_start($label);
		$hbox->show_all();

		$this->notebook->append_page($vbox, $hbox);
        $this->count ++;
		$page = $this->notebook->page_num($vbox);
		$this->notebook->set_current_page($page);

		return array($label, $grid);
	}
    
    

	/**
	 * Method adding a * to the name of a page (tab)
	 * @param	object	Why?
	 */
	function Added($scintilla)
	{   
        //echo "\n linha1170 $scintilla";//[ScintillaPHP object (GtkScintilla Gtk+ type)]int(0)
        //var_dump($scintilla->get_read_only());
        //$teste=$scintilla->get_read_only();// retorna 0 (zero)
        //echo "\n linha1173 $teste";
        if (!$scintilla->get_read_only())
        {   
            //label do notbook criado com new
            $label = $this->GetLabel();//retorna um objeto label
            //echo "\n label =$label linha 1176";
            $file = $label->get_label();//pega o texto do label
    
            if (substr($file,0,1) != '*') //arquivo modificou coloca um asteristico no nome
            {
                $label->set_text("* $file");
            }
    
            // Put '*' in front of tab label
            $label = $this->GetPage();
            $file = $label->get_label();
    
            if (substr($file,0,1) != '*')
            {
                $label->set_text("* $file");
            }
        }
	}

	/**
	 * Method setting the status of tulipIF (PhpGtkEditorIF)to remember a certain line was
	 * changed.
	 *
	 * @param	object	The current page pointer.
	 */
	function Refresh($scintilla)
	{
		$this->notebook->get_current_page();
		$line = $scintilla->get_cur_line();
		$col = $line[1];
		$this->status->push(1, "COL: $col");
	}

	/**
	 * Method getting the name of the file from the page (tab) name.
	 * busca o nome do arquivo no vbox dentro do label no notebook
	 * @return	string	The file's name
	 */
	function GetFileName($current = null)
	{
        if (!isset($current))
        {
            $current = $this->notebook->get_current_page();//busca um numero inteiro da pagina corrente
        }

		$content = $this->notebook->get_nth_page($current);//pega o widget da pagina corrente (container )
		if ($content)
		{
            
			$slots = $content->get_children();
            
			$slot1 = $slots[0];//pega o primeiro
           // echo "\n slots $slots[0]";//[GtkLabel object (GtkLabel Gtk+ type)]
            //print_r($slots[0]);
			//$label = $slot1->widget;//pega o widget label
			$file = $slot1->get_label();//pega o conteudo
           // echo "\n arquivo = $file";
			return $file;
		}
	}

	/**
	 * Method getting the name of a project from the file name.
	 */
	function GetProject()
	{
		$file = $this->GetFileName();
		$path = substr(GetPath($file),0,-1);

        // sort project paths by size
        $unsortEntries = $this->Entries;
        foreach ($unsortEntries as $unsortEntry => $project)
        {
            $size_entries[strlen($unsortEntry)][] = array($unsortEntry, $project);
        }
        ksort($size_entries);
        $size_entries = array_reverse($size_entries);
        foreach ($size_entries as $size => $content)
        {
            foreach ($content as $sortEntry)
            {
                $entries[$sortEntry[0]] = $sortEntry[1];
            }
        }

		if ($entries)
		{
			foreach ($entries as $entry => $project)
			{
				$len = strlen($entry);
				if ((substr($path,0,$len) == $entry) && ($entry))
                {
					return $project;
                }
			}
		}
		return null;
	}

	/**
	 * Method setting the name of a page (tab) (not really renaming the file)
	 * @param	string	The new name of the page
	 */
	function SetFileName($file)
	{
        // Sets the FileName Label
        $label = $this->GetLabel();
		$label->set_text($file);
        $split = explode(bar, $file);

        // removes the '*' in front of tab label
        $label = $this->GetPage();

		//if (substr($file,0,1) == '*')
        {
            $label->set_text($split[count($split)-1]);
        }
	}

	/**
	 * Method getting the reference (not really a reference, but anyway...) of
	 * the Scintilla current object.
	 *
	 * @return	object	Reference to the current scintilla object
	 */
	function GetScintilla($current = null)
	{
        if (!isset($current))
        {
            $current = $this->notebook->get_current_page();
            echo "\n Pagina corrente numero = ..";
            
        }

		$content = $this->notebook->get_nth_page($current);
       // echo "\n 1348 conteudo do notebook numero $current da pagina =$content..";//objeto
        
		if ($content)
		{   $slots = $content->get_children();
            //echo "\n 1355 slots do notebook =$slots..";//vasio
            if (count($slots)==2)
            {
                $slot2 = $slots[1];
                //echo "\n 1359 $slot2";
                $scintilla = $slot2;
                return $scintilla;
            }
            else
            {
                return false;
            }
		}
        
	}
    
    function GetTabLabel()
    {
		$current = $this->notebook->get_current_page();
		$content = $this->notebook->get_nth_page($current);
        $tab = $this->notebook->get_tab_label($content);

		$slots = $tab->children;
		$slot1 = $slots[1];
		$label = $slot1->widget;
        return $label;
    }
    
	/**
	 * Gets the sql statement
	 *
	 * @return	object	Reference to 
	 *					$this->notebook->current_content->children[1]->widget->children[1]->widget  ???
	 */
	function GetSql()
	{
		$current = $this->notebook->get_current_page();
		$content = $this->notebook->get_nth_page($current);
        //echo "\nPhpGtkEditor.class 1415 content $content.."; //[GtkVBox object (GtkVBox Gtk+ type)].
        //var_dump($content);
		if ($content)
		{
			$slots = $content->get_children();//GtkVBox notem children
            //echo "\nPhpGtkEditor.class 1420 $slots..";//var_dump($slots);
			$slot2 = $slots[1];
            echo "\nPhpGtkEditor.class 1422 $slots..";
			$frame = $slot2->get_children();//->widget;GtkHBox
            echo "\nTulipeditor.class 1424 $frame..";
			$boxchild = $frame[1];
			echo "\nPhpGtkEditor.class 1426 $boxchild..";//[GtkEntry object (GtkEntry Gtk+ type)]..
            //var_dump($boxchild);echo"\noi..";print_r($boxchild); echo"\n..";//espero aqui um gtkentry
			$sql = $boxchild; //retornando o objeto gtkentry
			return $sql;
		}
       
	}

	/**
	 * Gets the current page widget
	 *
	 * @return	object	Reference to the current page's childbox
	 */
	function GetPage()
	{
		$current = $this->notebook->get_current_page();
		$content = $this->notebook->get_nth_page($current);
		if ($content)
		{
			$hbox = $this->notebook->get_tab_label($content);
           // echo"\n1377 hbox = $hbox ..";//[GtkHBox object (GtkHBox Gtk+ type)]
			$boxchild = $hbox->get_children();
           // echo"\n1377 boxchild = $boxchild ..";//array
            $getpag=$boxchild[1];
            //print_r($boxchild);
			//return $boxchild->widget;
            //echo"\n getpag=$getpag ..";
            return $getpag;
		}
	}

	/**
	 * Gets the label of the current page
	 *
	 * @return	object?	Reference to the current page's label
	 */
	function GetLabel()
	{
		$current = $this->notebook->get_current_page();
		$content = $this->notebook->get_nth_page($current);//pega o widget da pagina corrente (container )
       // echo"\nnotebook corrente";
        //print_r($this->notebook);
       // echo"\nconteudo do notebook ";
        //print_r($content);
		if ($content)
		{
			$slots = $content->get_children();
            //echo "\n slots $slots[0]";//[GtkLabel object (GtkLabel Gtk+ type)]
			$slot2 = $slots[0];
			//$label = $slot2->get_label();//widget;
            //echo "\n1400 label=$label ..";
           // return $label;
           return $slot2 ;//retornando o objeto label
		}
	}
    
	/**
	 *	Gets the scrolling widget of the current page
	 *
	 * @return	object?	Reference to the current page's scrolling widget(3rd child)
	 */
	function GetScroll()
	{
		$current = $this->notebook->get_current_page();
		$content = $this->notebook->get_nth_page($current);
		if ($content)
		{
			$slots = $content->get_children();
			$slot2 = $slots[3];
			$list = $slot2;
			return $list;
		}
	}

	/**
	 * Reloads the file tree. Just a shortcut for $this->arquivos->ReadAgain()
	 * @see	FileTree#ReadAgain() in explorer.class
	 */
	function ReloadTree()
	{ 
		$this->ReadProjects();//le o diretorio de projetos e monta ua array
		$this->arquivos->ReadAgain();
        $this->remote->ReadAgain();
        //$this->cvs->Clear();
        
      $this->db->Clear();
         
		foreach($this->Projects as $Project => $Properties)
		{  echo "\n lendo os projetos $Project.. \n";print_r($Properties);
            if ($Properties['icon'])
            {
               $ico = $Properties['icon'];//vai o endereo 
               $dir = $Properties['directory'];
               $nome = $Project;
               $node = $this->arquivos->AddHome($dir,$nome, $ico);
            }
            else
            {  
               $dir = $Properties['directory'];
               $nome = $Project;
               $node = $this->arquivos->AddHome($dir,$nome);
            }
               // $this->arquivos->AbreDiretorio($Properties['directory'], $node);
            if ($Properties['remote'])
            {
                $node = $this->remote->AddHome($Project, $Properties['remote']);
            }
            //$this->cvs->AddProject($Project, $Properties);
            $this->db->AddProject($Project, $Properties);
		}
    
	}

	/**
	 * Closes the current file. If it has been modified (checked with '*' char)
	 * asks the user if he wants to save the file. Else, close the file
	 * without saving.
	 *
	 * @see	PhpGtkEditorIF#Salvar
	 * @see	PhpGtkEditorIF#FechaPagina
	 */
	function Fechar()
	{
		$file = $this->GetFileName();
		if (substr($file,0,1) == '*')
		{
			new Ask(_a('Do you want to save the file ?'),
                    array(&$this,'Save'), array(&$this, 'FechaPagina'), array($file));
		}
		else
		{
			$this->FechaPagina();
		}
	}

	/**
	 * Exits PhpGtkEditor unlocking all files
	 */
	function onClose()
	{
        new Ask(_a('Do you want to save the workspace ?'),
                array(&$this,'QuitSaving'), array(&$this, 'Quit'));
        return true;
	}

    function Quit()
    {
		//echo "Exiting...\n";
		if ($this->Locks)
		{
			foreach($this->Locks as $lock => $bool)
			{
				if ($bool)
                {
					$this->UnLock($lock);
                }
			}
		}
        gtk::main_quit();
    }
    
    function QuitSaving()
    {
        $this->SaveWork();
        $this->Quit();
    }

	/**
	 * Closes the current page. If the filename still starts with a '*', delete
	 * it and unlock the file (without saving).
	 */
	function FechaPagina()
	{
		$file = $this->GetFileName();
		if (substr($file,0,1)=='*')
			$file = substr($file,2);

		$this->UnLock($file);
		$this->notebook->remove_page($this->notebook->get_current_page());
        $this->count --;
	}

	/**
	 * Copy the current scintilla object's content?
	 */
	function Copy()
	{
		$scintilla = $this->GetScintilla();
		if ($scintilla)
			$scintilla->copy();
	}

	/**
	 * Paste the current scintilla object's content?
	 */
	function Paste()
	{
		$scintilla = $this->GetScintilla();
		if ($scintilla)
			$scintilla->paste();
	}

	/**
	 * Paste the current scintilla object's content?
	 */
	function Indent()
	{
		$scintilla = $this->GetScintilla();
		if ($scintilla)
			$scintilla->tab();
	}

	/**
	 * Paste the current scintilla object's content?
	 */
	function UnIndent()
	{
		$scintilla = $this->GetScintilla();
		if ($scintilla)
			$scintilla->back_tab();
	}

	/**
	 * Undo the last scintilla action
	 */
	function Undo()
	{
		$scintilla = $this->GetScintilla();
		if ($scintilla)
			$scintilla->undo();
	}

	/**
	 * Redo the last undone scintilla action
	 */
	function Redo()
	{
		$scintilla = $this->GetScintilla();
		if ($scintilla)
			$scintilla->redo();
	}

	/**
	 * Cut the current scintilla selection
	 */
	function Cut()
	{
		$scintilla = $this->GetScintilla();
		if ($scintilla)
			$scintilla->cut();
	}

	/**
	 * Line Delete
	 */
	function LineDelete()
	{
		$scintilla = $this->GetScintilla();
		if ($scintilla)
			$scintilla->line_delete();
	}

	/**
	 * Create new input box that gets a line number to go to
	 *
	 * @see	PhpGtkEditorIF#GoToLineX
	 */
	function GoToLine()
	{
		new InputBox(_a('Go to line') . ':', 180, '', array(&$this, 'GoToLineX'));
	}

	/**
	 * Go to line x in the current scintilla object
	 */
	function GoToLineX($entry)
	{
		$scintilla = $this->GetScintilla();
        if ($scintilla)
        {
            $scintilla->goto_line($entry->get_text() -1);
        }
	}

	/**
	 * Draws the input box for view docs
	 *
	 * @see PhpGtkEditorIF#Encontra()
	 */
	function Documentation()
	{
        $scintilla = $this->GetScintilla();
        if ($scintilla)
        {
            $text = $scintilla->get_current_word();
        }
        
		new InputBox(_a('PHP Function'). ':', 180, $text, array(&$this, 'ViewDocs'));
	}

	/**
	 * Shows the documentation
	 *
	 * @param	object	Reference to the entry containing the text to look for
	 */
	function ViewDocs($entry)
	{
        global $Pixmaps;
        include_once('functions.php');
        $function= $entry->get_text();
        $file = $this->functions[$function];
        if ($file)
        {
            $this->AbrirRapido("doc/php-doc/functions/$file");
        }
        else
        {
            include_once('gtkfunctions.php');
            $gtkfunctions = $this->gtkfunctions[$function];
            if ($gtkfunctions)
            {
                $classes = array_keys($gtkfunctions);
                if (count($classes)==1)
                {
                    $content = current($gtkfunctions);
                    $this->AbrirRapido("gtk-doc/$content");
                }
                else if (count($classes) > 1)
                {
                    $action = array(&$this, 'GoGtkMethod');
                    $this->list = &new IList($classes, $action, $Pixmaps['class'], _a('Choose the class'), _a('Class'));
                    $this->list->functions = $gtkfunctions;
                }
            }
            else
            {
                new Dialog(_a('No Docs'));
            }
        }
    }

    function GoGtkMethod()
    {
        $item = $this->list->GetItem();
        $functions = $this->list->functions;
        if ($item)
        {
            $file = $functions[$item];
            $this->AbrirRapido("doc/gtk-doc/$file");
        }
        
    }

	/**
	 * Draws the input box for text search
	 *
	 * @see PhpGtkEditorIF#Encontra()
	 */
	function Find()
	{
		new InputBox(_a('Searched text'). ':', 180, '', array(&$this, 'Encontra'));
	}

	/**
	 * Find next occurence of a text in the current page
	 *
	 * @see PhpGtkEditorIF#Encontra(string)
	 */
	function Next()
	{
		if ($this->Ultimo)
			$this->Encontra($this->Ultimo);
	}

	/**
	 * Find a text in the current page (scintilla object)
	 *
	 * @param	object	Reference to the entry containing the text to look for
	 */
	function Encontra($entry)
	{
		$this->Ultimo = $entry;
		$scintilla = $this->GetScintilla();
		if ($scintilla)
		{
			$flags = SCINTILLA_FIND_DOWN + SCINTILLA_FIND_WHOLE_WORDS + SCINTILLA_FIND_MATCH_CASE + SCINTILLA_FIND_WHOLE_WORDS +  SCINTILLA_FIND_WORD_START + SCINTILLA_FIND_REGEXP;
			$what = $entry->get_text();
			$start = 0;
			$end = $scintilla->get_length();
			if ($backwards)
			{
				$start = $scintilla->get_selection_start() - 1;
				$end = 0;
			}
			else
			{
				$start = $scintilla->get_selection_end();
				$end = $scintilla->get_length();
			}
			$result = $scintilla->find_text($flags, $what, $start, $end);
            //$result = $scintilla->find_text($flags, $what, 0, $end);
			if ($result > -1)
			{
				//if (!$scintilla->get_line_visible($scintilla->line_from_position($result)))
				$scintilla->goto_line($scintilla->line_from_position($result));
				$scintilla->set_selection_start($result);
				$scintilla->set_selection_end($result + strlen($what));
			}
			else
			{
				$scintilla->set_selection_end( $scintilla->get_selection_start());
			}
            $scintilla->grab_focus();
		}
	}

	/**
	 * Create double input box for text substitution
	 */
	function Replace()
	{
		new DoubleInputBox(_a('Expression'). ':', _a('Substitution'). ':', array(&$this, 'Substitui'));
	}
    
	/**
	 * Substitute entry1 by entry2
	 *
	 * @param	object	Reference to an entry containing the text to be replaced
	 * @param	object	Reference to an entry containing the text to put instead
	 */
	function Substitui($entry1, $entry2)
	{
		$scintilla = $this->GetScintilla();
		if (!$scintilla)
			return;

		$find_text = $entry1->get_text();
		$replace_text = $entry2->get_text();

		$flags = SCINTILLA_FIND_DOWN + SCINTILLA_FIND_MATCH_CASE + SCINTILLA_FIND_WHOLE_WORDS +
				SCINTILLA_FIND_WORD_START +  SCINTILLA_FIND_REGEXP;

		$sel_start = $scintilla->get_selection_start();
		$sel_end = $scintilla->get_selection_end();   
		$scintilla->begin_undo_action();
		$count = 0;
		$target_start = $target_end = 0;
        
		$replace_start = 0;
		$replace_end = $scintilla->get_length();

		$regex = 0;
		$prompt_on = 0;
		$replace_action = 0;
        
		$result = $scintilla->find_text($flags, $find_text, $replace_start, $replace_end);
		while (($result > -1) && ($replace_action < 3))
		{
			$target_start = $result;
			$target_end = $result + strlen($find_text);
			$scintilla->set_selection_start($target_start);
			$scintilla->set_selection_end($target_end);
			$scintilla->ensure_visible($scintilla->line_from_position($target_start));
            
			$replace_action = 0;
			if ($prompt_on)
			{
				//echo "PROMPT!";
				//$prompt_dialog = PromptDialog(doc.get_sel_text(), replace_text)
				//$replace_action = prompt_dialog.show()
			}
			if ($replace_action == 1)
			{
				$result = $scintilla->find_text($flags, $find_text,	$target_end, $replace_end);
				continue;
			}
			if ($replace_action == 2)    // all
				$prompt_on = 0;
			if ($replace_action == 4)   // cancel
				break;

			$count = $count + 1;
			$scintilla->set_target_start($target_start);
			$scintilla->set_target_end($target_end);
			if ($regex)
			{                            //Substituir alvo regex
				$len_replace = $scintilla->replace_target_re($regex, $replace_text);
			}
			else
			{                  // Void replace_target (comprimento, texto);
                               // Substituir alvo 
                $tamanho=strlen($replace_text);//($target_end - $target_start);
                echo "tamanho $tamanho texto a trocar $replace_text";
				$len_replace = $scintilla->replace_target($tamanho,$replace_text);
            }  
			$replace_start = $target_start + $len_replace;
			if (!$all)
			{
				$replace_end +=  ($len_replace - ($target_end - $target_start));
			}
			else
			{
				$replace_end =  $scintilla->get_length();
			}

			$result = $scintilla->find_text($flags, $find_text,
					$replace_start, $replace_end);
		}
		$scintilla->goto_pos($scintilla->get_target_end());
		$scintilla->end_undo_action();
	} 

	/**
	 * Open a file in a new scintilla page
	 * helder alterei
	 * @param	object	Reference to the file clicked in the file tree
	 */
	function Abrir( $fs )
	{   
       
		$Arquivo = $fs;//->get_filename();
		//$fs->hide();

        if ($this->Locks[$Arquivo])
        {
            //new Dialog(_a('File already opened'));
            $this->SetPageByLabel($Arquivo);
            return;
        }

		$lock = $this->IsLocked($Arquivo);
		if (!$lock)
		{
			$results = $this->AppendPage(GetFileName($Arquivo));
			$label = $results[0];
			$scintilla = $results[1];
			$scintilla->Open($Arquivo);
			$this->Lock($Arquivo);
			$label->set_text($Arquivo);
		}
		else
		{
			$lock = trim($lock);
			new Dialog(_a("User ^1 is working on this file", $lock));
		}

	}

	/**
	 * Shortcut opening of a file
	 *
	 * @param	object	Reference to an entry containing the name of the file to open
	 * @see		PhpGtkEditorIF#AbrirRapido
	 */
	function AtalhoAbrir($entry)
	{
		$file = $entry->get_text();
		if ($file)
			$this->AbrirRapido($file);
	}

	/**
	 * Opens a file by name
	 * 
	 * @param	array	Array containing info about the project and the file
	 */
	function AbrirRapido($Arquivo, $saverecent = true)
	{
        if ($this->Locks[$Arquivo])
        {
            //new Dialog(_a('File already opened'));
            $this->SetPageByLabel($Arquivo);
            return;
        }

		$lock = $this->IsLocked($Arquivo);
		if (!$lock)
		{
            $this->LoadFile($Arquivo);
		}
		else
		{
			$lock = trim($lock);
			new Dialog(_a("User ^1 is working on this file", $lock));
		}
	}
	/**
	 * Opens a recent file
	 */    
    function AbrirRecent($Arquivo)
    {
        $this->AbrirRapido($Arquivo, false);
    }

	/**
	 * Saves changes by writing the content of the scintilla object to the file
	 * or over the old file if there was one. If the file is a new file, use a
	 * dialog box to ask the name to give it.
	 */
	function Save()
	{
		$file = $this->GetFileName();
        $scintilla = $this->GetScintilla();
        echo "Salvando o arquivo $scintilla..";
		if ($scintilla)
		{   echo "Salvando o arquivo $file..";
			$texto = $scintilla->get_text();
			if ($file && trim($file) != '*')
			{
				if (substr($file,0,1)=='*')
                {
					$file = substr($file,2);
                    echo "\n Arquivo salvo $file";
                }

				$this->CheckExists($file, $texto, true);
			}
			else
			{   $type='save';
				$arquivo=HandlerFile(array('1',  array(&$this, 'SaveAs'), _a('Save'), null, $this->GetMagicPath()),$type);
                //$arquivo recebe o caminho completo do arquivo com o nome.
                if($arquivo)
                {
                    echo "\n 2011 chamando CheckExists";
                    $this->CheckExists($arquivo, $texto, false);
                    echo "\n Arquivo salvo $arquivo";
                }
                
			}
		}
	}

	/**
	 * Dialog box asking the name of the new file
	 */
	function DialogSaveAs()
	{
		$current = $this->notebook->get_current_page();
		$content = $this->notebook->get_nth_page($current);
		$slots = $content->get_children();
        echo "\n 2022 Dialogo save as da folha $slots";
        // check if it's a code page
        if (count($slots)==2)
        {
            $file = $this->GetFileName();
            if (substr($file,0,1)=='*')
                $file = substr($file,2);
    
            $this->UnLock($file);
            $type='saveas';
			$arquivo=HandlerFile(array('1',  array(&$this, 'SaveAs'), _a('Save as'), null, $this->GetMagicPath()),$type);
            if($arquivo)
                {
                    echo "\n 2043 chamando CheckExists";
                    $this->CheckExists($arquivo, $texto, false);
                    echo "\n 2045 Arquivo salvo $arquivo";
                }
        }
	}

	/**
	 * Saves a new file on disk
	 *
	 * @param	object	Reference to an object containing the name of the new file
	 */
	function SaveAs($fs)
	{
		$current = $this->notebook->get_current_page();
		$content = $this->notebook->get_nth_page($current);
		$slots = $content->get_children();
        echo "\n SaveAs da folha $slots";
        // check if it's a code page
        if (count($slots)==2)
        {
            $scintilla = $this->GetScintilla();
            $label = $this->GetLabel();
            $file = $label->get();
            $texto = $scintilla->get_text();
            $Arquivo = $fs->get_filename();

            $fs->hide();
            if ($Arquivo)
            {
                $this->CheckExists($Arquivo, $texto, false);
            }
        }
	}

    function CheckExists($file, $text, $pass)
    {
        if (file_exists($file) and !$pass)
        {
            new Ask(_a('Do you want to overwrite the file ?'),
                array(&$this,'CheckExists'), null, array($file, $text, true));
        }
        else
        {
            $info1 = explode('://', $file);
            $Server  = $info1[0];
            $Arquivo = $info1[1];

            if (count($info1) == 2)
            {
                $param = array('File'=>$Arquivo, 'text' => $text);
                # Cria objeto cliente SOAP
                $client = new soap_client("http://$Server/phpgtkeditor-server.php");
                $ret = $client->call('save_file',$param);
                if (!$ret)
                {
                    new Dialog(_a('Permission denied'));
                }
                else
                {
                    $this->SetFileName($file);
                }
            }
            else
            {
                $fp = fopen($file,'w');
                if ($fp)
                {
                    fwrite($fp, $text);
                    fclose($fp);
                    $this->SetFileName($file);
                }
                else
                {
                    new Dialog(_a('Permission denied'));
                }
            }
        }
    }

	/**
	 * Pre-opening method for a file. Generates a HandlerFile and binds 
	 * 'Abrir()' to it
	 * //helder alterei
	 * @see	PhpGtkEditorIF#Abrir()
	 */
	function PreAbrir()
	{
		$type=null;//em file dialog deve abrir sem o local para escrever o nome do arquivo
        $nomearquivo=HandlerFile(array('1',  array(&$this, 'Abrir'), _a('Open'), null, $this->GetMagicPath()),$type);
        if($nomearquivo)
        {
            $this->Abrir($nomearquivo);//precisa receber o nome arquivo
        }
	}

	/**
	 * Shortcut activated by 'Enter' keypress to search for a text within
	 * the active file, from the input box in the toolbar
	 *
	 * @param	object	Event object holding the key pressed
	 * @param	object	Entry object holding the search string
	 */
	function kFind($obj, $entry)
	{
		if ($obj->keyval == 65293)
			$this->Encontra($entry);
	}

	/**
	 * Shortcut activated by 'Enter' keypress to open a file. Used when the
	 * user hits return after filling the search input box in the toolbar.
	 *
	 * @param	object	Event object holding the key pressed
	 * @param	object	Entry object holding the file name
	 */
	function kOpen($obj, $entry)
	{
		if ($obj->keyval == 65293)
			$this->AbrirRapido($entry->get_text());
	}

	/**
	 * Generates the 'About' popup window.
	 */
	function About()
	{
        $this->about = new GtkWindow;
        $this->about->set_title('PhpGtkEditor 8.05.01');
        $this->about->connect_simple('key_press_event', array(&$this, 'CloseAbout'));
		$this->about->realize();

		$Pixmap  = GtkImage::new_from_file( images . 'about.xpm');

		$this->about->set_position(GTK_WIN_POS_CENTER);

		$this->about->add($Pixmap);
        
		$this->about->show_all();
	}

    function CloseAbout()
    {
        $this->about->hide();
    }

	/**
	 * Tells whether there is or isn't a lock for the file.
	 *
	 * @param	array	Array containing info about the file.
	 * @return	bool	true if there is a lock, false if there isn't.
	 */
	function IsLocked($Arquivo)
	{
        $info = explode('://', $Arquivo);

        if (count($info)==2)
        {
            $Server  = $info[0];
            $Arquivo = $info[1];

            $path = GetPath($Arquivo);
            $file = GetFileName($Arquivo);
            $lock = "{$path}.tulip_lock.{$file}";
            $param = array('File'=>$lock);
            # Cria objeto cliente SOAP
            $client = new soap_client("http://$Server/phpgtkeditor-server.php");
            if ($client->call('file_exists',$param))
            {
                $read = $client->call('open_file',$param);
                if (strtoupper(trim($read)) == strtoupper(trim($_ENV['USER'])))
                {
                    return false;
                }
                else
                {
                    return $read;
                }
            }
        }
        else
        {
            $path = GetPath($Arquivo);
            $file = GetFileName($Arquivo);
            $lock = "{$path}.PhpGtkEditor_lock.{$file}";
            if (file_exists($lock))
            {
                $read = file($lock);
                if (strtoupper(trim($read[0])) == strtoupper(trim($_ENV['USER'])))
                {
                    return false;
                }
                else
                {
                    return $read[0];
                }
            }
        }
		return false;
	}
	
	/**
	 * Puts a lock on a file (creates a file AND sets a flag in the PhpGtkEditorIF obj)
	 *
	 * @param	array	Array containing info about the file
	 */
	function Lock($Arquivo, $saverecent = true)
	{
        $info = explode('://', $Arquivo);
        $this->Locks[$Arquivo] = true;
        if ($saverecent)
        {
            $this->SaveRecent($Arquivo);
        }

        if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            $USER = strtoupper(trim($_ENV['USERNAME']));
        else
            $USER = strtoupper(trim($_ENV['USER']));

        if (count($info)==2)
        {
            $Server  = $info[0];
            $Arquivo = $info[1];
            $path = GetPath($Arquivo);
            $file =  GetFileName($Arquivo);
            $lock = "{$path}.PhpGtkEditor_lock.{$file}";

            $param = array('File'=>$lock, 'text'=>$USER);
            # Cria objeto cliente SOAP
            $client = new soap_client("http://$Server/phpgtkeditor-server.php");
            $client->call('save_file',$param);
        }
        else
        {
            $path = GetPath($Arquivo);
            $file =  GetFileName($Arquivo);    
            $lock = "{$path}.PhpGtkEditor_lock.{$file}";
    
            $fp = fopen($lock,'w');
            if ($fp)
            {
                fwrite($fp, $USER);
                fclose($fp);
            }
        }
	}

	/**
	 * Deletes the lock on a file and unsets the lock flag
	 *
	 * @param	array	Array containing info about the file
	 */
	function UnLock($Arquivo)
	{
        $this->Locks[$Arquivo] = false;
        $info = explode('://', $Arquivo);
        if (count($info)==2)
        {
            $Server  = $info[0];
            $Arquivo = $info[1];
            $path = GetPath($Arquivo);
            $file =  GetFileName($Arquivo);

            $param = array('File'=>"{$path}.PhpGtkEditor_lock.{$file}");
            # Cria objeto cliente SOAP
            $client = new soap_client("http://$Server/phpgtkeditor-server.php");
            $client->call('unlink',$param);
        }
        else
        {
            $path = GetPath($Arquivo);
            $file =  GetFileName($Arquivo);
            if (file_exists("{$path}.PhpGtkEditor_lock.{$file}"))
            {
                unlink("{$path}.PhpGtkEditor_lock.{$file}");
            }
        }
	}

	/**
	 * Check the operation
	 */
/*	function CVSVerify()
	{
		$selecao = $this->cvs->selection[0];
		$Arquivo = $this->cvs->node_get_row_data($selecao);
        $action = $Arquivo['CVS'];
        
        if ($action == 'login')
            $this->CVSLogin();
        else if ($action == 'logout')
            $this->CVSLogout();
        else if ($action == 'checkout')
            $this->TestCVSCheckout();
    }

    function TestCVSCheckout()
    {
        new Ask(_a('Do you want to checkout this project ?'),
                array(&$this,'CVSCheckout'), null, null);
    }
*/
	/**
	 * Logs in cvs server
	 */
/*	function CVSLogin()
	{
		$selecao = $this->cvs->selection[0];
		$Arquivo = $this->cvs->node_get_row_data($selecao);
		$user   = $Arquivo['cvs_user'];
		$server = $Arquivo['server'];
        $path   = $Arquivo['directory'];
    
		if ($user && $server)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $fp = fopen('cvs_up.bat', 'w');
                fwrite($fp, "cd $path\n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot login \n");
                fwrite($fp, "exit\n");
                fclose($fp);
                exec("start /wait cvs_up.bat >NULL &");
            }
            else
            {
                $fp = fopen('.cvs_up', 'w');
                fwrite($fp, "#!/bin/sh \n");
                fwrite($fp, "cd $path\n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot login \n");
                fwrite($fp, "sleep 3 \n");
                fclose($fp);
                chmod('.cvs_up', 0777);
                exec("xterm -e .cvs_up");
            }
		}
		else
		{
			new Dialog(_a('Server connection parameters are lacking'));
		}
	}

*/
	/**
	 * Logs out from cvs server
	 */
/*	function CVSLogout()
	{
		$selecao = $this->cvs->selection[0];
		$Arquivo = $this->cvs->node_get_row_data($selecao);
		$user   = $Arquivo['cvs_user'];
		$server = $Arquivo['server'];
        $path   = $Arquivo['directory'];

		if ($user && $server)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $fp = fopen('cvs_up.bat', 'w');
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot logout \n");
                fwrite($fp, "sleep 3 \n");
                fwrite($fp, "exit\n");
                fclose($fp);
                exec("start cvs_up.bat >NULL &");
            }
            else
            {
                $fp = fopen('.cvs_up', 'w');
                fwrite($fp, "#!/bin/sh \n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot logout \n");
                fwrite($fp, "sleep 3 \n");
                fclose($fp);
                chmod('.cvs_up', 0777);
                exec("xterm -e .cvs_up");
            }
		}
		else
		{
			new Dialog(_a('Server connection parameters are lacking'));
		}
	}
*/
	/**
	 * Checkout the cvs server
	 */
/*	function CVSCheckout()
	{
		$selecao = $this->cvs->selection[0];
		$Arquivo = $this->cvs->node_get_row_data($selecao);
		$user   = $Arquivo['cvs_user'];
		$server = $Arquivo['server'];
        $path   = get_parent_dir($Arquivo['directory']);
        $project= $Arquivo['Project'];

		if ($user && $server)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $fp = fopen('cvs_up.bat', 'w');
                fwrite($fp, "cd $path\n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot login \n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot co $project \n");
                fwrite($fp, "exit\n");
                fclose($fp);
                exec("start /wait cvs_up.bat >NULL &");
            }
            else
            {
                $fp = fopen('.cvs_up', 'w');
                fwrite($fp, "#!/bin/sh \n");
                fwrite($fp, "cd $path\n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot login \n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot co $project \n");
                fwrite($fp, "sleep 3 \n");
                fclose($fp);
                chmod('.cvs_up', 0777);
                exec("xterm -e .cvs_up");
            }
            sleep(3);
            $this->ReloadTree();
		}
		else
		{
			new Dialog(_a('Server connection parameters are lacking'));
		}
	}
*/
	/**
	 * Creates a new cvs file and submits (cvs add + cvs commit)
	 */
/*	function CVSNovo()
	{
		$project = $this->GetProject();
		$user   = $this->Projects[$project]['cvs_user'];
		$server = $this->Projects[$project]['server'];
		$file = $this->GetFileName();
		$path = GetPath($file);
		$file = GetFileName($file);

		if ($file && $user && $server)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $fp = fopen('cvs_up.bat', 'w');
                fwrite($fp, "cd $path\n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot add $file \n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot commit $file \n");
                fwrite($fp, "exit\n");
                fclose($fp);
                exec("start cvs_up.bat >NULL &");
            }
            else
            {
                $fp = fopen('.cvs_up', 'w');
                fwrite($fp, "#!/bin/sh \n");
                fwrite($fp, "cd $path\n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot add $file \n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot commit $file \n");
                fwrite($fp, "sleep 3 \n");
                fclose($fp);
                chmod('.cvs_up', 0777);
                exec("xterm -e .cvs_up");
            }
            new Dialog(_a('File Updated'));
		}
		else
		{
			new Dialog(_a('Server connection parameters are lacking'));
		}
	}
*/
	/**
	 * Updates the cvs file (cvs commit)
	 */
/*	function CVSAtual()
	{
		$project = $this->GetProject();
		$user   = $this->Projects[$project]['cvs_user'];
		$server = $this->Projects[$project]['server'];
		$file = $this->GetFileName();
		$path = GetPath($file);
		$file = GetFileName($file);

		if ($file && $user && $server)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $fp = fopen('cvs_up.bat', 'w');
                fwrite($fp, "cd $path\n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot commit $file \n");
                fwrite($fp, "exit\n");
                fclose($fp);
                exec("start cvs_up.bat >NULL &");
            }
            else
            {
                $fp = fopen('.cvs_up', 'w');
                fwrite($fp, "#!/bin/sh \n");
                fwrite($fp, "cd $path\n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot commit $file \n");
                fwrite($fp, "sleep 3 \n");
                fclose($fp);
                chmod('.cvs_up', 0777);
                exec("xterm -e .cvs_up");
            }
            new Dialog(_a('File Updated'));
		}
		else
		{
			new Dialog(_a('Server connection parameters are lacking'));
		}
	}
*/
	/**
	 * Updates the cvs file (cvs commit)
	 */
/*	function CVSLock()
	{
		$project = $this->GetProject();
		$user   = $this->Projects[$project]['cvs_user'];
		$server = $this->Projects[$project]['server'];
		$file = $this->GetFileName();
		$path = GetPath($file);
		$file = GetFileName($file);

        #cvs -d /cvsrep admin -l proj/file.doc

		if ($file && $user && $server)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $fp = fopen('cvs_up.bat', 'w');
                fwrite($fp, "cd $path\n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot admin -l $file \n");
                fwrite($fp, "exit\n");
                fclose($fp);
                exec("start cvs_up.bat >NULL &");
            }
            else
            {
                $fp = fopen('.cvs_up', 'w');
                fwrite($fp, "#!/bin/sh \n");
                fwrite($fp, "cd $path\n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot admin -l $file \n");
                fwrite($fp, "sleep 3 \n");
                fclose($fp);
                chmod('.cvs_up', 0777);
                exec("xterm -e .cvs_up");
            }
            new Dialog(_a('File Updated'));
		}
		else
		{
			new Dialog(_a('Server connection parameters are lacking'));
		}
	}
*/
	/**
	 * Updates the cvs file (cvs commit)
	 */
/*	function CVSUnlock()
	{
		$project = $this->GetProject();
		$user   = $this->Projects[$project]['cvs_user'];
		$server = $this->Projects[$project]['server'];
		$file = $this->GetFileName();
		$path = GetPath($file);
		$file = GetFileName($file);

		if ($file && $user && $server)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $fp = fopen('cvs_up.bat', 'w');
                fwrite($fp, "cd $path\n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot admin -u $file \n");
                fwrite($fp, "exit\n");
                fclose($fp);
                exec("start cvs_up.bat >NULL &");
            }
            else
            {
                $fp = fopen('.cvs_up', 'w');
                fwrite($fp, "#!/bin/sh \n");
                fwrite($fp, "cd $path\n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot admin -u $file \n");
                fwrite($fp, "sleep 3 \n");
                fclose($fp);
                chmod('.cvs_up', 0777);
                exec("xterm -e .cvs_up");
            }
            new Dialog(_a('File Updated'));
		}
		else
		{
			new Dialog(_a('Server connection parameters are lacking'));
		}
	}
*/
	/**
	 * Delete file and remove from cvs (unlink + cvs delete + cvs commit)
	 */
/*	function CVSDelete()
	{
		$project = $this->GetProject();
		$user   = $this->Projects[$project]['cvs_user'];
		$server = $this->Projects[$project]['server'];
		$file = $this->GetFileName();
		$path = GetPath($file);
		$file = GetFileName($file);

		if ($file && $user && $server)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $fp = fopen('cvs_up.bat', 'w');
                fwrite($fp, "cd $path\n");
                fwrite($fp, "rm $file \n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot remove $file \n");
                fwrite($fp, "c:\\PhpGtkEditor\\cvs.exe -d:pserver:$user@$server:/home/cvsroot commit $file \n");
                fwrite($fp, "exit\n");
                fclose($fp);
                exec("start cvs_up.bat >NULL &");
            }
            else
            {
                $fp = fopen('.cvs_up', 'w');
                fwrite($fp, "#!/bin/sh \n");
                fwrite($fp, "cd $path\n");
                fwrite($fp, "rm $file \n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot remove $file \n");
                fwrite($fp, "cvs -d:pserver:$user@$server:/home/cvsroot commit $file \n");
                fwrite($fp, "sleep 3 \n");
                fclose($fp);
                chmod('.cvs_up', 0777);
                exec("xterm -e .cvs_up");
            }
		}
		else
		{
			new Dialog(_a('Server connection parameters are lacking'));
		}
	}
*/
	/**
	 * Updates a file on the ftp server (ftp put)
	 */
	function FTPUpload()
	{
		$project = $this->GetProject();
		$user    = $this->Projects[$project]['ftp_user'];
		$ip      = $this->Projects[$project]['ftp_ip'];
        $dir     = $this->Projects[$project]['ftp_dir'];
		$pass    = base64_decode($this->Projects[$project]['ftp_pass']);
		$file = $this->GetFileName();
		$path = GetPath($file);
		$file = GetFileName($file);
        if (!$file)
        {
            new Dialog(_a('No File Opened'));
            return;
        }
        $pathl = win2lin($path);

		if ($user && $ip && $pass)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $path=(substr($path,-1)=='\\') ? substr($path,0, -1) : $path;
				$fp = fopen('ftp_up.scr', 'w');
                fwrite($fp, "$user\n");
                fwrite($fp, "$pass\n");
				fwrite($fp, "bin \n");
				fwrite($fp, "hash \n");
                fwrite($fp, "lcd $path\n");
				fwrite($fp, "cd $dir\n");
				fwrite($fp, "put $file \n");
				fwrite($fp, "bye \n");
				fwrite($fp, "quit\n");
				fclose($fp);
				exec("ftp -s:ftp_up.scr $ip >NULL &");
            }
            else
            {
				$fp = fopen('.ftp_up', 'w');
				fwrite($fp, "#!/bin/sh \n");
				fwrite($fp, "ftp -n $ip <<End-Of-Session \n");
				fwrite($fp, "user $user $pass \n");
				fwrite($fp, "bin \n");
				fwrite($fp, "hash \n");
				fwrite($fp, "bell \n");
                fwrite($fp, "lcd $path\n");
				fwrite($fp, "cd $dir\n");
				fwrite($fp, "put $file \n");
				fwrite($fp, "bye \n");
				fwrite($fp, "End-Of-Session \n");
				fwrite($fp, "sleep 1 \n");
				fclose($fp);
				chmod('.ftp_up', 0777);
				exec("./.ftp_up >/dev/null &");
            }
            new Dialog(_a('File Updated'));
		}
        else
        {
            new Dialog(_a('Server connection parameters are lacking'));
        }
	}

	/**
	 * Updates a file on the ftp server (ftp put)
	 */
	function FTPDownload()
	{
		$project = $this->GetProject();
		$user    = $this->Projects[$project]['ftp_user'];
		$ip      = $this->Projects[$project]['ftp_ip'];
        $dir     = $this->Projects[$project]['ftp_dir'];
		$pass    = base64_decode($this->Projects[$project]['ftp_pass']);
		$file = $this->GetFileName();
		$path = GetPath($file);
		$file = GetFileName($file);
        $scintilla = $this->GetScintilla();
        $pathl = win2lin($path);

        if (!$file)
        {
            new Dialog(_a('No File Opened'));
            return;
        }

		if ($user && $ip && $pass)
		{
            if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
            {
                $path=(substr($path,-1)=='\\') ? substr($path,0, -1) : $path;
				$fp = fopen('ftp_down.scr', 'w');
                fwrite($fp, "$user\n");
                fwrite($fp, "$pass\n");
				fwrite($fp, "bin \n");
				fwrite($fp, "hash \n");
                fwrite($fp, "cd $dir\n");
				fwrite($fp, "lcd $path\n");
				fwrite($fp, "get $file \n");
				fwrite($fp, "bye \n");
				fwrite($fp, "quit\n");
				fclose($fp);
				exec("ftp -s:ftp_down.scr $ip >NULL &");
            }
            else
            {
				$fp = fopen('.ftp_down', 'w');
				fwrite($fp, "#!/bin/sh \n");
				fwrite($fp, "ftp -n $ip <<End-Of-Session \n");
				fwrite($fp, "user $user $pass \n");
				fwrite($fp, "bin \n");
				fwrite($fp, "hash \n");
				fwrite($fp, "bell \n");
                fwrite($fp, "cd $dir\n");
				fwrite($fp, "lcd $path\n");
				fwrite($fp, "get $file \n");
				fwrite($fp, "bye \n");
				fwrite($fp, "End-Of-Session \n");
				fclose($fp);
				chmod('.ftp_down', 0777);
				exec("./.ftp_down >/dev/null &");
            }
            sleep(2);
            $file = $this->GetFileName(); //necessario caminho completo.
            $scintilla->Open($file);
            new Dialog(_a('File Updated'));
		}
        else
        {
            new Dialog(_a('Server connection parameters are lacking'));
        }
	}


	/**
	 * Deletes a file on the ftp server (ftp del)
	 * File isn't removed locally
	 */
	function FTPDelete()
	{
		$project = $this->GetProject();
		$user    = $this->Projects[$project]['ftp_user'];
		$ip      = $this->Projects[$project]['ftp_ip'];
		$pass    = base64_decode($this->Projects[$project]['ftp_pass']);

		$file   = $this->GetFileName();

		$fp = fopen('.ftp_up', 'w');
		fwrite($fp, "#!/bin/sh \n");
		fwrite($fp, "ftp -n $ip <<End-Of-Session \n");
		fwrite($fp, "user $user $pass \n");
		fwrite($fp, "asc \n");
		fwrite($fp, "hash \n");
		fwrite($fp, "bell \n");
		fwrite($fp, "pwd \n");
		fwrite($fp, "del $file \n");

		fwrite($fp, "bye \n");
		fwrite($fp, "End-Of-Session \n");
		fwrite($fp, "sleep 1 \n");

		fclose($fp);
		chmod('.ftp_up', 0777);
		if ($user)
			exec('.ftp_up');
	}

	/**
	 * Fires a toggle?
	 */
	function FireTog1()
	{
		if (!$this->Toggled)
		{
			$this->view->set_active(true);
		}
		else
		{
			$this->view->set_active(false);
		}
	}

	/**
	 * Fires a toggle
	 */
	function FireTog2()
	{
		if (!$this->Toggled)
		{
			$this->SubitemC->set_active(true);
		}
		else
		{
			$this->SubitemC->set_active(false);
		}
		$this->TogView();
	}

	/**
	 * ??? apresenta ou esconde o painel de arquivos esquerdo
	 */
	function TogView()
	{
		$this->Toggled = !$this->Toggled;
		if ($this->Toggled)
		{
			$this->paned->set_position(200);
		}
		else
		{
			$this->paned->set_position(0);
		}
		return;
	}

	/**
	 * Saves workspace. Saves all names of files currently locked into
	 * workspace.txt file.
	 */
	function SaveWork()
	{
		$fp = fopen('workspace.txt','w');
		if ($fp)
		{
			if ($this->Locks)
			{
				foreach ($this->Locks as $key => $Lock)
				{
					if ($Lock)
					{
						fwrite($fp, $key . "\n");
					}
				}
			}
			fclose($fp);
			new Dialog(_a('Workspace Saved'));
		}
		else
		{
			new Dialog(_a('Permission denied'));
		}
	}

	/**
	 * Open Recent Opened Files
	 */
    function OpenRecent()
    {
        if (file_exists('recent.txt'))
        {
            $fp = fopen('recent.txt','r');
            $n = 0;
            $this->Recent = null;
            while ($line = fgets($fp, 500))
            {
                $line = ereg_replace("\n", '', $line);
                $this->Recent[$n] = $line;
                $n ++;
            }
            fclose($fp);
        }
    }

	/**
	 * Save Recent Opened Files
	 */
	function SaveRecent($FileName)
	{
        $count = count($this->Recent);
        if ($count < 10)
        {
            $this->Recent[$count] = $FileName;
        }
        else
        {
            foreach ($this->Recent as $key => $content)
            {
                if ($key >0)
                {
                    $recent[$key-1] = $content;
                }
            }
            $this->Recent = $recent;
            $this->Recent[9] = $FileName;
        }

        $recent = $this->Recent;
		$fp = fopen('recent.txt','w');
		if ($fp)
		{
			if ($recent)
			{
				foreach ($recent as $key => $content)
				{
                    if (trim($content))
                    {
                        fwrite($fp, $content . "\n");
                    }
				}
			}
			fclose($fp);
		}
        $this->SetMenuRecent();
	}


	function SetMenuRecent()
    {
        global $Pixmaps;
        $recent = $this->Recent;

        if ($recent)
        {
            $SubMenu = &new GtkMenu;
            $this->MenuRecent->remove_submenu();//ver linha 493 em menu(); 
            foreach ($recent as $key => $content)
            {
                $posicao = strpos($content, '.');//content tem o endereo do arquivo com o nome.ext
                $ext = substr($content, $posicao+1);
                $ico = $Pixmaps[$ext];
                if (!$ico)
                    $ico = $Pixmaps['generic'];//deve ser o endereo do icone
                                           // ($img, $label, $function, $param = null)
                $item = new MyNormalMenuItem($ico, $content, array(&$this, 'AbrirRecent'), $content);
                $SubMenu->append($item);
               
            }
            $SubMenu->show_all();
            $this->MenuRecent->set_submenu($SubMenu); 
        }
    }

	/**
	 * Tests a file by executing it as a php file (debug function)
	 */
    function TestFile()
    {
        $scintilla = $this->GetScintilla();
        if (!$scintilla)
        {
            return null;
        }

        $filename = $this->GetFileName();
        if (substr($filename,0,1) == '*')
        {
            new Dialog(_a('File not Saved'));
        }
        else if (file_exists($filename))
        {
            if (strtoupper(substr(PHP_OS, 0, 3)) != 'WIN')
            {
                $php_cmd = $_ENV['_'];
                exec("$php_cmd -q $filename", $array);
            }
            else
            {
                exec("php\\php -q $filename", $array);
            }

            $error_msg = false;
            if ($array)
            {
                foreach ($array as $a)
                {

                    $result = null;
                    for ($n=$line; $n<=strlen($a); $n++)
                    {
                        $char = substr($a,$n,1);
                        if (is_numeric($char))
                        {
                            $result .= $char;
                        }
                    }
                    $scintilla->goto_line($result -1);
                    $scintilla->grab_focus();

                    $pos = $scintilla->position_from_line($result -1);
                    $scintilla->set_selection_start($pos);
                    $scintilla->set_selection_end($pos + strlen($scintilla->get_line($result -1)));
                    $return[] = RemoveTags($a);
                    $error_msg = true;
                }
            }
            if ($error_msg)
            {
                if ($this->terminal)
                {
                    //$this->terminal->Load($return);
                    $this->terminal = new MyTerminal($return);
                }
                else
                {
                    $this->terminal = new MyTerminal($return);
                }
            }
            else
            {
                new Dialog('No Errors');
            }
        }
    }

	/**
	 * Tries to launch a browser to see the current file as seen by a browser
	 * Much like a "preview" function
	 */
    function Highlight()
    {
        $filename = $this->GetFileName();
        if (substr($filename,0,1) == '*')
        {
            new Dialog(_a('File not Saved'));
        }
        else if (file_exists($filename))
        {
            $string = highlight_file($filename, true);

            $fp = fopen('.highlight.html', 'w');
            fwrite($fp, $string);
            fclose($fp);
            $cwd = getcwd();
            $filename = $cwd . "/.highlight.html";

            if (strtoupper(substr(PHP_OS, 0, 3)) != 'WIN')
            {
                if (file_exists('/usr/bin/mozilla'))
                {
                    $a = exec("mozilla $filename >/dev/null &");
                }
                else
                {
                    $a = exec("konqueror $filename >/dev/null &");
                }
            }
            else
            {
                //if (PHP_OS != 'WINNT')
                {
                    $a = exec("explorer .highlight.html >NULL &");
                }
            }
        }
    }
    
    function onExpand()
    {
        $scintilla = $this->GetScintilla();
        if ($scintilla)
        {
            //$scintilla->show_lines(0, $scintilla->get_line_count());
            $scintilla->expand_all();
        }
    }
    
    function onCollapse()
    {
        $scintilla = $this->GetScintilla();
        if ($scintilla)
        {
            $scintilla->collapse_all();
        }
    }
    
    function Report()
    {
        /** Instance the parser */
        $parser = new Parser();
        if (file_exists($this->GetFileName()))
        {
            /** Set the path to the script, class to parse. */
            $parser->set_archivo($this->GetFileName());
            
            /** Set the colors of the headers, left panel and font of headers */
            $parser->set_colores('#003399','#0099CC','#FFFFFF');
            
            /** Parse the script, class. */
            $parser->parse();
            
            /** Show the report */
            //echo 
            $parser->ver_reporte();
        }
    }

    function Preferences()
    {
        $this->pwindow = &new GtkWindow;
        $this->pwindow->connect('delete-event', array(&$this, 'Hide'));
        $this->pwindow->connect_simple('key_press_event', array(&$this,'KeyTest'), $this->pwindow);
        $this->pwindow->set_title(_a('Preferences'));
        $this->pwindow->set_position(GTK_WIN_POS_CENTER);
        $this->pwindow->set_default_size(668,480);
        $this->pwindow->realize();
        $hbox = new GtkHBox;
        $this->pwindow->add($hbox);
        $this->ReadProfiles();
        $profiles = $this->Profiles;

        $desc[0] = 'php_coment';
        $desc[1] = 'php_variable';
        $desc[2] = 'php_number';
        $desc[3] = 'php_operator';
        $desc[4] = 'php_keyword';
        $desc[5] = 'php_string';
        $desc[6] = 'html_unquoted';
        $desc[7] = 'html_php';
        $desc[8] = 'html_script';
        $desc[9] = 'html_comment';
        $desc[10] = 'html_string';
        $desc[11] = 'html_number';
        $desc[12] = 'html_att_unknown';
        $desc[13] = 'html_att';
        $desc[14] = 'html_tag_unkown';
        $desc[15] = 'html_tag';
        $desc[16] = 'background';
        $desc[17] = 'caret';

        foreach ($profiles as $key => $vetores)
        {
            $content = $vetores['colors'];
            $i = 0;
            $Vars[$key][] = array($vetores['font'], _a('Font'), false, 'gtkfont', true);
            foreach ($content as $var => $value)
            {
                $Vars[$key][] = array($value, $desc[$i], false, 'colors', false);
                $atts[$var] = true;
                $i ++;
            }
        }

        $i = 0;
        $Plus[]= array('', _a('Font'), false, 'gtkfont', true);
        foreach ($desc as $desci)
        {
            $Plus[] = array('#FFFFFF', $desci, false, 'colors', false);
            $i ++;
        }

        $slot_ok = array(&$this, 'onPreferences');
        $slot_del= array(&$this, 'DeleteProfile');
        $this->Colors = &new Preferences(&$hbox);
        $this->Colors->SetTitleImage(images . 'setup.xpm');
        $this->Colors->SetTitle(_a('Preferences'));
        $this->Colors->SetPlus($Plus);
        $this->Colors->SetSaveButton(true);
        $this->Colors->SetOk($slot_ok, _a('Apply'));
        $this->Colors->SetDel($slot_del);
        $this->Colors->SetStatus(_a('Loaded from profiles directory'));
        $this->Colors->SetPixmap(images . 'ico_png.xpm');
        $this->Colors->SetListTitle(_a('Profile Name'));
        $this->Colors->BuildForms($Vars);

        $this->pwindow->show_all();
    }
    
    function KeyTest($p1, $window)
    {
        if ($p1->keyval == K_ESC)
        {
            $window->hide();
        }
    }
  
  	/**
	 * Method to erase a profile file when the user clicks the button to do so
	 */
    function DeleteProfile()
    {
        $profile = $this->Colors->Current();
        @unlink("profiles/$profile");
    }
  
    function onPreferences()
    {
        $return = $this->Colors->GetVars();
        $profile = key($return);
        $schema = $return[$profile];
        $this->pwindow->Hide();

        $font                    = $schema[0];
        $colors['php_coment']    = $schema[1];
        $colors['php_variable']  = $schema[2];
        $colors['php_number']    = $schema[3];
        $colors['php_operator']  = $schema[4];
        $colors['php_keyword']   = $schema[5];
        $colors['php_string']    = $schema[6];
        $colors['html_unquoted'] = $schema[7];
        $colors['html_php']      = $schema[8];
        $colors['html_script']   = $schema[9];
        $colors['html_comment']  = $schema[10];
        $colors['html_string']   = $schema[11];
        $colors['html_number']   = $schema[12];
        $colors['html_att_unknown']  = $schema[13];
        $colors['html_att']       = $schema[14];
        $colors['html_tag_unkown']= $schema[15];
        $colors['html_tag']       = $schema[16];
        $colors['background']     = $schema[17];
        $colors['caret']     = $schema[18];

        $fd = fopen ("profiles/{$profile}", "w");
        if ($fd)
        {
            fwrite ($fd, "<?\n");
            fwrite ($fd, "\$font                    =  '" .   $schema[0] . "';\n");
            fwrite ($fd, "\$colors['php_coment']    =  '" .   $schema[1] . "';\n");
            fwrite ($fd, "\$colors['php_variable']  =  '" .   $schema[2] . "';\n");
            fwrite ($fd, "\$colors['php_number']    =  '" .   $schema[3] . "';\n");
            fwrite ($fd, "\$colors['php_operator']  =  '" .   $schema[4] . "';\n");
            fwrite ($fd, "\$colors['php_keyword']   =  '" .   $schema[5] . "';\n");
            fwrite ($fd, "\$colors['php_string']    =  '" .   $schema[6] . "';\n");
            fwrite ($fd, "\$colors['html_unquoted'] =  '" .   $schema[7] . "';\n");
            fwrite ($fd, "\$colors['html_php']      =  '" .   $schema[8] . "';\n");
            fwrite ($fd, "\$colors['html_script']   =  '" .   $schema[9] . "';\n");
            fwrite ($fd, "\$colors['html_comment']  =  '" .   $schema[10] . "';\n");
            fwrite ($fd, "\$colors['html_string']   =  '" .   $schema[11] . "';\n");
            fwrite ($fd, "\$colors['html_number']   =  '" .   $schema[12] . "';\n");
            fwrite ($fd, "\$colors['html_att_unknown']= '" .  $schema[13] . "';\n");
            fwrite ($fd, "\$colors['html_att']       = '" .   $schema[14] . "';\n");
            fwrite ($fd, "\$colors['html_tag_unkown']= '" .   $schema[15] . "';\n");
            fwrite ($fd, "\$colors['html_tag']       = '" .   $schema[16] . "';\n");
            fwrite ($fd, "\$colors['background']     = '" .   $schema[17] . "';\n");
            fwrite ($fd, "\$colors['caret']           = '" .  $schema[18] . "';\n");
            fwrite ($fd, "?>");
        }
        fclose($fd);
        $Theme = $this->Theme;
        $Language= $this->Language;
        $Profile = $profile;

        $fd = fopen ('setup.inc', "w");
        if ($fd)
        {
            fwrite ($fd, "<?\n");
            fwrite ($fd, "  \$Theme='$Theme';\n");
            fwrite ($fd, "  \$Language='$Language';\n");
            fwrite ($fd, "  \$Profile='$Profile';\n");
            fwrite ($fd, "?>\n");
        }
        fclose($fd);
        $this->Profiles[$profile]['colors'] = $colors;
        $this->Profiles[$profile]['font'] = $font;
        $this->Profile = $profile;
        $this->pwindow->hide();
        $this->ApplyColors($this->Profiles[$profile]);
    }
    
    function Hide($window)
    {
        $window->hide();
    }

    function Projects()
    {   echo "\nPhpGtkEditor.class montando a tela projects() 3396 ";
        $this->prwindow = &new GtkWindow;
        $this->prwindow->connect('delete-event', array(&$this, 'Hide'));
        $this->prwindow->connect_simple('key_press_event', array(&$this,'KeyTest'), $this->prwindow);
        $this->prwindow->set_title(_a('Projects'));
        $this->prwindow->set_position(GTK_WIN_POS_CENTER);
        $this->prwindow->set_default_size(668,546);
        $this->prwindow->realize();
        $hbox = new GtkHBox;
        $this->prwindow->add($hbox);
        $this->ReadProjects();
        $projects = $this->Projects;

        $desc[0] = _a('Project Path');
        $desc[1] = _a('Remote Editing Server');
        $desc[2] = _a('FTP Server IP');
        $desc[3] = _a('FTP Server User');
        $desc[4] = _a('FTP Server Password');
        $desc[5] = _a('FTP Server Path');
        $desc[6] = _a('CVS Server');
        $desc[7] = _a('CVS User');
        $desc[8] = _a('Database IP');
        $desc[9] = _a('Database User');
        $desc[10] = _a('Database Password');
        $desc[11] = _a('Database Name');
        $desc[12] = _a('Database Type');
        $desc[13] = _a('Icon') . ' .xpm (16x16)';
        
        $tooltip[1] = _a('Apache Server where PhpGtkEditor Service is running, example ^1 or ^2', '"192.168.0.62"', '"192.168.0.62/dir"');
        $tooltip[5] = _a('Path in the FTP Server that will be used to send this project files');

        foreach ($projects as $key => $content)
        {
            $i = 0;
            foreach ($content as $var => $value)
            {
                $pass = false;
                $kind = null;
                $edit = true;
                if ($var == 'db_pass' or $var == 'ftp_pass' )
                {
                    $pass = true;
                    $value = base64_decode($value);
                }
                if ($var == 'db_type')
                {
                    $kind = array('pgsql', 'mysql');
                    $edit = false;
                }
                if ($var == 'directory')
                {
                    $kind = 'files2';
                }
                if ($var == 'icon')
                {
                    $kind = 'files';
                }
                $Vars[$key][] = array($value, $desc[$i], $pass, $kind, $edit, $tooltip[$i]);
                $atts[$var] = true;
                $i ++;
            }
        }

        foreach ($desc as $key => $desc)
        //foreach ($atts as $var => $att)
        {
            $pass = false;
            $kind = null;
            $edit = true;
            if (($key == 4) or ($key == 10))
            {
                $pass = true;
                $value = base64_decode($value);
            }
            if ($key == 12)
            {
                $kind = array('pgsql', 'mysql');
                $edit = false;
            }
            if ($key == 0)
            {
                $kind = 'files2';
            }
            if ($key == 13)
            {
                $kind = 'files';
            }
            if ($key == 1)
            {
                $value = 'http://';
            }
            $Plus[] = array('', $desc, $pass, $kind, $edit);
        }

        $slot_ok = array(&$this, 'onProjects');
        $slot_del= array(&$this, 'DeleteProject');
        $this->Colors = &new Preferences(&$hbox);
        $this->Colors->SetTitleImage(images . 'project_bar.xpm');
        $this->Colors->SetTitle(_a('Projects'));
        $this->Colors->SetPlus($Plus);
        $this->Colors->SetSaveButton(true);
        $this->Colors->SetOk($slot_ok, _a('Save'));
        $this->Colors->SetDel($slot_del);
        $this->Colors->SetStatus(_a('Loaded from Projects directory'));
        $this->Colors->SetPixmap(images . 'projects.xpm');
        $this->Colors->SetListTitle(_a('Project Name'));
        $this->Colors->BuildForms($Vars);

        $this->prwindow->show_all();
    }

  	/**
	 * Method to erase a project file when the user clicks the button to do so
	 */
    function DeleteProject()
    {
        $project = $this->Colors->Current();
        @unlink("projects/$project");
    }
  
    function onProjects()
    {
        $return = $this->Colors->GetVars();
        $project = key($return);
        $schema = $return[$project];

        $projects['directory']   = $schema[0];
        $projects['remote']      = $schema[1];
        $projects['ftp_ip']      = $schema[2];
        $projects['ftp_user']    = $schema[3];
        $projects['ftp_pass']    = $schema[4];
        $projects['ftp_dir']     = $schema[5];
        $projects['server']      = $schema[6];
        $projects['cvs_user']    = $schema[7];
        $projects['db_ip']       = $schema[8];
        $projects['db_user']     = $schema[9];
        $projects['db_pass']     = $schema[10];
        $projects['db_name']     = $schema[11];
        $projects['db_type']     = $schema[12];
        $projects['icon']        = $schema[13];

        $fd = fopen ("projects/{$project}", "w");
        if ($fd)
        {
            fwrite ($fd, "<?\n");
            fwrite ($fd, "\$directory               =  '" .   $schema[0] . "';\n");
            fwrite ($fd, "\$remote                  =  '" .   $schema[1] . "';\n");
            fwrite ($fd, "\$ftp_ip                  =  '" .   $schema[2] . "';\n");
            fwrite ($fd, "\$ftp_user                =  '" .   $schema[3] . "';\n");
            fwrite ($fd, "\$ftp_pass                =  '" .   base64_encode($schema[4]) . "';\n");
            fwrite ($fd, "\$ftp_dir                 =  '" .   $schema[5] . "';\n");
            fwrite ($fd, "\$server                  =  '" .   $schema[6] . "';\n");
            fwrite ($fd, "\$cvs_user                =  '" .   $schema[7] . "';\n");
            fwrite ($fd, "\$db_ip                   =  '" .   $schema[8] . "';\n");
            fwrite ($fd, "\$db_user                 =  '" .   $schema[9] . "';\n");
            fwrite ($fd, "\$db_pass                 =  '" .   base64_encode($schema[10]) . "';\n");
            fwrite ($fd, "\$db_name                 =  '" .   $schema[11] . "';\n");
            fwrite ($fd, "\$db_type                 =  '" .   $schema[12]. "';\n");
            fwrite ($fd, "\$icon                    =  '" .   $schema[13]. "';\n");
            fwrite ($fd, "?>");
        }
        fclose($fd);
        $this->Projects[$project] = $projects;
        $this->prwindow->hide();
        $this->ReloadTree();
    }

}
?>