<?
/***********************************************************/
/* Tree handler, a wrapper for FileExplorer
/* by Pablo Dall'Oglio 2001-2006
/***********************************************************/
class TreeHandler extends GtkVBox
{
    /***********************************************************/
    /* Constructor Method
    /***********************************************************/
             //&new TreeHandler($this->db,  array(0 => 'Open'));
    function TreeHandler($FileTree, $names = null, $horizontal = false)
    {   
        parent::__construct();
        $this->boxparent = new GtkVBox();//cria un container vertical
        $this->horizontal = $horizontal;
        $this->FileTree = $FileTree; //recebe a arvore
        $scroll = new GtkScrolledWindow;//cria um scrol
        $view = new GtkViewPort; //cria um visualizador
        $hbox = new GtkHBox; //cria um container horizontal 
        $scroll->add($view);//o scrol recebe o visualizador
        $view->add($hbox);//no vizualizador inclui o container horizontal
        $hbox->pack_start($FileTree);//container horizontal recebe filetree
        $this->names = $names;
        if ($horizontal)//pergunta se  para ser horizontal
        {
            $this->boxparent = new GtkHBox();//se for cria um container horizontal com nome boxparent
        }
        else
        {
            $this->boxparent = new GtkVBox();//ou cria um container vertical 
        }
        $this->widget = $widget;

        parent::pack_start($scroll);//o handler recebe o scrol
        
        //$this->CreateMenu();
        $this->OpenAction = new GtkButton();
        $botao = $FileTree->BotaoOk;
        
//        $botao->connect_object('clicked', array(&$this, 'Pop'));

        parent::show_all();
        //return $this->parent;
    }

    /***********************************************************/
    /* Pop the File Explorer options
    /***********************************************************/
    function Pop()
    {
        $Menu = $this->Menu;
        $Menu->show_all();
        $Menu->popup(null, null, null, 1, 1);
    }

    /***********************************************************/
    /* Creates the PopMenu Options
    /***********************************************************/
    function CreateMenu()
    {
        global $Pixmaps;
        $this->Menu = $Menu = new GtkMenu;
        $names = $this->names;

        if (!$names)
        {
            $this->ItemOpen = $Menuitem1 = new MyNormalMenuItem($Pixmaps['menu_open'], _a('Open'), array(&$this, 'Open'));
            $this->ItemDel  = $Menuitem2 = new MyNormalMenuItem($Pixmaps['menu_del'], _a('Delete'), array(&$this, 'Delete'));
        }
        else
        {
            if ($names[0])
            {
                $this->ItemOpen = $Menuitem1 = new MyNormalMenuItem($names[0][0], _a($names[0][1]) , array(&$this, 'Open'));
            }
            
            if ($names[1])
            {
                $this->ItemDel  = $Menuitem2 = new MyNormalMenuItem($names[1][0], _a($names[1][1]), array(&$this, 'Delete'));
            }
        }
        
        
        $Menuitem3 = new GtkMenuItem;
        $Menuitem4 = new MyNormalMenuItem($Pixmaps['menu_close'], _a('Close'), null);

        $Menu->append($Menuitem1);
        if ($Menuitem2)
        {
            $Menu->append($Menuitem2);
        }
        $Menu->append($Menuitem3);
        $Menu->append($Menuitem4);
    }

    /***********************************************************/
    /* Creates the toolbar
    /***********************************************************/
    function CreateToolBar()
    {
        global $Pixmaps;
        $this->boxparent->realize();
        if ($this->horizontal)
            $ButtonBox = new GtkVBox;
        else
            $ButtonBox = new GtkHBox;

        $end_new=$Pixmaps['folder_new'];
        $end_open=$Pixmaps['file_open'];
        $end_del=$Pixmaps['file_del']; 
        
        $ButtonBox->pack_start($a = new Button(array(&$this, 'CreateFolder'),  _a('Create Folder'), $end_new, ICONBUTTON), false, false);
        $ButtonBox->pack_start($b = new Button(array(&$this, 'Open'),          _a('Open'),          $end_open,  ICONBUTTON), false, false);
        $ButtonBox->pack_start($c = new Button(array(&$this, 'Delete'),        _a('Delete'),        $end_del,   ICONBUTTON), false, false);

        $a->set_relief(Gtk::RELIEF_NONE);
        $b->set_relief(Gtk::RELIEF_NONE);
        $c->set_relief(Gtk::RELIEF_NONE);
        $this->boxparent->pack_start($ButtonBox);
       // parent::pack_start($ButtonBox);
        return $this->boxparent;
    }

    /***********************************************************/
    /* Complementary options
    /***********************************************************/
    function CreateToolBar2()
    {
        $this->boxparent->realize();
        $ButtonBox = new GtkHBox;
        $this->boxparent->pack_start($ButtonBox, false, false);
        $ButtonBox->pack_start(new GtkHBox);
        $pixmap = Gdk::pixmap_create_from_xpm($this->window, null, images . 'ico_require.xpm');
        $ButtonBox->pack_start($b = new Button(array(&$this, 'Open'),    _a('Apply'), $pixmap, IMAGEBUTTON), false, false);
        
        $b->set_relief(Gtk::RELIEF_NONE);
    }

    /***********************************************************/
    /* Asks by the Folder name
    /***********************************************************/
    function CreateFolder()
    {
        $FileTree = $this->FileTree;
        $node = $FileTree->get_selection(0);
        if ($node)
        {
            $info = $FileTree->node_get_row_data($node);
            if (is_dir($info))
            {
                $this->InputBox = new InputBox(_a('Folder Name'), 180, '');
                $button =  $this->InputBox->button;
                $button->connect_object('clicked', array(&$this,'MakeFolder'), $node, $info);
            }
            else
            {
                new Dialog(_a('Cannot create the directory'));
            }
        }
        else
        {
            $this->InputBox = new InputBox(_a('Folder Name'), 180, '');
            $button =  $this->InputBox->button;
            $button->connect_object('clicked', array(&$this,'MakeFolder'), null, $FileTree->entries[0]);
        }
    }

    /***********************************************************/
    /* Creates the folder
    /***********************************************************/
    function MakeFolder($node, $folder)
    {
        global $Pixmaps;
        $InputBox = $this->InputBox;
        $Item = $InputBox->InputEntry->get_text();
        $InputBox->Close();
        $FileTree = $this->FileTree;
        $Caminho =  $folder . bar . $Item;
        if (mkdir($Caminho))
        {
            $ico1 = $Pixmaps['folder1'];
            $ico2 = $Pixmaps['folder2'];
            $NodoPasta = $FileTree->insert_node($node, null, array($Item), 5, $ico1[0], $ico1[1], $ico2[0], $ico2[1], false, false);
            $FileTree->node_set_row_data($NodoPasta, $Caminho);
        }
        else
        {
            new Dialog(_a('Cannot create the directory'));
        }
    }

    /***********************************************************/
    /* Opens a node
    /***********************************************************/
    function Open()
    {
        $FileTree = $this->FileTree;
        $node = $FileTree->selection[0];
        if (!$node)
        {
            return;
        }

        $Menu = $this->Menu;
        if ($Menu)
        {
            $Menu->popdown();
        }
        
        $info = $FileTree->node_get_row_data($node);
        if (($info) &&  is_file($info))// arquivo
        {
            $ItemOpen = $this->OpenAction;
            $ItemOpen->emit('clicked');
        }
        else
        {
            $FileTree->expand($node);
        }
    }

    /***********************************************************/
    /* Deletes the selected node (file or dir)
    /***********************************************************/
    function Delete($flag = false)
    {
        $FileTree = $this->FileTree;
        $node = $FileTree->selection[0];
        
        if (!$flag)
        {
            $b = new Ask(_a('Do you really want to delete ?'), array(&$this,'Delete'), null, array(true));
            return true;
        }
        else
        {
            if ($node)
            {
                $info = $FileTree->node_get_row_data($node);
                if (is_file($info)) // arquivo
                {
                    $t1 = unlink($info);
                    if (!$t1)
                    {
                        new Dialog(_a('Cannot remove the file'));
                    }
                    else
                    {
                        $FileTree->remove_node($node);
                    }
                }
                else
                {
                    $t1 = rmdir($info);
                    if (!$t1)
                    {
                        new Dialog(_a('Cannot remove the directory'));
                    }
                    else
                    {
                        $FileTree->remove_node($node);
                    }
                }
            }
        }
    }
    
}
?>
