<?
// +-----------------------------------------------------------------+
// | Solis - Free Software Cooperative                               |
// | Copyleft (l) 2004,  Lajeado/RS - Brasil                         |
// +-----------------------------------------------------------------+
// | Licensed under GPL: www.fsf.org for further details             |
// |                                                                 |
// +-----------------------------------------------------------------+
// | Abstract: Classe para edicao de codigos PHP                     |
// |                                                                 |
// | Created by Pablo Dall'Oglio (pablo@php.net)                     |
// | Scintilla codes by Alan Knowles                                 |
// | Modificado por Helder Mauricio  para php-gtk2                   |
// +-----------------------------------------------------------------+


// Find flags
@define(  "SCINTILLA_FIND_DOWN"                     ,   1 ); 
@define(  "SCINTILLA_FIND_WHOLE_WORDS"              ,   2 ); 
@define(  "SCINTILLA_FIND_MATCH_CASE"               ,   4 ); 
@define(  "SCINTILLA_FIND_WORD_START"               ,   0x00100000 ); 
@define(  "SCINTILLA_FIND_REGEXP"                   ,   0x00200000 ); 
@define(  "SCINTILLA_LEXER_HTML"                    ,   4 );

// GtkScintillaStyle
@define(  "SCINTILLA_STYLE_DEFAULT"                 ,   32 ); 
@define(  "SCINTILLA_STYLE_LINE_NUMBER"             ,   33 ); 
@define(  "SCINTILLA_STYLE_BRACE_LIGHT"             ,   34 ); 
@define(  "SCINTILLA_STYLE_BRACE_BAD"               ,   35 ); 
@define(  "SCINTILLA_STYLE_CONTROL_CHAR"            ,   36 ); 
@define(  "SCINTILLA_STYLE_INDENT_GUIDE"            ,   37 ); 
@define(  "SCINTILLA_STYLE_MAX"                     ,   127 ); 

// LEXER_HTML Lexical states
@define(  "SCINTILLA_HTML_TEXT"                     ,   0 ); 
@define(  "SCINTILLA_HTML_TAG"                      ,   1 ); 
@define(  "SCINTILLA_HTML_TAG_UNKNOWN"              ,   2 ); 
@define(  "SCINTILLA_HTML_ATTRIBUTE"                ,   3 ); 
@define(  "SCINTILLA_HTML_ATTRIBUTE_UNKNOWN"        ,   4 ); 
@define(  "SCINTILLA_HTML_NUMBER"                   ,   5 ); 
@define(  "SCINTILLA_HTML_DOUBLE_STRING"            ,   6 ); 
@define(  "SCINTILLA_HTML_SINGLE_STRING"            ,   7 ); 
@define(  "SCINTILLA_HTML_OTHER"                    ,   8 ); 
@define(  "SCINTILLA_HTML_COMMENT"                  ,   9 ); 
@define(  "SCINTILLA_HTML_ENTITY"                   ,   10 ); 
@define(  "SCINTILLA_HTML_XML_TAG_END"              ,   11    ); 
@define(  "SCINTILLA_HTML_XML_ID_START"             ,   12    ); 
@define(  "SCINTILLA_HTML_XML_ID_END"               ,   13    ); 
@define(  "SCINTILLA_HTML_SCRIPT"                   ,   14 ); 
@define(  "SCINTILLA_HTML_ASP_1"                    ,   15  ); 
@define(  "SCINTILLA_HTML_ASP_2"                    ,   16   ); 
@define(  "SCINTILLA_HTML_CDATA"                    ,   17 ); 
@define(  "SCINTILLA_HTML_PHP"                      ,   18 ); 
@define(  "SCINTILLA_HTML_UNQUOTED"                 ,   19 ); 

// LEXER HTML :: Embedded Javascript
@define(  "SCINTILLA_HTML_JS_START"                 ,   40 ); 
@define(  "SCINTILLA_HTML_JS_DEFAULT"               ,   41 ); 
@define(  "SCINTILLA_HTML_JS_COMMENT_BLOCK"         ,   42 ); 
@define(  "SCINTILLA_HTML_JS_COMMENT_LINE"          ,   43 ); 
@define(  "SCINTILLA_HTML_JS_COMMENT_DOC"           ,   44 ); 
@define(  "SCINTILLA_HTML_JS_NUMBER"                ,   45 ); 
@define(  "SCINTILLA_HTML_JS_WORD"                  ,   46 ); 
@define(  "SCINTILLA_HTML_JS_KEYWORD"               ,   47 ); 
@define(  "SCINTILLA_HTML_JS_STRING_DOUBLE"         ,   48 ); 
@define(  "SCINTILLA_HTML_JS_STRING_SINGLE"         ,   49 ); 
@define(  "SCINTILLA_HTML_JS_SYMBOL"                ,   50 ); 
@define(  "SCINTILLA_HTML_JS_EOL"                   ,   51 ); 
@define(  "SCINTILLA_HTML_JS_REGEX"                 ,   52 ); 

// LEXER_HTML :: PHP
@define(  "SCINTILLA_HTML_PHP_DEFAULT"              ,   118 ); 
@define(  "SCINTILLA_HTML_PHP_STRING_DOUBLE"        ,   119 ); 
@define(  "SCINTILLA_HTML_PHP_STRING_SINGLE"        ,   120 ); 
@define(  "SCINTILLA_HTML_PHP_KEYWORD"              ,   121 ); 
@define(  "SCINTILLA_HTML_PHP_NUMBER"               ,   122 ); 
@define(  "SCINTILLA_HTML_PHP_VARIABLE"             ,   123 ); 
@define(  "SCINTILLA_HTML_PHP_COMMENT_BLOCK"        ,   124 ); 
@define(  "SCINTILLA_HTML_PHP_COMMENT_LINE"         ,   125 ); 
@define(  "SCINTILLA_HTML_PHP_EOL"                  ,   126 ); 
@define(  "SCINTILLA_HTML_PHP_OPERATOR"             ,   127 ); 

@define(  "SCINTILLA_PERL_WHITE_SPACE"              ,   0 ); 
@define(  "SCINTILLA_PERL_ERROR"                    ,   1 ); 
@define(  "SCINTILLA_PERL_COMMENT_LINE"             ,   2 ); 
@define(  "SCINTILLA_PERL_POD"                      ,   3 ); 
@define(  "SCINTILLA_PERL_NUMBER"                   ,   4 ); 
@define(  "SCINTILLA_PERL_KEYWORD"                  ,   5 ); 
@define(  "SCINTILLA_PERL_STRING"                   ,   6 ); 
@define(  "SCINTILLA_PERL_CHARACTER"                ,   7 ); 
@define(  "SCINTILLA_PERL_PUNCTUATION"              ,   8 ); 
@define(  "SCINTILLA_PERL_PREPROCESSOR"             ,   9 ); 
@define(  "SCINTILLA_PERL_OPERATOR"                 ,   10 ); 
@define(  "SCINTILLA_PERL_IDENTIFIER"               ,   11 ); 
@define(  "SCINTILLA_PERL_SCALAR"                   ,   12 ); 
@define(  "SCINTILLA_PERL_ARRAY"                    ,   13 ); 
@define(  "SCINTILLA_PERL_HASH"                     ,   14 ); 
@define(  "SCINTILLA_PERL_SYMBOL_TABLE"             ,   15 ); 
@define(  "SCINTILLA_PERL_REGEX"                    ,   17 ); 
@define(  "SCINTILLA_PERL_REGSUBST"                 ,   18 ); 
@define(  "SCINTILLA_PERL_LONG_QUOTE"               ,   19 ); 
@define(  "SCINTILLA_PERL_BACKTICKS"                ,   20 ); 
@define(  "SCINTILLA_PERL_DATA_SECTION"             ,   21 ); 
@define(  "SCINTILLA_PERL_HERE_DELIM"               ,   22 ); 
@define(  "SCINTILLA_PERL_HERE_Q"                   ,   23 ); 
@define(  "SCINTILLA_PERL_HERE_QQ"                  ,   24 ); 
@define(  "SCINTILLA_PERL_HERE_QX"                  ,   25 ); 
@define(  "SCINTILLA_PERL_STRING_Q"                 ,   26 ); 
@define(  "SCINTILLA_PERL_STRING_QQ"                ,   27 ); 
@define(  "SCINTILLA_PERL_STRING_QX"                ,   28 ); 
@define(  "SCINTILLA_PERL_STRING_QR"                ,   29 ); 
@define(  "SCINTILLA_PERL_STRING_QW"                ,   30 ); 

// LEXER_XML Lexical states
@define(  "SCINTILLA_XML_DEFAULT"                   ,   0 ); 
@define(  "SCINTILLA_XML_TAG"                       ,   1 ); 
@define(  "SCINTILLA_XML_TAG_UNKNOWN"               ,   2 ); 
@define(  "SCINTILLA_XML_ATTRIBUTE"                 ,   3 ); 
@define(  "SCINTILLA_XML_ATTRIBUTE_UNKNOWN"         ,   4 ); 
@define(  "SCINTILLA_XML_NUMBER"                    ,   5 ); 
@define(  "SCINTILLA_XML_DOUBLE_STRING"             ,   6 ); 
@define(  "SCINTILLA_XML_SINGLE_STRING"             ,   7 ); 
@define(  "SCINTILLA_XML_OTHER"                     ,   8 ); 
@define(  "SCINTILLA_XML_COMMENT"                   ,   9 ); 
@define(  "SCINTILLA_XML_ENTITY"                    ,   10 ); 
@define(  "SCINTILLA_XML_TAG_END"                   ,   11 ); 
@define(  "SCINTILLA_XML_ID_START"                  ,   12 ); 
@define(  "SCINTILLA_XML_ID_END"                    ,   13 ); 
@define(  "SCINTILLA_XML_CDATA"                     ,   17 ); 
@define(  "SCINTILLA_XML_QUESTION"                  ,   18 ); 
@define(  "SCINTILLA_XML_UNQUOTED"                  ,   19 ); 

// LEXER_SQL Lexical states
@define(  "SCINTILLA_SQL_WHITE_SPACE"               ,   0 ); 
@define(  "SCINTILLA_SQL_COMMENT_BLOCK"             ,   1 ); 
@define(  "SCINTILLA_SQL_COMMENT_LINE"              ,   2 ); 
@define(  "SCINTILLA_SQL_COMMENT_DOC"               ,   3 ); 
@define(  "SCINTILLA_SQL_NUMBER"                    ,   4 ); 
@define(  "SCINTILLA_SQL_KEYWORD"                   ,   5 ); 
@define(  "SCINTILLA_SQL_DOUBLE_STRING"             ,   6 ); 
@define(  "SCINTILLA_SQL_SINGLE_STRING"             ,   7 ); 
@define(  "SCINTILLA_SQL_SYMBOLS"                   ,   8 ); 
@define(  "SCINTILLA_SQL_PREPROCESSOR"              ,   9 ); 
@define(  "SCINTILLA_SQL_OPERATOR"                  ,   10 ); 
@define(  "SCINTILLA_SQL_IDENTIFIER"                ,   11 ); 
@define(  "SCINTILLA_SQL_STRING_EOL"                ,   12 ); 

// LEXER_DIFF Lexical states
@define(  "SCINTILLA_DIFF_DEFAULT"                  ,   0 ); 
@define(  "SCINTILLA_DIFF_COMMENT"                  ,   1 ); 
@define(  "SCINTILLA_DIFF_COMMAND"                  ,   2 ); 
@define(  "SCINTILLA_DIFF_FILES"                    ,   3 ); 
@define(  "SCINTILLA_DIFF_POSITION"                 ,   4 ); 
@define(  "SCINTILLA_DIFF_DEL_LINE"                 ,   5 ); 
@define(  "SCINTILLA_DIFF_ADD_LINE"                 ,   6 ); 

// LEXER_CONF Lexical states
@define(  "SCINTILLA_CONF_DEFAULT"                  ,   0 ); 
@define(  "SCINTILLA_CONF_COMMENT"                  ,   1 ); 
@define(  "SCINTILLA_CONF_NUMBER"                   ,   2 ); 
@define(  "SCINTILLA_CONF_IDENTIFIER"               ,   3 ); 
@define(  "SCINTILLA_CONF_EXTENSION"                ,   4 ); 
@define(  "SCINTILLA_CONF_PARAMETER"                ,   5 ); 
@define(  "SCINTILLA_CONF_STRING"                   ,   6 ); 
@define(  "SCINTILLA_CONF_OPERATOR"                 ,   7 ); 
@define(  "SCINTILLA_CONF_IP"                       ,   8 ); 
@define(  "SCINTILLA_CONF_DIRECTIVE"                ,   9 ); 

class ScintillaPHP extends GtkScintilla
{
    public $editor;
    
	function __construct($colors)
	{
		parent::__construct();
               
        parent::set_size_request(400, 200);
        
        parent::connect_simple('update_ui', array(&$this,'highlight_braces'));
		parent::connect_simple('char_added', array(&$this,'char_added'));
        parent::connect_simple('margin_click', array(&$this,'margin_click'));
		parent::set_margin_type_n(2, 0);
		parent::set_margin_width_n(2, 0);
		parent::set_margin_width_n(1, 20);
		parent::set_tab_indents(1);
		parent::set_backspace_unindents(1);
		parent::set_size_request(400, 200);
		//parent::use_pop_up(0);

		parent::set_sel_back(true,    11250603);
		parent::marker_set_back(true, 15908608);
        parent::set_caret_line_visible(true);
        parent::set_view_eol(0);
		parent::set_caret_width(2);
		parent::set_caret_period(250);

		$this->DefinePHP($colors);

		parent::set_tab_width(4);
		parent::set_use_tabs(0);
		parent::set_indent(4);
		parent::set_indentation_guides(1);
		parent::set_edge_mode(0);
		parent::set_edge_column(80);
		parent::set_edge_colour(8355712);
		parent::set_style_bits(7);
		parent::set_lexer(SCINTILLA_LEXER_HTML);
        //void show_lines(lineStart, lineEnd);
		parent::show_lines(0,parent::get_line_count());//mostra a linha de at 
		parent::show();
       
	}
    
	function Open($file)
	{
        $this->file = $file;
		parent::clear_all();
		if (file_exists($file))
		{
            $fd = fopen($file, 'r');
            while ($line = fgets($fd, 500))
            {
                $lines.= $line;
            }
            fclose($fd);

            $this->InsertLines($lines);
		}
		parent::empty_undo_buffer();
        parent::marker_set_fore(1, hexdec('FF0000'));
        parent::marker_set_fore(2, 21504);
	}

	function Load($lines)
	{
		parent::clear_all();
		if ($lines)
		{
            $this->InsertLines($lines);
		}
		parent::empty_undo_buffer();
        parent::marker_set_fore(1, hexdec('FF0000'));
        parent::marker_set_fore(2, 21504);
        //$this->group_braces($lines);
	}
    
    function InsertLines($lines)
    {
        // controls different line feeds.
        $lines = ereg_replace(chr(13).chr(10), chr(10), $lines);
        $lines = ereg_replace(chr(13), chr(10), $lines);
        $lines = explode(chr(10), $lines);
        $linesrev = array_reverse($lines);
        $count = count($linesrev);
        $n=1;
        foreach($linesrev as $line)
        {
            parent::insert_text(-1, $line);
            if ($n < $count)
            {
                parent::insert_text(-1, "\n");
            }
            $n ++;
        }
        $this->group_braces($lines);
    }

    function MarkCode($linestring)
    {
        $i = 0;
        //$linestring = array_reverse($linestring);
        foreach ($linestring as $line)
        {
            //echo $line . "\n";
            $pos1 = strpos($line, '{');
            $pos2 = strpos($line, '}');
            $posf = strpos($line, 'function');

            if ($posf !== false)
            {
                $posp = strpos($line, '(');
                $funcname = trim(substr($line, $posf + 9, $posp - ($posf + 9)));
                $open = true;
                $lastlevel = $level;
                //$funcnames[$level] = $funcname;
                parent::marker_add($i, 1);
                //echo "ok $i\n";
            }
            //echo "$i|$line";
            $i ++;
        }
    }

    function highlight_braces()
    {
        $braces = array( "[" =>1, "]" =>2, "{" =>3, "}" =>4, "(" =>5, ")" =>6);
        $position = parent::get_current_pos();
        $ch1 = parent::get_char_at($position - 1);
        $ch2 = parent::get_char_at($position);

        if (@$braces[chr($ch1)])
            $brace_pos = $position - 1;
        else if (@$braces[chr($ch2)])
            $brace_pos =  $position;
        else
            $brace_pos =  -1;

        if ($brace_pos > 0)
        {
            $other_pos = parent::brace_match($brace_pos);
            if ($other_pos > 0)
            {
                parent::brace_highlight($brace_pos, $other_pos);
            }
            else
            {
                parent::brace_bad_light($brace_pos);
            }
        }
        else
        {
            parent::brace_bad_light(-1);
        }
    }

    function is_brace() {

    }     

	function char_added($char)
	{
        if (parent::get_read_only())
        {
            return;
        }
        if($char == 10)
        { # malko add 'keep indent on newline'
            $cur_line = $this->line_from_position($this->get_current_pos());
            if( $line_indent = $this->get_line_indentation($cur_line-1))
            {
                $this->set_line_indentation($cur_line,$line_indent);
                $this->goto_pos($this->get_current_pos()+$line_indent);
            }
            return;
        }
			$this->complete_word_activate(1,1);
	}

	function get_current_word($n = 0)
	{
		$this->curpos = parent::get_current_pos();
		parent::word_left_extend();
		if ($n ==1)
			parent::word_left_extend();

		$word = parent::get_sel_text();
		parent::goto_pos($this->curpos);
		return trim($word);
	}
 
	function complete_word_activate($is_key=0)
	{
		$disable_autocomplete = FALSE;
		//$word = strtolower($this->get_current_word());
		$word = $this->get_current_word();
	
		if (@$this->lastword && $is_key)
		if (substr(trim($word),0,strlen($this->lastword)) == $this->lastword)
			$disable_autocomplete = TRUE;
		if (trim($word) == substr($word,1)) $word[0] = " "; 
		if ((strlen($word) > 2) || $word == '(')
			$word = trim($word);

			if ($linematches = $this->get_suggestions($word))
			{
                sort($linematches);
				$l = trim(implode("",array_unique($linematches)));
				if ($is_key && count($linematches) == 1) $l.=" ";
				{
					if ($is_key) $this->lastword = $word;
					//parent::autoc_show(strlen($word), $l);
				}
			}
			elseif ($word == '(')
			{
                
				$this->lastword = substr($this->get_current_word(1), 0, -1);
				$start = $this->curpos - strlen($this->lastword);
				if ($f = $this->get_definition($this->lastword))
				{
					parent::call_tip_show($start,$f);
				}
			}
	}

	function get_suggestions ($word)
	{
		for($i=1;$i<=8;$i++)
		{
			if (!$this->keywords[$i]) continue;
			if (isset($matches)) unset($matches);
			if (@preg_match_all ("( ".$word ."[^ ]*)" , $this->keywords[$i],
				$matches, PREG_PATTERN_ORDER))
			return $matches[0];
		}
	}
    
	function read_function_file()
	{
		$data = file('php_functions');
		for ($i=0;$i<count($data);$i++)
		{
			$line = $data[$i];
			$info  = explode(" ",trim($line));
			$this->functions[$info[1]] = trim($line);
		}

		$data = file('gtk_functions');
		for ($i=0;$i<count($data);$i++)
		{
			$line = $data[$i];
			$info  = explode(" ",trim($line));
			$function_name = $info[1];
			$this->functions[$function_name] = trim($line);
			$gtkfunctions[] = $function_name;
		}
		$this->keywords[7] = implode(' ', $gtkfunctions);

		$data = file('extra_functions');
		for ($i=0;$i<count($data);$i++)
		{
			$line = $data[$i];
			$info  = explode(" ",trim($line));
			$function_name = $info[1];
			$this->functions[$function_name] = trim($line);
			$extrafunctions[] = $function_name;
		}
		$this->keywords[8] = implode(' ', $extrafunctions);
	}
    
	function get_definition($function)
	{
		$a =  @$this->functions[$function];
		return $a;
	}
 
	function DefinePHP($profile)
	{
        $colors = $profile['colors'];
        $font = $profile['font'];
		if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
		{
			if (!$font)
            {
                $font =    '-*-courier new-*-*-*-*-*-120-*-*-*-*-*-*';
            }
			$lilfont = '-*-courier new-*-*-*-*-*-120-*-*-*-*-*-*';
			$etcfont = '-*-courier new-*-*-*-*-*-120-*-*-*-*-*-*';
		}
		else
		{
			if (!$font)
            {
                $font    = '-*-luxisans-bold-r-normal-*-18-*-*-*-*-*-*-*';
            }
			$lilfont = '-*-luxisans-medium-r-normal-*-18-*-*-*-*-*-*';
			$etcfont = '-*-lucidatypewriter-medium-r-normal-*-18-*-*-*-*-*-*';
		}
        
        foreach ($colors as $key => $cor)
        {
            $cor = $colors[$key] = substr($cor, 1);
            $colors[$key] = substr($cor, 4,2) . substr($cor, 2, 2) . substr($cor, 0, 2);
        }

        parent::set_caret_line_back(hexdec($colors['caret']));
        parent::set_caret_fore(hexdec(invcolor('#' . $colors['background'])));
		parent::style_set_font(SCINTILLA_STYLE_DEFAULT, $lilfont);
		parent::style_set_fore(SCINTILLA_STYLE_DEFAULT, hexdec($colors['php_operator']));
		parent::style_set_back(SCINTILLA_STYLE_DEFAULT, hexdec($colors['background']) );
	
		parent::style_set_font(SCINTILLA_STYLE_LINE_NUMBER, $lilfont);
		parent::style_set_fore(SCINTILLA_STYLE_LINE_NUMBER, 0);
		parent::style_set_back(SCINTILLA_STYLE_LINE_NUMBER, 11053224);
	
		parent::style_set_font(SCINTILLA_STYLE_BRACE_LIGHT, $lilfont);
		parent::style_set_fore(SCINTILLA_STYLE_BRACE_LIGHT, hexdec(invcolor('#' . $colors['background'])));
		parent::style_set_back(SCINTILLA_STYLE_BRACE_LIGHT, 10921638);

		parent::style_set_font(SCINTILLA_STYLE_BRACE_BAD, $lilfont);
		parent::style_set_fore(SCINTILLA_STYLE_BRACE_BAD, 12517376);
		parent::style_set_back(SCINTILLA_STYLE_BRACE_BAD, 15987699);

		
        parent::set_margin_width_n(0, 30); //aqui eu consegui fazer aparecer os numeros de linhas
        
		$this->keywords[1] = 'doctype a abbr abbr accept accept-charset accesskey acronym action address align alink alt applet archive area axis b background base basefont bdo bgcolor big blockquote body border br button caption cellpadding cellspacing center char charoff charset checkbox checked cite cite class classid clear code codebase codetype col colgroup color cols colspan compact content coords data datafld dataformatas datapagesize datasrc datetime dd declare defer del dfn dir dir disabled div dl dt em enctype event face fieldset file font for foreach form frame frame frameborder frameset h1 h2 h3 h4 h5 h6 head headers height hidden hr href hreflang hspace html http-equiv i id iframe image img input ins isindex ismap kbd label label lang language leftmargin legend li link link longdesc map marginheight marginwidth maxlength media menu meta method multiple name noframes nohref noresize noscript noshade nowrap object object ol onblur onchange onclick ondblclick onfocus onkeydown onkeypress onkeyup onload onmousedown onmousemove onmouseout onmouseover onmouseup onreset onselect onsubmit onunload optgroup option p param password pre profile prompt public q radio readonly rel reset rev rows rowspan rules s samp scheme scope script select selected shape size small span span src standby start strike strong style style sub submit summary sup tabindex table target tbody td text text textarea tfoot th thead title title topmargin tr tt type u ul usemap valign value valuetype var version vlink vspace width xml xmlns';
		$this->keywords[2] = 'abstract boolean break byte case catch char class const continue debugger default delete do double else enum export extends final finally float for foreach function goto if implements import in instanceof int interface long native new package private protected public return short static super switch synchronized this throw throws transient try typeof var void volatile while with';
		$this->keywords[4] = 'None and assert break class continue def del elif else except exec finally for from global if import in is lambda not or pass print raise return try while function include include_once require require_once';

		$df = get_defined_functions();
		$dc = get_declared_classes();
		$this->keywords[5] = implode(' ', $df['internal']);
		$this->keywords[6] = implode(' ', $dc); 
		parent::set_keywords(1, $this->keywords[1]);
		parent::set_keywords(2, $this->keywords[2]);
		parent::set_keywords(4, $this->keywords[4]);

		$this->read_function_file();

        parent::style_set_fore(SCINTILLA_HTML_PHP_COMMENT_LINE,  hexdec($colors['php_coment']));
		parent::style_set_fore(SCINTILLA_HTML_PHP_COMMENT_BLOCK, hexdec($colors['php_coment']));
		parent::style_set_fore(SCINTILLA_HTML_PHP_VARIABLE, hexdec($colors['php_variable']));
		parent::style_set_fore(SCINTILLA_HTML_PHP_NUMBER, hexdec($colors['php_number']));
		parent::style_set_fore(SCINTILLA_HTML_PHP_OPERATOR, hexdec($colors['php_operator']));
        parent::style_set_fore(SCINTILLA_HTML_PHP_DEFAULT,  hexdec($colors['php_operator']));
		parent::style_set_fore(SCINTILLA_HTML_PHP_KEYWORD, hexdec($colors['php_keyword']));
		parent::style_set_fore(SCINTILLA_HTML_PHP_STRING_SINGLE, hexdec($colors['php_string']));
		parent::style_set_fore(SCINTILLA_HTML_PHP_STRING_DOUBLE, hexdec($colors['php_string']));
        parent::style_set_fore(SCINTILLA_HTML_PHP_EOL, hexdec($colors['php_variable']));
        
        parent::style_set_fore(SCINTILLA_HTML_JS_START, hexdec($colors['html_tag']));
        parent::style_set_fore(SCINTILLA_HTML_JS_DEFAULT, hexdec($colors['php_operator']));
        parent::style_set_fore(SCINTILLA_HTML_JS_STRING_DOUBLE, hexdec($colors['php_string']));
        parent::style_set_fore(SCINTILLA_HTML_JS_STRING_SINGLE, hexdec($colors['php_string']));
        parent::style_set_fore(SCINTILLA_HTML_JS_NUMBER, hexdec($colors['php_number']));
        parent::style_set_fore(SCINTILLA_HTML_JS_EOL, hexdec($colors['php_variable']));
        parent::style_set_fore(SCINTILLA_HTML_JS_COMMENT_BLOCK, hexdec($colors['php_coment']));
        parent::style_set_fore(SCINTILLA_HTML_JS_COMMENT_LINE, hexdec($colors['php_coment']));
        parent::style_set_fore(SCINTILLA_HTML_JS_COMMENT_DOC, hexdec($colors['php_coment']));
        parent::style_set_fore(SCINTILLA_HTML_JS_WORD, hexdec($colors['php_operator']));
        parent::style_set_fore(SCINTILLA_HTML_JS_KEYWORD, hexdec($colors['php_keyword']));
        parent::style_set_fore(SCINTILLA_HTML_JS_SYMBOL, hexdec($colors['php_keyword']));
        parent::style_set_fore(SCINTILLA_HTML_JS_EOL, hexdec($colors['php_keyword']));
        parent::style_set_fore(SCINTILLA_HTML_JS_REGEX, hexdec($colors['php_keyword']));

		parent::style_set_fore(SCINTILLA_HTML_UNQUOTED, hexdec($colors['html_unquoted']));
		parent::style_set_fore(SCINTILLA_HTML_PHP, hexdec($colors['html_php']));
		parent::style_set_fore(SCINTILLA_HTML_SCRIPT, hexdec($colors['html_script']));
		parent::style_set_fore(SCINTILLA_HTML_COMMENT, hexdec($colors['html_comment']));
		parent::style_set_fore(SCINTILLA_HTML_SINGLE_STRING, hexdec($colors['html_string']));
		parent::style_set_fore(SCINTILLA_HTML_DOUBLE_STRING, hexdec($colors['html_string']));
		parent::style_set_fore(SCINTILLA_HTML_NUMBER, hexdec($colors['html_number']));
		parent::style_set_fore(SCINTILLA_HTML_ATTRIBUTE_UNKNOWN, hexdec($colors['html_att_unknown']));
		parent::style_set_fore(SCINTILLA_HTML_ATTRIBUTE, hexdec($colors['html_att']));
		parent::style_set_fore(SCINTILLA_HTML_TAG_UNKNOWN,  hexdec($colors['html_tag_unkown']));
		parent::style_set_fore(SCINTILLA_HTML_TAG, hexdec($colors['html_tag']));

        parent::style_set_fore(SCINTILLA_PERL_COMMENT_LINE,  hexdec($colors['php_coment']));
		//parent::style_set_fore(SCINTILLA_PERL_VARIABLE, hexdec($colors['php_variable']));
		parent::style_set_fore(SCINTILLA_PERL_NUMBER, hexdec($colors['php_number']));
		parent::style_set_fore(SCINTILLA_PERL_OPERATOR, hexdec($colors['php_operator']));
        //parent::style_set_fore(SCINTILLA_PERL_DEFAULT,  hexdec($colors['php_operator']));
		parent::style_set_fore(SCINTILLA_PERL_KEYWORD, hexdec($colors['php_keyword']));
		parent::style_set_fore(SCINTILLA_PERL_STRING, hexdec($colors['php_string']));
        parent::style_set_fore(SCINTILLA_PERL_CHARACTER, hexdec($colors['php_operator']));

/*
@define(  "SCINTILLA_PERL_CHARACTER"                ,   7 ); 
@define(  "SCINTILLA_PERL_PUNCTUATION"              ,   8 ); 
@define(  "SCINTILLA_PERL_PREPROCESSOR"             ,   9 ); 
@define(  "SCINTILLA_PERL_OPERATOR"                 ,   10 ); 
@define(  "SCINTILLA_PERL_IDENTIFIER"               ,   11 ); 
@define(  "SCINTILLA_PERL_SCALAR"                   ,   12 ); 
@define(  "SCINTILLA_PERL_ARRAY"                    ,   13 ); 
@define(  "SCINTILLA_PERL_HASH"                     ,   14 ); 
@define(  "SCINTILLA_PERL_SYMBOL_TABLE"             ,   15 ); 
@define(  "SCINTILLA_PERL_REGEX"                    ,   17 ); 
@define(  "SCINTILLA_PERL_REGSUBST"                 ,   18 ); 
@define(  "SCINTILLA_PERL_LONG_QUOTE"               ,   19 ); 
@define(  "SCINTILLA_PERL_BACKTICKS"                ,   20 ); 
@define(  "SCINTILLA_PERL_DATA_SECTION"             ,   21 ); 
@define(  "SCINTILLA_PERL_HERE_DELIM"               ,   22 ); 
@define(  "SCINTILLA_PERL_HERE_Q"                   ,   23 ); 
@define(  "SCINTILLA_PERL_HERE_QQ"                  ,   24 ); 
@define(  "SCINTILLA_PERL_HERE_QX"                  ,   25 ); 
@define(  "SCINTILLA_PERL_STRING_Q"                 ,   26 ); 
@define(  "SCINTILLA_PERL_STRING_QQ"                ,   27 ); 
@define(  "SCINTILLA_PERL_STRING_QX"                ,   28 ); 
@define(  "SCINTILLA_PERL_STRING_QR"                ,   29 ); 
@define(  "SCINTILLA_PERL_STRING_QW"                ,   30 ); 
*/

		for  ($n=118; $n<=127; $n++) //PHP BACK
		{
			parent::style_set_back($n, hexdec($colors['background']));
			parent::style_set_font($n, $font);
		}
		for  ($n=0; $n<=29; $n++) //HTML BACK
		{
			parent::style_set_back($n, hexdec($colors['background']));
			parent::style_set_font($n, $font);
            //parent::style_set_fore($n, hexdec($colors['php_variable']));
		}
	}

    function group_braces($linestring)
    {
        parent::set_margin_width_n(1, 12);
        parent::set_margin_sensitive_n(1,1);
        parent::marker_define( 1, 0);
        parent::marker_define( 2, 3);
         
        $linenum = 1;
        $level = 0;
        if ($linestring)
        {
            foreach ($linestring as $line)
            {
                $line = trim($line);
                if ((substr($line,0,2)!='//') and (substr($line,0,1)!= '#'))
                {
                    $pos1 = strpos($line, '{');
                    $pos2 = strpos($line, '}');
                    $specs = array('static function', 'public function', 'private function',
                                   'protected function', 'final function', 'abstract function');
    
                    if (substr($line,0,8)=='function')
                    {
                        $posf = true;
                    }
                    else
                    {
                        $posf = false;
                        foreach ($specs as $func)
                        {
                            if ($posf === false)
                                $posf = strpos($line, $func);
                        }
                    }
    
                    if ($posf !== false)
                    {
                        $posp = strpos($line, '(');
                        $funcname = trim(substr($line, $posf + 9, $posp - ($posf + 9)));
                        $open = true;
                        $lastlevel = $level;
                    }
            
                    if ($pos1 !== false)
                    {
                        if ($open)
                        {
                            $brace_parser[$funcname]['begin'] = $linenum;
                            $open = false;
                        }
                        $level ++;
                    }
            
                    if ($pos2 !== false)
                    {
                        $level --;
                        if ($level == $lastlevel)
                            $brace_parser[$funcname]['end'] = $linenum -1;
                    }
                }
                $linenum ++;
            }
        }

        $min=parent::get_line_count();
        $max=0;

        if ($brace_parser)
        {
            foreach ($brace_parser as $name=>$linedata)
            {
                if ($linedata["begin"] < $min)  $min = $linedata["begin"];
                if ($linedata["end"] > $max)    $max = $linedata["end"];

                parent::marker_add($linedata["begin"]-1, 2);
                $lines[$linedata["begin"] -1 ] = 1;
                $lines[$linedata["end"]] = 0;
            }
        }

        $curdepth=0;
        for ($i= $min-1; $i<$max; $i++)
        {
            if (@isset($lines[$i]))
            {
                $curdepth = $lines[$i];
            }
            parent::set_fold_level($i, SCINTILLA_FOLDLEVELBASE + $curdepth);
        }
    }

    function margin_click($modifier,$position,$margin)
    {
        $line       = parent::line_from_position($position);
        $thislevel  = parent::get_fold_level($line);
        $lastchild  = parent::get_last_child($line, $thislevel -1);
        $parent     = parent::get_fold_parent($line+1);
        $is_expanded= parent::get_fold_expanded($line);
        $nextmarker = parent::marker_next($line+1, 255);

        if (($nextmarker > $line) && ($nextmarker< $lastchild))
        {
            $nextmarker_level = parent::get_fold_level( $nextmarker);
            if ($nextmarker_level == $thislevel) 
            {
                $lastchild = $nextmarker-1;
            }
        }

        if ($is_expanded)
        {
            $this->collapse_from($line);
        }
        else
        {
            $this->expand($line, $lastchild);
      }
    }

    function expand($line, $lastchild)
    {
        parent::set_fold_expanded($line,1);
        parent::marker_delete($line,1);
        parent::marker_delete($line,2);
        parent::marker_add($line,2);
        parent::show_lines($line,$lastchild);
        return $lastchild;
    }

    function expand_all()
    {
        $end = parent::get_line_count();
        $line = 0;

        while ($line < $end)
        {
            $thislevel = parent::get_fold_level($line);
            $lastchild = parent::get_last_child($line, $thislevel -1);

            if ($thislevel > SCINTILLA_FOLDLEVELBASE)
            {
                $line = $this->expand($line, $lastchild);
            }
            $line++;
        }
    }

    function collapse_from($line)
    {
        $thislevel = parent::get_fold_level($line);
        $lastchild  = parent::get_last_child($line,$thislevel -1);
        $nextmarker = parent::marker_next($line+1,255);
        if ($lastchild <= $line) return $line+1;
        if (($nextmarker > $line) && ($nextmarker< $lastchild))
        {
            $nextmarker_level = parent::get_fold_level( $nextmarker);
            if ($nextmarker_level == $thislevel) 
                $lastchild = $nextmarker-1;
                             
        }
        parent::set_fold_expanded($line,0);
        parent::marker_delete($line,1);
        parent::marker_delete($line,2);
        parent::marker_add($line,1);
        parent::hide_lines($line+1,$lastchild );
        return $lastchild;
    }

    function collapse_all()
    {
        $begin = 0;
        $end = parent::get_line_count();
        $line = $begin;

        while ($line < $end)
        {
            $thislevel = parent::get_fold_level($line);
            if ($thislevel > SCINTILLA_FOLDLEVELBASE)
            {
                $line = $this->collapse_from($line);
            }
            $line++;
        }
    }
}
?>
