<?
/**
 * This class defines the Icone object, which is a picture loaded as icon,
 * with a text beneath and a little info box when the cursos goes over the icon
 */
class Icone extends GtkButton
{
	/**
	 * Constructor Method, cria os botoes
     * baseado na pagina 293 do livro php-gtk criando aplicaoes graficas com php
     * autor Pablo Dall'Oglio
     * Helder Mauricio Gomes Ferreira adaptando o tulip para php-gtk2 2008
	 *
	 * @param	string	The path to the picture to load
	 * @param	string	The string to display under the icon
	 * @param	string	The string to display when cursor hovers the icon
     * @param   string  The string to callback
	 /***********************************************************/

    function Icone( $imagem, $texto, $dica, $ishorizontal = false)
	{
		parent::__construct();
		
        if(file_exists($imagem))
        {
        $Imagem=GtkImage::new_from_file($imagem);
        }
		$Rotulo = new GtkLabel($texto);

		$help = &new GtkTooltips();
		$help->set_tip($this, $dica);
		if ($ishorizontal)
		{
			$box = new GtkHBox;
		}
		else
		{
			$box = new GtkVBox;
		}
		$box->pack_start($Imagem);
		$box->pack_start($Rotulo);

		parent::add($box);
	}
}

/**
 * Class defining the toggle icon.
 */
class ToggleIcone extends GtkToggleButton
{
	/**
	 * Constructor method of the ToggleIcone class.
	 *
	 * @param	object	Reference to the window object the TI is bound to
	 * @param	string	Path to the picture to load
	 * @param	string	Text to be written below the icon
	 * @param	string	Text to appear when the mouse hovers the icon
	 */
	function ToggleIcone( $imagem, $texto, $dica, $ishorizontal = false)
	{
		parent::__construct();
		
        if(file_exists($imagem))
        {
        $Imagem=GtkImage::new_from_file($imagem);
        }
		$Rotulo = new GtkLabel($texto);

		$help = &new GtkTooltips();
		$help->set_tip($this, $dica);
		if (!$ishorizontal)
		{
			$box = new GtkHBox;
		}
		else
		{
			$box = new GtkVBox;
		}
		$box->pack_start($Imagem);
		$box->pack_start($Rotulo);

		parent::add($box);
	}
}

/**
 * Class defining an icon without text below.
 */
class IconeImg extends GtkButton
{
	/**
	 * Class constructor.
	 * 
	 * @param	object	Reference to the window the icon is bound to
	 * @param	string	Path to the picture to load
	 * @param	string	Text to appear when the cursor hovers the icon
	 */
	function IconeImg($oWindow, $imagem, $dica)
	{
		parent::__construct();
		$Pixmap = GdkPixbuf::new_from_file($imagem);
        $Imagem = new GtkImage;
        $Imagem->set_from_pixbuf($Pixmap);

		$help = &new GtkTooltips;
		$help->set_tip($this, $dica);
		$vbox = new GtkVBox;
		$vbox->pack_start($Imagem);

		GtkButton::add($vbox);
	}
}
?>