<?
/***********************************************************/
/* Classe que cria Dilogos                                */
/* Linguagem PHP-GTK                                       */
/* Autor: Pablo Dall'Oglio                                 */
/* ltima aterao em 29 Outubro 2001 por Pablo            */
/***********************************************************/

/***********************************************************/
/* Classe de Dilogo
/***********************************************************/
class InputBox
{
    var $dialog;
    var $InputEntry;
    
    /***********************************************************/
    /* Mtodo construtor da classe dilogo
    /***********************************************************/
    function InputBox($mensagem, $lenght, $PreText = '', $action = null)
    {
        $this->dialog = new GtkWindow;
        $this->dialog->set_title(_a('Question'));
        $this->dialog->set_border_width(0);
        $this->dialog->set_position(GTK_WIN_POS_CENTER);
        $this->dialog->connect_simple('key_press_event', array(&$this,'KeyTest'), 'window');
        $this->dialog->realize();
        
        $Vbox = &new GtkHBox(false, 3);
        $Vbox->show();
        $this->dialog->add($Vbox);
        
        $box = &new GtkVBox(false, 3);
        $box->show();
        $Vbox->pack_start($box);
        
        $this->InputEntry  = &new GtkEntry();
        $box->pack_start(new EntryBox($this->InputEntry, $lenght, $mensagem, $PreText), false, false, 10);
        $this->InputEntry->connect_simple('key_press_event', array(&$this,'KeyTest'), 'entry');
        $this->InputEntry->set_usize($lenght,20);

        //$ico_ok = Gdk::pixmap_create_from_xpm($this->dialog->window, null,  images . 'ico_ok.xpm');
        $ico_ok = images . 'ico_ok.xpm';//vai o endereo
        //$ico_ok = GtkImage::new_from_file($ico_ok); 
                
        $this->button = &new VoidButton('OK', $ico_ok, IMAGEBUTTON);
        $this->button->connect_simple('clicked', array(&$this->dialog, 'hide'));
        if ($action)
        {
            $this->button->connect_simple('clicked', $action, $this->InputEntry);
        }
        $this->button->show();
        $this->button->set_relief(GTK_RELIEF_NONE);
        $hbox = &new GtkHBox;
        $hbox->pack_start(new GtkHBox, true, true);
        $hbox->pack_start($this->button, false, false);
        $box->pack_start($hbox, false, true, 0);
        
        $this->dialog->set_focus($this->InputEntry);
        $this->dialog->realize();
        $this->dialog->show_all();
    }
    
    function KeyTest($p1, $context)
    {
        if ($p1->keyval == K_ENTER && $context=='entry')
        {
            $this->button->clicked();
        }
        else if ($p1->keyval == K_ESC && $context=='window')
        {
            $this->dialog->hide();
        }
    }
    
    /***********************************************************/
    /* Funo que fecha dilogo
    /***********************************************************/
    function Close()
    {
        $this->dialog->hide();
    }
    
}
/*

class InputBox extends GtkDialog
{
	function InputBox($mensagem, $length, $default, $paramOk)
	{
		parent::GtkDialog();
		GtkWindow::set_border_width(4);
		GtkWindow::set_position(GTK_WIN_POS_CENTER);
		$texto = new GtkLabel($mensagem);
		$this->InputEntry = $entry = new GtkEntry;
        $entry->set_usize($lenght,20);
		$entry->set_text($default);
		$this->paramOk = $paramOk;

		$vbox = $this->vbox;
		$vbox->pack_start($texto);
		$vbox->pack_start($entry);
    
		$hbox = $this->action_area;
		$this->button = $botao1 = new GtkButton('OK');
		$botao1->connect_simple('clicked', array($this, 'hide'));
        if ($paramOk)
            $botao1->connect_simple('clicked', $paramOk, $entry);

		$botao2 = new GtkButton('Cancelar');
		$botao2->connect_simple('clicked', array($this, 'hide'));

		GtkWindow::connect_simple('key_press_event', array($this, 'test'), $botao1);
		$hbox->pack_start($botao1);
		$hbox->pack_start($botao2);
		GtkWindow::set_focus($entry);
		GtkWindow::show_all();
	}
	function test($obj, $botao)
	{
		if ($obj->keyval==65293)
		{
			$botao->clicked();
			//GtkWindow::hide();
		}
		elseif ($obj->keyval==65307)
		{
			GtkWindow::hide();
		}
	}
}
*/
class DoubleInputBox extends GtkDialog
{
	function DoubleInputBox($mensagem1, $mensagem2, $paramOk)
	{
		//parent::GtkDialog();
        parent::__construct();
		GtkWindow::set_border_width(4);
		GtkWindow::set_position(GTK_WIN_POS_CENTER);
		$texto1 = new GtkLabel($mensagem1);
		$texto2 = new GtkLabel($mensagem2);

		$entry1 = new GtkEntry;
		$entry2 = new GtkEntry;

		$this->paramOk = $paramOk;

		$vbox = $this->vbox;
		$vbox->pack_start($texto1);
		$vbox->pack_start($entry1);
		$vbox->pack_start($texto2);
		$vbox->pack_start($entry2);
    
		$hbox = $this->action_area;
		$botao1 = new GtkButton('OK');
		$botao1->connect_simple('clicked', array($this, 'hide'));
		$botao1->connect_simple('clicked', $paramOk, $entry1, $entry2);

		$botao2 = new GtkButton('Cancelar');
		$botao2->connect_simple('clicked', array($this, 'hide'));

		GtkWindow::connect_simple('key_press_event', array($this, 'test'), $botao1);
		$hbox->pack_start($botao1);
		$hbox->pack_start($botao2);
		GtkWindow::set_focus($entry1);
		GtkWindow::show_all();
	}
	function test($obj, $botao)
	{
		if ($obj->keyval==65293)
		{
			$botao->clicked();
		}
		elseif ($obj->keyval==65307)
		{
			GtkWindow::hide();
		}
	}
}
?>