<?

/***********************************************************/
/* Classe de traducoes                                     */
/* Linguagem PHP-GTK                                       */
/* Autor: Pablo Dall'Oglio                                 */
/* ltima aterao em 19 Outubro 2001 por Pablo            */
/*                                                         */
/* History:                                                */
/*   10/24/2001  Thomas S. - Some improvements             */
/*               german messages, positional parameters    */
/*               and default instantiation                 */
/*               Bruno Depero - Italian Translation        */
/*               Christian Etuy - French Translation       */
/*                                                         */
/*   20/11/2002  Lucas Di Pentima - Spanish Translation    */
/*                                                         */
/***********************************************************/

/***********************************************************/
/* Classe de Traducoes                                     */
/***********************************************************/

/**
 * Class defining both the different languages terms and the
 * methods to deal with them.
 */
class Trans
{
  /**
   * Array containing the languages terms. To add a language, 
   * just copy the 'en' part (because obviously it will be 
   * the most up-to-date) and put it after the other
   * languages arrays, changing all the terms to the new
   * language.
   */
  var $messages = array(


    'en' => array(
	'File Explorer',
	'Open',
	'Delete',
	'No action',
	'Close',
	'New',
	'Save',
	'New Project',
	'Save Project',
	'Delete Project',
	'Close Window',
	'New File',
	'Open File',
	'Save File',
	'Save File as',
	'CVS::Login',
	'CVS::Logout',
	'CVS::New',
	'CVS::Commit',
	'CVS::Delete',
	'Setup Projects',
	'Update',
	'Logout',
	'Login',
	'View File Tree',
	'Projects',
	'View files',
	'Close file',
	'Quit',
	'File',
	'Edit',
	'Undo',
	'Redo',
	'Cut',
	'Copy',
	'Paste',
	'Find',
	'Find Next',
	'Replace',
	'Go to line',
	'About',
	'User ^1 is working on this file',
	'Do you want to save the file ?',
	'Searched text',
	'Expression',
	'Substitution',
	'A IDE for PHP Development',
	'Colaborations',
	'Free software co-operative',
	'Server connection parameters are lacking',
	'Project',
	'Project Name',
	'CVS Server',
	'Project Path',
	'CVS User',
	'Database User',
	'FTP Server IP',
	'Database Password',
	'FTP Server User',
	'Database Name',
	'FTP Server Password',
	'Database IP',
	'Database',
	'Record',
	'Reload',
	'Database Type',
	'Save as',
	'Permission denied',
	'Save Workspace',
	'Workspace',
	'Workspace Saved',
	'File not Saved',
	'No Errors',
	'Test File',
	'Create Documentation',
	'Highlight',
	'Debug',
	'Yes',
	'No',
	'Question',
	'Line Delete',
	'Indent',
	'Unindent',
	'Left Tab',
	'Right Tab',
	'Cancel',
	'File already opened',
	'Create Folder',
	'Caret Lines',
	'Show EOL',
	'Select all',
	'Open Recent',
	'Word Wrap',
	'Rectangular selection',
	'Upload',
	'Download',
	'No Docs',
	'No File Opened',
	'File Updated',
	'View Docs',
	'Checkout',
	'Do you want to checkout this project ?',
	'Do you want to save the workspace ?',
	'Commit',
	'Expand all',
	'Collapse all',
	'Class',
	'Choose the class',
	'Preferences',
   	'Colors',
	'Profile Name',
    'Font',
    'Report',
    'Do you really want to delete ?',
    'Add',
    'FTP Server Path',
    'Used in compare statement but never assigned',
    'Assigned value and never used',
    'Used in concatenation statement but never assigned',
    'Used as subitem in array but never assigned',
    'Used in operate statement but never assigned',
    'Used as an object but never created',
    'Used as a param but never assigned',
    'Used as an array but never used',
    'Its value is beign assign but never set',
    'Unknown error',
    'Good use',
    'Apply',
    'Do you want to overwrite the file ?',
    'Remote Editing Server',
    'Apache Server where Tulip Service is running, example ^1 or ^2',
    'Path in the FTP Server that will be used to send this project files',
    'Connection Problems',
	'Lock',
	'Unlock'
    ),

    //
    // brazilian portuguese messages
    //

    'pt' => array(
    'Navegador de Arquivos',
	'Abrir',
	'Apagar',
	'Sem ao',
	'Fechar',
	'Novo',
	'Salvar',
	'Novo Projeto',
	'Salva Projeto',
	'Apaga Projeto',
	'Fecha Janela',
	'Novo Arquivo',
	'Abre Arquivo',
	'Salva Arquivo',
	'Salva Arquivo como',
	'CVS::Login',
	'CVS::Logout',
	'CVS::Novo',
	'CVS::Atualiza',
	'CVS::Deleta',
	'Configura Projetos',
	'Atualiza',
	'Logout',
	'Login',
	'Ver rvore de arquivos',
	'Projetos',
	'Ver arquivos',
	'Fecha arquivo',
	'Sair',
	'Arquivo',
	'Editar',
	'Desfazer',
	'Refazer',
	'Recortar',
	'Copiar',
	'Colar',
	'Procurar',
	'Prximo',
	'Substituir',
	'Ir para a linha',
	'Sobre',
	'Usurio ^1 est com este arquivo aberto',
	'Deseja salvar o arquivo ?',
	'Expresso procurada',
	'Expresso',
	'Substituio',
	'Uma IDE para desenvolvimento em PHP',
	'Colaboraes',
	'Cooperativa de solues livres',
	'Falta parmetros de conexo ao servidor',
	'Projeto',
	'Nome do Projeto',
	'Servidor CVS',
	'Diretrio do Projeto',
	'Usurio do servidor CVS',
	'Usurio do Banco de Dados',
	'IP do Servidor FTP',
	'Senha do Banco de Dados',
	'Usurio do servidor FTP',
	'Nome do Banco de Dados',
	'Senha do servidor FTP',
	'IP do Banco de Dados',
	'Banco de dados',
	'Registro',
	'Recarregar',
	'Tipo de Banco de Dados',
	'Salvar como',
	'Permisso negada',
	'Salvar rea de Trabalho',
	'rea de Trabalho',
	'rea de Trabalho Salva',
	'Arquivo no Salvo',
	'Sem Erros',
	'Testar Arquivo',
	'Criar Documentao',
	'Highlight',
	'Debug',
	'Sim',
	'No',
	'Pergunta',
	'Deletar Linha',
	'Identar',
	'Desidentar',
	'Tab Esquerda',
	'Tab Direita',
	'Cancelar',
	'Arquivo j aberto',
	'Criar Pasta',
	'Realar Linhas',
	'Exibir EOL',
	'Selecionar tudo',
	'Abrir Recentes',
	'Ajuste de Texto',
	'Seleo em colunas',
	'Enviar',
	'Receber',
	'Sem Documentao',
	'No h arquivo aberto',
	'Arquivo atualizado',
	'Ver Documentao',
	'Baixar',
	'Deseja baixar este projeto ?',
	'Deseja salva a rea de trabalho ?',
	'Atualizar',
	'Expandir tudo',
	'Condensar tudo',
	'Classes',
	'Escolha a classe',
	'Preferncias',
	'Cores',
	'Nome do Perfil',
    'Font',
    'Relatrio',
    'Deseja realmente apagar ?',
    'Adicionar',
    'Caminho no servidor FTP',
    'Usado em comparao, mas nunca inicializado',
    'Inicializado e nunca utilizado',
    'Usado em concatenao mas nunca inicializado',
    'Usado em vetor, mas nunca inicializado',
    'Usado como operador mas nunca inicializado',
    'Usado como objeto, mas nunca criado',
    'Usado como parmetro mas nunca inicializado',
    'Usado como vetor, mas nunca utilizado',
    'Valor assinalado, mas nunca inicializado',
    'Erro Desconhecido',
    'Bom uso',
    'Aplicar',
    'Voc deseja sobregravar o arquivo ?',
    'Servidor para Edio Remota',
    'Servidor Apache onde o Servio do Tulip est rodando, por exemplo ^1 ou ^2',
    'Caminho no Servidor FTP que ser utilizado para enviar os arquivos do projeto',
    'Problemas na Conexo',
	'Travar',
	'Destravar'
    ),

	//Traduction franaise. Ajout le 05/06/2004 (Yannick Warnier)

	'fr' => array(
	'Explorateur de fichiers',
	'Ouvrir',
	'Effacer',
	'Pas d\'action',
	'Fermer',
	'Nouveau',
	'Sauver',
	'Nouveau projet',
	'Sauver projet',
	'Supprimer projet',
	'Fermer fentre',
	'Nouveau fichier',
	'Ouvrir un fichier',
	'Sauver fichier',
	'Sauver fichier sous...',
	'CVS::Login',
	'CVS::Logout',
	'CVS::Nouveau',
	'CVS::Mise--jour',
	'CVS::Suppression',
	'Paramtres des projets',
	'Update',
	'Logout',
	'Login',
	'Arborescence des fichiers',
	'Projets',
	'Voir fichiers',
	'Fermer fichier',
	'Quitter',
	'Fichier',
	'diter',
	'Annuler',
	'Rfaire',
	'Couper',
	'Copier',
	'Coller',
	'Chercher',
	'Chercher suivant',
	'Remplacer',
	'Aller  la ligne',
	' propos',
	'L\'utilisateur ^1 travaille sur ce fichier',
	'Voulez-vous sauver le fichier ?',
	'Texte recherch',
	'Expression',
	'Substitution',
	'Un EDI pour le dveloppement PHP',
	'Collaborations',
	'Free software co-operative',
	'Certains paramtres de connexion au serveur font dfaut. Veuillez vrifier les paramtres mentionns dans la configuration du projet.',
	'Projet',
	'Nom du projet',
	'Serveur CVS',
	'Chemin du projet',
	'Utilisateur CVS',
	'Utilisateur Base de Donnes',
	'IP du serveur FTP',
	'Mot de passe Base de Donnes',
	'Utilisateur FTP',
	'Nom Base de Donnes',
	'Mot de passe FTP',
	'IP de la Base de Donnes',
	'Base de donnes',
	'Enregistrer',
	'Rafrachir',
	'Type de Base de Donnes',
	'Sauver...',
	'Permission refuse',
	'Sauver l\'espace de travail',
	'Espace de travail',
	'Espace de travail sauv',
	'Fichier non sauv',
	'Pas d\'erreur',
	'Fichier de test',
	'Crer de la documentation',
	'Highlight',
	'Dbug',
	'Oui',
	'Non',
	'Question'
	),

    'es' => array(
	'Explorador de Archivos',
	'Abrir',
	'Borrar',
	'Sin accion',
	'Cerrar',
	'Nuevo',
	'Guardar',
	'Nuevo Proyecto',
	'Guardar Proyecto',
	'Borrar Proyecto',
	'Cerrar Ventana',
	'Nuevo Archivo',
	'Abrir Archivo',
	'Guardar Archivo',
	'Guardar Archivo Como',
	'CVS::Login',
	'CVS::Logout',
	'CVS::New',
	'CVS::Update',
	'CVS::Delete',
	'Configura Proyectos',
	'Actualiza',
	'Salir',
	'Login',
	'Ver Arbol de Archivos',
	'Proyectos',
	'Ver archivos',
	'Cerrar archivo',
	'Salir',
	'Archivo',
	'Editar',
	'Deshacer',
	'Rehacer',
	'Cortar',
	'Copiar',
	'Pegar',
	'Buscar',
	'Buscar Siguiente',
	'Reemplazar',
	'Ir a la linea',
	'Acerca de',
	'El usuario ^1 esta editando este archivo',
	'Desea guardar el archivo ?',
	'Texto buscado',
	'Expresion',
	'Sustitucion',
	'Un IDE para desarrollo de PHP',
	'Colaboraciones',
	'Cooperativa de soluciones libres',
	'Faltan parametros de conexion al servidor',
	'Proyecto',
	'Nombre del Proyecto',
	'Servidor CVS',
	'Ruta del Proyecto',
	'Usuario CVS',
	'Usuario de la Base de Datos',
	'IP del Servidor FTP',
	'Contrasea de la Base de Datos',
	'Usuario del Servidor FTP',
	'Nombre de la Base de Datos',
	'Contrasea del Servidor FTP',
	'IP de la Base de Datos',
	'Base de Datos',
	'Registro',
	'Recargar',
	'Tipo de la Base de Datos',
	'Guardar como',
	'Permission Denied',
	'Save Workspace',
	'Workspace',
	'Workspace Saved',
	'Archivo no guardado',
	'No falta',
	'Test File',
	'Create Documentation',
	'Highlight',
	'Debug',
	'Si',
	'No',
	'Pregunta',
	),

    'nl' => array(
	'Bestanden verkenner',
	'Openen',
	'Verwijderen',
	'Niets doen',
	'Sluiten',
	'Nieuw',
	'Opslaan',
	'Nieuw project',
	'Sla project op',
	'Verwijder project',
	'Sluit venster',
	'Nieuw bestand',
	'Open bestand',
	'Sla bestand op',
	'Sla bestand op als',
	'CVS::Inloggen',
	'CVS::Uitloggen',
	'CVS::Nieuw',
	'CVS::voor command uit',
	'CVS::Verwijder',
	'Configureer project',
	'Update',
	'Uitloggen',
	'Inloggen',
	'Bekijk bestandenboom',
	'Projecten',
	'Bekijk bestanden',
	'Sluit bestand',
	'Afsluiten',
	'Bestand',
	'Wijzig',
	'Ongedaan maken',
	'Ongedaan maken herstellen',
	'Knip',
	'Kopieren',
	'Plakken',
	'Vinden',
	'Volgende vinden',
	'Wijzigen',
	'Ga naar lijn',
	'About',
	'Gebruike ^1 is bezig met dit bestand',
	'Wilt u dit bestand opslaan ?',
	'Te zoekn tekst',
	'Expressie',
	'Substitutie',
	'Een IDE voor PHP Development',
	'Colaborations',
	'Free software co-operative',
	'Server connectie parameters ontbreken',
	'Project',
	'Project Naam',
	'CVS Server',
	'Project Pad',
	'CVS gebruiker',
	'Database gebruiker',
	'FTP Server IP',
	'Database wachtwoord',
	'FTP Server gebruiker',
	'Database Naam',
	'FTP Server wachtwoord',
	'Database IP',
	'Database',
	'Record',
	'Ververs',
	'Database type',
	'opslaan als',
	'Toegang geweigerd',
	'Sla workspace op',
	'Workspace',
	'Workspace opgeslagen',
	'Bestand niet opgesaal',
	'Geen fouten',
	'Test bestand',
	'Maak documentatie',
	'Highlight',
	'Debug',
	'Ja',
	'Nee',
	'Vraag',
	'Verwijder lijn',
	'Spring in',
	'Spring uit',
	'Linkse Tab',
	'Rechtse Tab',
	'Annuleren',
	'Bestand is al geopend',
	'Maak folder',
	'Voeg lijnen in',
	'Laat einde van de lijn zien',
	'Selecteer alles',
	'Open Recente',
	'Woord omlijning',
	'Selectie',
	'Upload',
	'Download',
	'Geen Docs',
	'Geen bestand geopend',
	'Bestand geupdate',
	'Bekijk Docs',
	'Nakijken',
	'Wilt u dit project nakijken ?',
	'Wilt u de workspace opslaan?',
	'Doe',
	'Klap alles uit',
	'Klap alles in'
     ),
  );

  //
  //  default spanish messages
  //

  var $language = 'en';

  /**
   *  A common used technique is, to keep a default instance
   *  for shared classes. In this case, the global variable
   *  $Language has become a member variable of this class,
   *  which is more consistent from the OO point of view.
   *
   *  Calling this method will return the default instance.
   *  If the default instance does not exist, it will be
   *  created.
   *
   *  One defect of PHP is, that it does not allow static
   *  class member variables - thus we have to use a common
   *  global to hold the default instance ;-)
   */
  function & GetDefaultInstance()
  {
    global $__default_trans_instance;

    if ( ! $__default_trans_instance )
    {
      $__default_trans_instance = new Trans();
    }

    return $__default_trans_instance;
  }

  /**
   *  The translate method takes a string $msg and three
   *  optional positional parameters ($p1,$p2,$p3). The
   *  positional parameters will substitute occurrencies
   *  of the form ^1, ^2 and ^3 contained in the string.
   *
   *  Positional parameters are useful, to include parameters
   *  like filenames or others. In different languages, it is
   *  likely, that the position changes:
   *
   *    'the _white_ dog'   vs.   'o cachorro _branco_'
   */
  function Translate($msg,$p1=null,$p2=null,$p3=null)
  {
    $inst = & Trans::GetDefaultInstance();

    //
    // $nls will become our localized message, if one would
    // be found. Otherwise, it will become the original message
    // prepended by an underscore to notify, that a localized
    // message is missing.
    //

    $nls = $msg;

    if ( $inst->language != 'en' )
    {
      $nls = $msg;

      if ( is_array($inst->messages[$inst->language]) )
      {
        $i = 0;

        foreach ( $inst->messages['en'] as $m )
        {
          if ( $m == $msg )
          {
            $m = $inst->messages[$inst->language][$i];

            if ( $m )
            {
              $nls = $m;
              break;
            }
          }

          $i++;
        }
      }
    }

    //
    // substitute positional parameters if necessary
    //

    if ( $p1 != null )
      $nls = str_replace('^1',$p1,$nls);

    if ( $p2 != null )
      $nls = str_replace('^2',$p2,$nls);

    if ( $p3 != null )
      $nls = str_replace('^3',$p3,$nls);

    return $nls;
  }

  /**
   *  returns the currently selected language identifier
   */
  function GetLanguage()
  {
    $inst = & Trans::GetDefaultInstance();

    return $inst->language;
  }

  /**
   *  switches to another language. If the specified language
   *  is not defined, an error message is generated
   */
  function SetLanguage($lang, $showMsg = tru)
  {
    $inst = & Trans::GetDefaultInstance();

    if ( ! $inst->messages[$lang] )
    {
      if ($showMsg)
        new Dialog("Language '$lang' is not supported!");
      return false;
    }

    $inst->language = $lang;
    return true;
  }

  /**
   *  for testing and demonstrating the new features
   */
  function Dump()
  {
    $inst = & Trans::GetDefaultInstance();

    $old_lang = Trans::GetLanguage();

    //
    // dumps mapping of all available messages except the default ones
    //

    foreach( array_keys($inst->messages) as $l )
    {
      if ( $l == 'en' )
        continue;

      $inst->language = $l;

      echo "<table bgcolor=#999999 cellspacing=1 cellpadding=2 width=100%>\n";
      echo "<tr><td colspan=3 align=center><font color=white><b>Current language is '$l'</b></font></td></tr>\n";

      foreach ( $inst->messages['en'] as $m )
        echo "<tr><td width=50% bgcolor=#efefef><i>$m</i></td>"
             ."<td align=center bgcolor=#ffefef>&nbsp;=&gt;&nbsp;</td>"
             ."<td width=50% bgcolor=#ffffef>" . _T($m) . "</td></tr>\n";

      echo "</table>\n";
      echo "<br>\n";
    }

    Trans::SetLanguage($old_lang);

    //
    // positional parameters test
    //

    $samples = array(
                      array( 'The numbers are ^1, ^2 and ^3', array('one','two','three') ),
                      array( 'Little boys like ^2 and little girls like ^1 ...', array('dolls','cars') ),
                      array( '... and when they become older, ^1 like ^2 and ^2 like ^1', array('boys','girls') )
                    );

    echo "<table bgcolor=#999999 cellspacing=1 cellpadding=2 width=100%>\n";
    echo "<tr><td colspan=3 align=center><font color=white><b>Postional Parameters</b></font></td></tr>\n";

    foreach ( $samples as $s )
    {
      $m = $s[0];

      list ( $p1, $p2, $p3 ) = $s[1];

      echo "<tr><td width=50% bgcolor=#efefef><i>$m</i></td>"
           ."<td align=center bgcolor=#ffefef>&nbsp;=&gt;&nbsp;</td>"
           ."<td width=50% bgcolor=#ffffef>" . _T($m,$p1,$p2,$p3) . "</td></tr>\n";
    }

    echo "</table>\n";
    echo "<br>\n";

    Trans::SetLanguage('xyz');
  }
}

// a shorthand for Trans::Translate()

//function _T($e,$p1=null,$p2=null,$p3=null) { return Trans::Translate($e,$p1,$p2,$p3); }

// a test run

//Trans::Dump();

//--> new words

?>
